#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "tinet_app_config.h"
#include "DDNS_IP.h"
#include "util.h"

extern const char *itron_strerror (ER ercd);

static volatile unsigned int ddns_interval  = 1000*60*25;	// Dynamic DNS IPXV


UB tcp_ddns_cep_sbuf[TCP_DDNS_CEP_SBUF_SIZE];
UB tcp_ddns_cep_rbuf[TCP_DDNS_CEP_RBUF_SIZE];

/*
 *  !!
 *  BUF_SIZE  TCP 
 *  MEChEobt@TCY + MEChEobt@TCY
 *  傫Ȃ΁AfbhbN\B
 */

#define SVR_BUF_SIZE	((TCP_DDNS_CEP_SBUF_SIZE+TCP_DDNS_CEP_SBUF_SIZE) * 3 / 2)

static B ddns_domain[32];
static B ddns_passwd[16];

//tO
static UB flag = 0;

void initDDNS(B *domain, B *passwd){
	UB i;

	for(i=0; (i<sizeof(ddns_domain)-1) && (domain[i]!='\0') ; i++){
		ddns_domain[i] = domain[i];
	}
	ddns_domain[i] = '\0';

	for(i=0; (i<sizeof(ddns_passwd)-1) && (passwd[i]!='\0') ; i++){
		ddns_passwd[i] = passwd[i];
	}
	ddns_passwd[i] = '\0';

	flag = 1;
}



extern T_IN4_ADDR  ipv4_addr;

/*


ƂāATCPʐM̂߂̐lĂB

*/
void
tcp_ddns_reflesh_task (ID cepid)
{
	while(TRUE){
		refleshIPAddr(cepid);
		dly_tsk(ddns_interval);
	}
}

/*
0ȊOԂ


*/
int refleshIPAddr(ID cepid){
//	static UB addr[sizeof("123.123.123.123")];
	UB	buf[SVR_BUF_SIZE];
	int	rlen, total;
	T_IPV4EP myaddr;
	T_IPV4EP dstaddr;
	ER	error = E_OK;

	// ĂȂꍇɂ̓G[
	if(! flag ) return 0;

	myaddr.ipaddr  = ipv4_addr;
	myaddr.portno  = 10000;

	dstaddr.ipaddr = MAKE_IPV4_ADDR(219,166,120,226);	/* free.ddo.jp (219.166.120.226) */
	dstaddr.portno = 80;					/* WWW port */
	

	// ڑv(\I[v)
	if ((error=tcp_con_cep(cepid, &myaddr, &dstaddr, 10000)) != E_OK) {
		syslog(LOG_NOTICE, "[TCP DDNS] error: %s", itron_strerror(error));
		if ((error = tcp_sht_cep((INT)cepid)) != E_OK)
			syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

		if ((error = tcp_cls_cep((INT)cepid, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));

		return 0;
	}
	
	syslog(LOG_NOTICE, "[TCP DDNS] Dynamic DNS reflesh: Domain=%s",ddns_domain);
	
	sprintf(buf, "GET /dnsupdate.php?dn=%s&pw=%s HTTP/1.1\r\n"  \
	             "Host: free.ddo.jp\r\n"                        \
	             "Accept: */*\r\n\r\n", ddns_domain, ddns_passwd);
	
	rlen = strlen(buf);
	if( (total = send_data(cepid, buf, rlen)) <= 0 ){
		return 0;
	}
	
	while(TRUE){
		if ((rlen = tcp_rcv_dat(cepid, buf, SVR_BUF_SIZE - 2, 7000)) <= 0) {
			if (rlen != E_OK)
				syslog(LOG_NOTICE, "[TCP SRV RCV] error: %s", itron_strerror(rlen));
			goto err_fin;
		}
		buf[rlen]='\0';
		syslog(LOG_NOTICE, "[TCP SRV RCV] Message: \n%s", buf);
	}

err_fin:
	if ((error = tcp_sht_cep((INT)cepid)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep((INT)cepid, TMO_FEVR)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));

	syslog(LOG_NOTICE, "[TCP SRV FIN] finished, total len: %d", total);

	return total;
}


