#include "plugin.h"
#include "3069S.H"


#define TIMEZONE	(-9*60*60)				// GMT ̐̕b

#define MAX_PATH_LENGTH	255


H readline(UB *buf, UH length){
	H res=0, len=0;
	B echo = 0;
	char *c;

	if( (c=get_env("ECHO")) != 0 ){
		if( *c == '1' ) echo = 1;
	}

	while( (length-1 > 0) && (res = scan(buf, 1)) > 0 ){

		if( *buf == 0xff ){
			// 2 oCg
			if( (res = scan(buf, 1)) < 0 ) break;

			if( *buf == 250 ){		// SB
				// TuIvVlSVG[V
				while( *buf != 240 ){
					if( (res = scan(buf, 1)) < 0 ) goto exit;
				}
			}else{
				// 3 oCg
				if( (res = scan(buf, 1)) < 0 ) break;
			}

			continue;
		}

		// back space ̏
		if( *buf == 0x08 ){
			if( len == 0 ) continue;
			
			len--; length++; *buf--;
			
			print("\b \b");	// backspace ' ' backspace

			continue;
		}

		if( echo ){
			print2(buf, 1);
			if( *buf == '\r' ){
				print2("\n", 1);
			}
		}

		if( *buf == '\n' ){  continue; }
		if( *buf == 0    ){  continue; }	// NUL (Ȃ)

		len++; length--;

		if( *buf++ == '\r' ) break;
	}

	exit:

	if (res < 0){
		return -1;
	}

	*buf = '\0';	// ^[~l[g

	return len;
}

int split_cmd(char *buf, char **cmd, char **arg1, char **arg2, char **arg3, char **arg4, char **arg5){
	char **dim[6] = {cmd , arg1, arg2, arg3, arg4, arg5};
	B i;
	
	*cmd = *arg1 = *arg2 = *arg3 = *arg4 = *arg5 = 0;


	for(i=0; i<6; i++){
		*(dim[i]) = buf;
		for( ; *buf!='\0'; buf++){
			switch(*buf){
				case ' ' : 
				case '\t': 
				case '\r': 
				case '\n': goto spacing;
				default  : break;
			}
		}
		spacing:

		for( ; *buf!='\0'; buf++){
			switch(*buf){
				case ' ' : 
				case '\t': 
				case '\r': 
				case '\n': *buf='\0'; break;
				default  : goto next_step;
			}
		}
		next_step:
		if( *buf == '\0' ) return i;
	}

	return i-1;
}

void print_prompt(void){
	char *c;

	c=get_env("PWD");

	if( c == 0 ){
		print("/");
	}else{
		print(c);
	}
	print("> ");
}

void mix_path(char *org, char *mix){
	UH i, j, tmp;


	i = strlen(org);

	if( *mix == '/' ){
		i = 0;
	}else{
		// fBNg̖ '/' (pwd̖'/'ȂAroot)
		if(i!=1) org[i++] = '/';
	}

	while(!(*mix == '\0')){
		if( *mix == '.' && (*(mix+1)=='/' || *(mix+1)=='\0') ){
			mix+=1;
			if(*mix == '/') mix+=1;
		}else if( *mix == '.' && *(mix+1) == '.' && (*(mix+2)=='/' || *(mix+2)=='\0') ){
			mix+=2;
			if(*mix == '/') mix+=1;

			if( i != 1 ){
				tmp = 0;
				for(j=0; j<i-1; j++) tmp = (org[j]=='/') ? j : tmp;
				i = tmp+1;	// Ō / ͎c
			}
		}else{
			org[i++] = *mix++;
		}
	}
	if(i!=1 && org[i-1] == '/'){
		org[i-1] = '\0';
	}else{
		org[i] = '\0';
	}

}

B chdir(char *cd){
	DIR *dir;
	UH i;

	UB tpwd[MAX_PATH_LENGTH+1];

	char *c = get_env("PWD");

	if( c != 0 ){
		for(i=0; c[i]!='\0'; i++) tpwd[i] = c[i];
		tpwd[i] = '\0';
	}else{
		i = 1;
		tpwd[0] = '/';
		tpwd[i] = '\0';
	}

	mix_path(tpwd, cd);

	// ړ̃fBNg݂邩mF
	if( 0 != (dir = opendir(tpwd)) ){
		set_env("PWD", tpwd);

		closedir(dir);
	}

	return 1;
}
B ls(char *path){
	DIR    *dir;
	dirent *entry;
	struct stat st;
	int i;

	UB buf[128];

	if( 0 == (dir = opendir(path)) ){
		return -1;
	}

	i=0;
	while( 0 != (entry = readdir(dir)) ){
		sprintf(buf, "%s/%s",
			(*path=='/' && *(path+1)=='\0') ? "" : (char *)path, entry->d_name);

		stat(buf, &st);

		sprintf(buf,"%14s", entry->d_name );	// t@C
		print(buf);

		i++;
		if( i % 4 == 0 ) print("\r\n");
	}
	if( i % 4 != 0 ) print("\r\n");

	closedir(dir);

	return 1;
}

B ls_la(char *path){
	DIR    *dir;
	dirent *entry;
	struct stat st;
	struct tm   tmc, tmn;
	time_t ntime;

	UB buf[128];

	char* month[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };

	if( 0 == (dir = opendir(path)) ){
		return -1;
	}

	while( 0 != (entry = readdir(dir)) ){
		sprintf(buf, "%s/%s",
			(*path=='/' && *(path+1)=='\0') ? "" : (char *)path, entry->d_name);

		if( stat(buf, &st) < 0 ){
			sprintf(buf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %4d %s\r\n",
				(entry->attr&0x10) ? 'd' : '-',
				(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
				(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
				(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
				0,			// t@CTCY
				"Apr",			// 
				1,			// 
				2000,			//  ()
				entry->d_name );	// t@C
		}else{
			st.st_mtime -= TIMEZONE;
			gmtime_r((time_t *)&(st.st_mtime), &tmc);
			
			ntime = time() - TIMEZONE;
			gmtime_r(&ntime, &tmn);

			if(tmc.tm_year != tmn.tm_year){
				sprintf(buf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %4d %s\r\n",
					(entry->attr&0x10) ? 'd' : '-',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					st.st_size,		// t@CTCY
					month[tmc.tm_mon],	// 
					tmc.tm_mday,		// 
					1900+tmc.tm_year,	//  ()
					entry->d_name );	// t@C
			}else{
				sprintf(buf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %2d:%02d %s\r\n",
					(entry->attr&0x10) ? 'd' : '-',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					st.st_size,		// t@CTCY
					month[tmc.tm_mon],	// 
					tmc.tm_mday,		// 
					tmc.tm_hour,		// 
					tmc.tm_min,		// 
					entry->d_name );	// t@C
			}
		}

		print(buf);
	}

	closedir(dir);

	return 1;
}


int main(int argc, char **argv){
	B buf[64];
	B out_buf[64];
	char *argv2[6];
	UH args,i;
	UW exec_buf[20*1024/4];
	UB exec_file[MAX_PATH_LENGTH+5];
	W res;


	for(print_prompt(); readline(buf, sizeof(buf)-1 ) >=0; print_prompt()){
		args = split_cmd(buf, &(argv2[0]), &(argv2[1]), &(argv2[2]), &(argv2[3]), &(argv2[4]), &(argv2[5]) );
		
		if( *argv2[0] == '\0' ) continue;		// ŝ݂̏ꍇ

/*
		sprintf(out_buf, "\n%d args \r\n", args);
		print(out_buf);

		for(i=0; i<=args; i++){
			sprintf(out_buf, "ard%d: %d\r\n", i, argv2[i]);
			print(out_buf);
		}

		for(i=0; i<=args; i++){
			sprintf(out_buf, "ard%d: %s\r\n", i, argv2[i]);
			print(out_buf);
		}
*/

		if( !strcmp(argv2[0], "exit") ){
			print("exit...\r\n");
			break;
		}else if( !strcmp(argv2[0], "time") ){
			UW tim = time() - TIMEZONE;
			ctime_r(&tim, out_buf);

			print(out_buf);
			print("\r\n");
		}else if( !strcmp(argv2[0], "!echo") ){
			char *c;
			if( (c=get_env("ECHO")) != 0 ){
				if( *c == '1' ) set_env("ECHO", "0");
				else            set_env("ECHO", "1");

				c = get_env("ECHO");
				sprintf(out_buf, "echo : %s\r\n", *c==1 ? "on" : "off");

				print(out_buf);
			}
		}else if( !strcmp(argv2[0], "pwd") ){
			char *c = get_env("PWD");

			if( c != 0 ) print(c);
			print("\r\n");
		}else if( !strcmp(argv2[0], "cd") ){
			if( args == 1 ){
				chdir(argv2[1]);
			}else if( args == 0 ){
				chdir("/");
			}else{
				errprint("too many args\r\n");
			}
		}else if( !strcmp(argv2[0], "ls") ){
			UB mode = 0;
			UB *p   = 0;

			for(i=1; i<=args; i++){
				if( *argv2[i] == '-' ){
					while( *++argv2[i] != '\0' ){
						switch( *argv2[i] ){
						case 'l': mode = 1; break;
						case 'a': mode = 1; break;
						default:  mode = 250; break;
						}
					}
				}else{
					p = argv2[i];
				}
			}
			if( p == 0 ){
				p = get_env("PWD");
				if(p==0) p = "/";
			}
			switch(mode){
			case 0:  ls(p);     break;
			case 1:  ls_la(p);  break;
			default: errprint("too many args\r\n\r\n");
			}
		}else{
			if( exec(argv2[0], (UB *)exec_buf, sizeof(exec_buf), 0, args+1, argv2, &res) < 0 ){
				sprintf(exec_file, "/bin");
				mix_path(exec_file, argv2[0]);

				if( exec(exec_file, (UB *)exec_buf, sizeof(exec_buf), 0, args+1, argv2, &res) < 0 ){
					i = strlen(exec_file);
					exec_file[i++]='.'; exec_file[i++]='e'; exec_file[i++]='x'; exec_file[i++]='e'; exec_file[i]='\0';

					if( exec(exec_file, (UB *)exec_buf, sizeof(exec_buf), 0, args+1, argv2, &res) < 0 ){
						print("command not found\r\n\r\n");
						continue;
					}
				}
			}
			sprintf(out_buf, "\r\n res= %d\r\n\r\n", res);

			print(out_buf);
		}
	}

	return 0;
}


