#include "plugin.h"
#include "3069S.H"

#include "data/svgheader.h"

#define TIMEZONE	(-9*60*60)				// GMT ÿ



void mix_path(char *org, char *mix){
	UH i, j, tmp;


	i = strlen(org);

	if( *mix == '/' ){
		i = 0;
	}else{
		// ǥ쥯ȥ '/' Ĥ(pwd'/'ʤroot)
		if(i!=1) org[i++] = '/';
	}

	while(!(*mix == '\0')){
		if( *mix == '.' && (*(mix+1)=='/' || *(mix+1)=='\0') ){
			mix+=1;
			if(*mix == '/') mix+=1;
		}else if( *mix == '.' && *(mix+1) == '.' && (*(mix+2)=='/' || *(mix+2)=='\0') ){
			mix+=2;
			if(*mix == '/') mix+=1;

			if( i != 1 ){
				tmp = 0;
				for(j=0; j<i-1; j++) tmp = (org[j]=='/') ? j : tmp;
				i = tmp+1;	// Ǹ / ϻĤ
			}
		}else{
			org[i++] = *mix++;
		}
	}
	if(i!=1 && org[i-1] == '/'){
		org[i-1] = '\0';
	}else{
		org[i] = '\0';
	}

}

UW begin_time(struct tm ntm, UW tim, UW dbef){
	
	tim -= ntm.tm_sec;
	tim -= ntm.tm_min * 60;
	tim -= ntm.tm_hour * 60 * 60;

	tim -= dbef * 24 * 60 * 60;

	return tim;
}

#define bufflush(fd)	bufwrite(fd, 0, 0)

UB bufwrite(B fd, UB *dat, H size){
	static H  len=0, i;
	static UB buf[1024];
	
	if( dat == 0 ){
		write(fd, buf, len);
		len = 0;

		return 0;
	}
	
	
	for(i=0; i != size; i++){
		if( len == sizeof(buf) ){
			len = 0;
			write(fd, buf, sizeof(buf));
		}
		buf[len++] = dat[i];
	}

	return size;
}

UB readbyte(B fd, B *dat){
	static UB buf[1024];
	static H pos = 0;	// buf ǤǤĹ
	static H nrd = 0;	// buf ͭǡĹ

	if( pos >= nrd ){
		nrd = read(fd, buf, sizeof(buf));
		pos = 0;
	}

	if( pos >= nrd ) return 0;

	*dat = buf[pos++];

	return 1;
}


UH readline(B fd, char *buf, UH length){
	UH i;

	for(i=0; i<length-1; i++){
		if(0 == readbyte(fd, buf+i)) return 0;

		if( buf[i] == '\n' ) break;
	}

	buf[i] = '\0';

	return i;
}

int main(int argc, char **argv){
	B fd_src;
	B fd_dest;
	char buf[512];
	char fname[15];
	char *c;

	UW tim;
	struct tm res;
	W day = 1;
	W item = 0;

	if( argc < 2 ){
		errprint("Usage: ");
		errprint(argv[0]);
		errprint(" (source file) \r\n");
	}

restart:

	// ǽоݤΤϤλ()
	tim = time() - TIMEZONE;
	gmtime_r(&tim, &res);
	tim += TIMEZONE;
	tim = begin_time(res, tim, day);

	// оݤ
	tim -= TIMEZONE;
	gmtime_r(&tim, &res);
	tim += TIMEZONE;

	c = get_env("PWD");
	sprintf(buf, "%s", c==0 ? "/" : c);
	mix_path(buf, argv[1]);
	if( (fd_src=open(buf, O_RDONLY)) < 0 ) return 2;

	sprintf(fname, "T%02d%02d%02d.svg", (res.tm_year+1900)%100, res.tm_mon+1, res.tm_mday);
	sprintf(buf, "%s", c==0 ? "/" : c);
	mix_path(buf, fname);
	if( (fd_dest = open(buf, O_RDONLY)) >= 0 ){
		close(fd_src);
		close(fd_dest);
		day ++; goto restart;
	}
	if( (fd_dest=creat(buf, 0777)) < 0 ) return 2;

	// SVG Υإå񤭹
	bufwrite(fd_dest, svg_graph_header, sizeof(svg_graph_header) - 1);

	// 󥽡ȥեоݤ񤭹
	sprintf(buf, "<text x= \"660\" y=\"80\" font-family=\"Verdana\" font-size=\"20\" fill=\"black\">%d/%d/%d</text>\n",
		res.tm_year+1900, res.tm_mon+1, res.tm_mday);
	bufwrite(fd_dest, buf, strlen(buf));

	sprintf(buf,"%dǯ %d %d %d:%d \r\n",
		res.tm_year+1900, res.tm_mon+1, res.tm_mday, res.tm_hour, res.tm_min, res.tm_sec);
	print(buf);

	item = 0;
	while( readline( fd_src, buf, sizeof(buf) - 1) != 0){
		UW rtim;
		W dat;
		
		sscanf(buf, "%d %d", &rtim, &dat);
		
		if( rtim >= tim && rtim < tim + 24*60*60 ){
			item++;
			sprintf(buf, "<circle cx=\"%d\" cy=\"%d\" r=\"1\" fill=\"red\" stroke=\"red\" />\n",
				(rtim-tim)/60, -dat/10);
			bufwrite(fd_dest, buf, strlen(buf));
		}
	}

	// եνü񤭹
	sprintf(buf, "</svg>\n\n");
	bufwrite(fd_dest, buf, strlen(buf));

	bufflush(fd_dest);

	close(fd_src);
	close(fd_dest);

	sprintf(buf,"%d ĤǤ񤭹ߤޤ \r\n", item);
	print(buf);

	if( item != 0 ){
		day ++;
		goto restart;
	}

	sprintf(fname, "T%02d%02d%02d.svg", (res.tm_year+1900)%100, res.tm_mon+1, res.tm_mday);
	sprintf(buf, "%s", c==0 ? "/" : c);
	mix_path(buf, fname);
	unlink(buf);

	sprintf(buf,"%s ޤ \r\n", buf);
	print(buf);


	return 0;
}

