
#ifdef NOT_ITRON

/*
-------------------------------------------------------------------------------
                not ITRON ł̐ݒ(n܂)
-------------------------------------------------------------------------------
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h> 
#include <stdio.h>
#include <stdarg.h> 

typedef int8_t		B;
typedef uint8_t		UB;
typedef int16_t		H;
typedef uint16_t	UH;
typedef int32_t		W;
typedef uint32_t	UW;


#define LOG_NOTICE 	0
#define COFFLOAD_SEM	0

void wai_sem(int n){ ; }
void sig_sem(int n){ ; }

void syslog(B hoge, char *fmt, ...) {
        va_list ap;

        va_start(ap, fmt);

	vprintf(fmt, ap);

        va_end(ap);
}

/*
-------------------------------------------------------------------------------
                not ITRON ł̐ݒ()
-------------------------------------------------------------------------------
*/

#else
/*
-------------------------------------------------------------------------------
                    ITRON ł̐ݒ(n܂)
-------------------------------------------------------------------------------
*/

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include <string.h>
#include <stdio.h>

#include "fat_api.h"
#include "3069S.h"


/*
-------------------------------------------------------------------------------
                    ITRON ł̐ݒ(I)
-------------------------------------------------------------------------------
*/
#endif


#include "coffload.h"

/*
[h̃LbV
(1-way ZbgEA\VAeBu(_CNg}bv))
*/
static UB coffload_cache_dataary [COFFLOAD_CACHE_TAG][COFFLOAD_CACHE_LINE];
static W  coffload_cache_tagarray[COFFLOAD_CACHE_TAG];	// -1 Ȃ疳


struct ftable{
	char *name;		// V{
	void *addr;		// AhX
};

static struct ftable func_table[FUNC_TABLE_SIZE];
static UB n_func = 0;					// o^ꂽ֐̐

/*
	COFF t@Cwb_[
	20oCg
*/
#define SIZEOF_FILE_HEADER		20

struct coff_filehdr{
	UH magic;
	UH n_section;
	UW time;
	UW p_symtable;
	UW n_symtable;
	UH opthdr;
	UH flags;
};

/*
	COFF ZNVwb_
	40oCg
*/
#define SIZEOF_SECTION_HEADER		40

struct coff_sectionhdr{
	B name[8];
	UW phyaddr;
	UW vaddr;
	UW size;
	UW p_section;
	UW p_relocation;
	UW p_line;
	UH n_relocation;
	UH n_line;
	UW flags;
};

/*
4 x 3 + 2 + 2 = 12+4 = 16 
*/
#define SIZEOF_RELOCATION_ITEM		16

struct coff_relocation{
	UW addr;
	UW symbol_idx;
	UW offset;
	UH type;
	UH stuff;
};


/*
8+4+2+2+1+1 = 18
*/
#define SIZEOF_SYMBOL_ITEM		18

struct coff_symbol{
	union{
		B name[8];
		struct{
			UW zeroes;
			UW offset;
		} e;
	}e;
	UW value;
	H  section;
	UH type;
	UB strageclass;
	UB numaux;
};


W  cached_read(UB fd, UB *buf, W count){
	W pos = lseek(fd, 0, SEEK_CUR);
	
	// C܂Ƃ̓LbVgȂ
	if( (pos>>COFFLOAD_CACHE_BIT_LINE) == ((pos+count)>>COFFLOAD_CACHE_BIT_LINE) ){
		UH i;
		UB sft = COFFLOAD_CACHE_BIT_LINE + COFFLOAD_CACHE_BIT_TAG;
		UH idx = pos>>COFFLOAD_CACHE_BIT_LINE;
		idx = idx & (COFFLOAD_CACHE_TAG-1);

		if( coffload_cache_tagarray[idx] != (pos >> sft) ){
			coffload_cache_tagarray[idx] = pos >> sft;
			lseek(fd, pos - (pos&(COFFLOAD_CACHE_LINE-1)), SEEK_SET);
			read(fd, coffload_cache_dataary[idx], COFFLOAD_CACHE_LINE);
			lseek(fd, pos, SEEK_SET);
		}

		for(i=0; i<count; i++){
			buf[i] = coffload_cache_dataary[idx][(i+pos)&(COFFLOAD_CACHE_LINE-1)];
		}
		lseek(fd, count, SEEK_CUR);

		return count;
	}else{
		return read(fd, buf, count);
	}
}

void printCoffFileHeader(struct coff_filehdr *hdr){
	syslog(LOG_NOTICE, "COFF File Header:\n");
	syslog(LOG_NOTICE, "\t magic number: 0x%x\n",               hdr->magic     );
	syslog(LOG_NOTICE, "\t number of section: %d\n",            hdr->n_section );
	syslog(LOG_NOTICE, "\t time stump: %d\n",                   hdr->time      );
	syslog(LOG_NOTICE, "\t pointer to symboltable: 0x%x\n",     hdr->p_symtable);
	syslog(LOG_NOTICE, "\t number of symboltable entry: %d\n",  hdr->n_symtable);
	syslog(LOG_NOTICE, "\t sizeof option header: %d\n",         hdr->opthdr    );
	syslog(LOG_NOTICE, "\t flags: 0x%x\n",                      hdr->flags     );
}


void printCoffSectionHeader(struct coff_sectionhdr *hdr){
	syslog(LOG_NOTICE, "COFF Section Header:\n");
	syslog(LOG_NOTICE, "\t section name: %s\n",               hdr->name        );
	syslog(LOG_NOTICE, "\t physical address: 0x%x\n",         hdr->phyaddr     );
	syslog(LOG_NOTICE, "\t virtual address : 0x%x\n",         hdr->vaddr       );
	syslog(LOG_NOTICE, "\t size : %d\n",                      hdr->size        );
	syslog(LOG_NOTICE, "\t pointer to section    : 0x%x\n",   hdr->p_section   );
	syslog(LOG_NOTICE, "\t pointer to relocation : 0x%x\n",   hdr->p_relocation);
	syslog(LOG_NOTICE, "\t pointer to line number: 0x%x\n",   hdr->p_line      );
	syslog(LOG_NOTICE, "\t number of relocation  : %d\n",     hdr->n_relocation);
	syslog(LOG_NOTICE, "\t number of line number : %d\n",     hdr->n_line      );
	syslog(LOG_NOTICE, "\t flags : 0x%x\n",                   hdr->flags       );
}

void printCoffRelocation(struct coff_relocation *reloc){
	syslog(LOG_NOTICE, "COFF Relocation:\n");
	syslog(LOG_NOTICE, "\t Addr        : 0x%d\n",         reloc->addr      );
	syslog(LOG_NOTICE, "\t Symbol index: 0x%x\n",         reloc->symbol_idx);
	syslog(LOG_NOTICE, "\t offset      : 0x%x\n",         reloc->offset    );
	syslog(LOG_NOTICE, "\t type        : 0x%x\n",         reloc->type      );
	syslog(LOG_NOTICE, "\t stuff       : 0x%x\n",         reloc->stuff     );
}

void printCoffSymbol(struct coff_symbol *sym){
	syslog(LOG_NOTICE, "COFF Symbol:\n");
	if(sym->e.e.zeroes != 0){
		syslog(LOG_NOTICE, "\t Name        : %s\n",         sym->e.name      );
	}else{
		syslog(LOG_NOTICE, "\t Name        : @0x%d\n",      sym->e.e.offset  );
	}
	syslog(LOG_NOTICE, "\t value       : 0x%x\n",         sym->value       );
	syslog(LOG_NOTICE, "\t section     : 0x%x\n",         sym->section     );
	syslog(LOG_NOTICE, "\t type        : 0x%x\n",         sym->type        );
	syslog(LOG_NOTICE, "\t strageclass : 0x%x\n",         sym->strageclass );
	syslog(LOG_NOTICE, "\t numaux      : 0x%x\n",         sym->numaux      );
}


B readCoffFileHeader(B fd, struct coff_filehdr *hdr){
	UB buf[20];
	
	cached_read(fd, buf, sizeof(buf));
	
	hdr->magic     = (buf[ 0]<< 8) | (buf[ 1]);
	hdr->n_section = (buf[ 2]<< 8) | (buf[ 3]);
	hdr->time      = (buf[ 4]<<24) | (buf[ 5]<<16) | (buf[ 6]<< 8) | buf[ 7];
	hdr->p_symtable= (buf[ 8]<<24) | (buf[ 9]<<16) | (buf[10]<< 8) | buf[11];
	hdr->n_symtable= (buf[12]<<24) | (buf[13]<<16) | (buf[14]<< 8) | buf[15];
	hdr->opthdr    = (buf[16]<< 8) | (buf[17]);
	hdr->flags     = (buf[18]<< 8) | (buf[19]);
	
	return 0;
}

B readCoffSectionHeader(B fd, struct coff_sectionhdr *hdr){
	UB buf[40];
	
	cached_read(fd, buf, sizeof(buf));
	
	hdr->name[0]=buf[0]; hdr->name[1]=buf[1]; hdr->name[2]=buf[2]; hdr->name[3]=buf[3];
	hdr->name[4]=buf[4]; hdr->name[5]=buf[5]; hdr->name[6]=buf[6]; hdr->name[7]=buf[7];

	hdr->phyaddr      = (buf[ 8]<<24) | (buf[ 9]<<16) | (buf[10]<< 8) | buf[11];
	hdr->vaddr        = (buf[12]<<24) | (buf[13]<<16) | (buf[14]<< 8) | buf[15];
	hdr->size         = (buf[16]<<24) | (buf[17]<<16) | (buf[18]<< 8) | buf[19];
	hdr->p_section    = (buf[20]<<24) | (buf[21]<<16) | (buf[22]<< 8) | buf[23];
	hdr->p_relocation = (buf[24]<<24) | (buf[25]<<16) | (buf[26]<< 8) | buf[27];
	hdr->p_line       = (buf[28]<<24) | (buf[29]<<16) | (buf[30]<< 8) | buf[31];
	hdr->n_relocation = (buf[32]<< 8) | (buf[33]);
	hdr->n_line       = (buf[34]<< 8) | (buf[35]);
	hdr->p_line       = (buf[36]<<24) | (buf[37]<<16) | (buf[38]<< 8) | buf[39];

	return 0;
}

B readCoffRelocation(B fd, struct coff_relocation *reloc){
	UB  buf[16];

	cached_read(fd, buf, sizeof(buf));

	reloc->addr       = (buf[ 0]<<24) | (buf[ 1]<<16) | (buf[ 2]<< 8) | buf[ 3];
	reloc->symbol_idx = (buf[ 4]<<24) | (buf[ 5]<<16) | (buf[ 6]<< 8) | buf[ 7];
	reloc->offset     = (buf[ 8]<<24) | (buf[ 9]<<16) | (buf[10]<< 8) | buf[11];
	reloc->type       = (buf[12]<< 8) | (buf[13]);
	reloc->stuff      = (buf[14]<< 8) | (buf[15]);

	return 0;
}

B readCoffSymbol(B fd, struct coff_symbol *sym){
	UB  buf[18];

	cached_read(fd, buf, sizeof(buf));


	if( buf[0] != 0 ){
		sym->e.name[0]=buf[0]; sym->e.name[1]=buf[1]; sym->e.name[2]=buf[2]; sym->e.name[3]=buf[3];
		sym->e.name[4]=buf[4]; sym->e.name[5]=buf[5]; sym->e.name[6]=buf[6]; sym->e.name[7]=buf[7];
	}else{
		sym->e.e.zeroes = 0;
		sym->e.e.offset = (buf[ 4]<<24) | (buf[ 5]<<16) | (buf[ 6]<< 8) | buf[ 7];
	}

	sym->value      = (buf[ 8]<<24) | (buf[ 9]<<16) | (buf[10]<< 8) | buf[11];
	sym->section    = (buf[12]<< 8) | (buf[13]);
	sym->type       = (buf[14]<< 8) | (buf[15]);
	sym->strageclass=  buf[16];
	sym->numaux     =  buf[17];

	return 0;
}

/*


MAX_FUNCNAME_LENGTH 𒴂(蒷)֐͓o^łȂB

߂l:
	sꍇɂ -1 ߂B
	MAX_FUNCNAME_LENGTH 𒴂钷̊֐o^ꍇB
	FUNC_TABLE_SIZE 𒴂̊֐o^ꍇB
*/
B addLinkFunction(char *name, void *addr){

	if( n_func >= FUNC_TABLE_SIZE ){
		return -1;
	}

	UB length = strlen(name);
	if( length > MAX_FUNCNAME_LENGTH ){
		return -1;
	}

	func_table[n_func].name   = name;
	func_table[n_func].addr   = addr;
	n_func++;

	return 0;
}

/*

߂l:
	sƂ 0 ߂
*/
void *lookupFunction(char *name){
	UB i;

	for(i=0; i < n_func; i++){
		// Xs[hグ邽
		if( name[1] != func_table[i].name[1] ) continue;

		if(! strncmp(name, func_table[i].name, MAX_FUNCNAME_LENGTH+1) )
			return func_table[i].addr;
	}

	return 0;
}

B fix_relocation(UB fd, UB *buf, UW offset, struct coff_filehdr filehdr, struct coff_sectionhdr hdr ){
//	struct coff_sectionhdr text_hdr;

	struct coff_relocation reloc;
	struct coff_symbol sym;
	int i;
//	int size;
	UW  coffset, addr;
	UB symstr[MAX_FUNCNAME_LENGTH+1], tmp;


	for(i=0; i<hdr.n_relocation; i++ ){

		lseek(fd, hdr.p_relocation + i*SIZEOF_RELOCATION_ITEM , SEEK_SET);
		readCoffRelocation(fd, &reloc);

//		printCoffRelocation(&reloc);
		
		coffset = offset;

		if( reloc.symbol_idx != 0xffffffff ){
			lseek(fd, filehdr.p_symtable + reloc.symbol_idx*SIZEOF_SYMBOL_ITEM , SEEK_SET);
			readCoffSymbol(fd, &sym);


			/*
				`̃V{΃N
			*/
			if( sym.section == 0 ){		// V{̑ĂZNV0 (== undef)

				// `̃V{i[郁̈NA
				for( tmp = 0; tmp <= MAX_FUNCNAME_LENGTH; tmp++) symstr[tmp] = '\0';
				
				// `̃V{ǂݏo
				if( sym.e.e.zeroes == 0 ){
					// 9ȏ̏ꍇ
					// String table  Symbol table ̌ɑ݂
					lseek( fd,
					       filehdr.p_symtable + 
					       filehdr.n_symtable * SIZEOF_SYMBOL_ITEM + 
					       sym.e.e.offset, 
					       SEEK_SET);

					cached_read (fd, symstr, MAX_FUNCNAME_LENGTH);
				}else{
					// 8 ̏ꍇ
					for( tmp = 0; tmp < 8; tmp++) symstr[tmp] = sym.e.name[tmp];
				}

				if( (addr = (UW)lookupFunction(symstr)) != 0){
					sym.value = addr;
					syslog(LOG_NOTICE, "link , %s 0x%x\n", symstr, sym.value);
				}else{
					syslog(LOG_NOTICE, "linking error %s %d 0x%x 0x%x  (line %d)\n", symstr, sym.section, sym.type, sym.strageclass, __LINE__);
					return -1;
				}

				/*
					{̃vOƃNƂ́A
					ItZbg𑫂킹KvȂ
				*/
				coffset = 0;
			}else if( sym.section == -1 ){	/* Absolute symbol */
			
			
				coffset = 0;
			}
		}else{
			sym.value = 0;
			sym.e.name[0] = '\0';
			coffset = 0;
		}
		
		
		
		
#ifdef NOT_ITRON
		syslog(LOG_NOTICE, "prog addr: @ 0x%x -> 0x%x offset 0x%x type: 0x%x (%s) \n", 
			reloc.addr, sym.value, reloc.offset, reloc.type, (sym.e.e.zeroes == 0) ? "" : sym.e.name);
#endif
		
		if( reloc.type == 17 ){			// R_RELLONG
			buf[reloc.addr + 0] = 0xff&((coffset+sym.value+reloc.offset)>>24);
			buf[reloc.addr + 1] = 0xff&((coffset+sym.value+reloc.offset)>>16);
			buf[reloc.addr + 2] = 0xff&((coffset+sym.value+reloc.offset)>> 8);
			buf[reloc.addr + 3] = 0xff&((coffset+sym.value+reloc.offset)>> 0);

		}else if( reloc.type == 18 ){		// R_PCRBYTE
			buf[reloc.addr + 0] = sym.value - reloc.addr + reloc.offset;

		}else if( reloc.type == 19 ){		// R_PCRWORD
			buf[reloc.addr + 0] = 0xff&((sym.value - (reloc.addr+1) + reloc.offset )>>8);	// 16 bitȂ̂reloc.addr1炵ČvZKv炵
			buf[reloc.addr + 1] = 0xff&((sym.value - (reloc.addr+1) + reloc.offset )>>0);

		}else if( reloc.type == 0x46){		// R_JMPL1
			/*
				24 bit target address with jmp inst
				\Ȃ bra + pc  8 bit ɕύX
			*/
			buf[reloc.addr + 1] = 0xff&((coffset+sym.value+reloc.offset)>>16);
			buf[reloc.addr + 2] = 0xff&((coffset+sym.value+reloc.offset)>> 8);
			buf[reloc.addr + 3] = 0xff&((coffset+sym.value+reloc.offset)>> 0);

		}else if( reloc.type == 0x48){		// R_MOV24B1
			/*
				0x48 : R_MOV24B1
					24 bit absolute address IyhƂ mov.b
					\Ȃ absolute 8 bit address ɕύX
			*/
			buf[reloc.addr + 1] = 0xff&((coffset+sym.value+reloc.offset)>>16);
			buf[reloc.addr + 2] = 0xff&((coffset+sym.value+reloc.offset)>> 8);
			buf[reloc.addr + 3] = 0xff&((coffset+sym.value+reloc.offset)>> 0);
		}else if( reloc.type == 0x4c){		// R_MOVL1
			/*
				0x4c : R_MOVL1
					32/24 bit absolute address IyhƂ mov.[wl] 
					ꍇɂĂ absolute 16 bit address ɕύX
			*/
			buf[reloc.addr + 0] = 0xff&((coffset+sym.value+reloc.offset)>>24);
			buf[reloc.addr + 1] = 0xff&((coffset+sym.value+reloc.offset)>>16);
			buf[reloc.addr + 2] = 0xff&((coffset+sym.value+reloc.offset)>> 8);
			buf[reloc.addr + 3] = 0xff&((coffset+sym.value+reloc.offset)>> 0);

		}else{
			syslog(LOG_NOTICE, "reloc type error %d", reloc.type);
			return -1;
		}
	}

	return 0;
}

B loadCoff(UB fd, UB *buf, UW bufsize, UW offset, UW *binsize){
	struct coff_filehdr filehdr;
	struct coff_sectionhdr sectionhdr;

	struct coff_sectionhdr text_hdr;
	struct coff_sectionhdr data_hdr;
	struct coff_sectionhdr bss_hdr;
	
//	struct coff_relocation reloc;
//	struct coff_symbol sym;
	
	int i;
//	int size;
//	UW  coffset, addr;
//	UB  tmp;
	
	// LbV̓Ƃ邽
	wai_sem(COFFLOAD_SEM);
	
	// LbV
	lseek(fd, 0, SEEK_SET);
	for(i=0; i< COFFLOAD_CACHE_TAG; i++){
		coffload_cache_tagarray[i] = -1;
	}
	
	readCoffFileHeader(fd, &filehdr);
	printCoffFileHeader(&filehdr);
	
	lseek(fd, SIZEOF_FILE_HEADER + filehdr.opthdr, SEEK_SET);
	
	
	for(i=0; i<filehdr.n_section; i++ ){
		readCoffSectionHeader(fd, &sectionhdr);

		if(! strncmp(sectionhdr.name, ".text", 6))      text_hdr = sectionhdr;
		else if(! strncmp(sectionhdr.name, ".data", 6)) data_hdr = sectionhdr;
		else if(! strncmp(sectionhdr.name, ".bss" , 5)) bss_hdr  = sectionhdr;
		else{
			if( sectionhdr.size == 0 ){
#ifdef NOT_ITRON
				syslog(LOG_NOTICE, "Section \"%s\" ignored\n", sectionhdr.name);
#endif
			}else{
#ifdef NOT_ITRON
				syslog(LOG_NOTICE, "Error: Section \"%s\" can't ignore\n", sectionhdr.name);
#endif
				goto err_exit;
			}
			continue;
		}

#ifdef NOT_ITRON
		printCoffSectionHeader(&sectionhdr);
#endif
	}
	
	if( text_hdr.vaddr != 0 ){
#ifdef NOT_ITRON
		syslog(LOG_NOTICE, "Error: text section addr is not 0\n");
#endif
		goto err_exit;
	}
	if( bufsize < (text_hdr.vaddr + text_hdr.size) ){
#ifdef NOT_ITRON
		syslog(LOG_NOTICE, "Error: text section size too large\n");
#endif
		goto err_exit;
	}
	if( bufsize < (data_hdr.vaddr + data_hdr.size) ){
#ifdef NOT_ITRON
		syslog(LOG_NOTICE, "Error: data section size too large\n");
#endif
		goto err_exit;
	}
	if( bufsize < (bss_hdr.vaddr  + bss_hdr.size ) ){
#ifdef NOT_ITRON
		syslog(LOG_NOTICE, "Error: bss section size too large\n");
#endif
		goto err_exit;
	}
	
	lseek(fd, text_hdr.p_section, SEEK_SET); cached_read(fd, buf               , text_hdr.size);
	lseek(fd, data_hdr.p_section, SEEK_SET); cached_read(fd, buf+data_hdr.vaddr, data_hdr.size);
/*
	lseek(fd, bss_hdr .p_section, SEEK_SET); cached_read(fd, buf+bss_hdr.vaddr , bss_hdr .size);
*/
	for(i=0;i<bss_hdr.size;i++) *(buf+bss_hdr.vaddr+i) = 0;
	
	*binsize = text_hdr.vaddr + text_hdr.size;
	if( *binsize < data_hdr.vaddr + data_hdr.size ) *binsize = data_hdr.vaddr + data_hdr.size;
	if( *binsize < bss_hdr .vaddr + bss_hdr .size ) *binsize = bss_hdr .vaddr + bss_hdr .size;
	
	if( fix_relocation(fd, buf, offset, filehdr, text_hdr ) < 0) goto err_exit;
	if( fix_relocation(fd, buf, offset, filehdr, data_hdr ) < 0) goto err_exit;
	if( fix_relocation(fd, buf, offset, filehdr,  bss_hdr ) < 0) goto err_exit;

	sig_sem(COFFLOAD_SEM);
	return 0;

err_exit:
	
	sig_sem(COFFLOAD_SEM);
	return -1;
}

int caller(int (* func)(int, char **), int argc, char **argv){
	return (*func)(argc, argv);
}


#ifdef NOT_ITRON
int main(int argc, char **argv){
	UB buf[1024*10];
	int fd1, fd2;
	UW binsize;

	if( argc < 3 ){
		syslog(LOG_NOTICE, "Usgae: %s filename outname \n\n", argv[0]);
		exit(1);
	}
	
	fd1 = open(argv[1], O_RDWR );
	fd2 = creat(argv[2], 0744 );
	
	
	if( fd1 < 0 || fd2 < 0){
		syslog(LOG_NOTICE, "Can't open file\n\n");
		exit(1);
	}
	
	

	addLinkFunction("_syslog" ,        0x100);
	addLinkFunction("_send_data",      0x101);
	addLinkFunction("_get_cgi_value",  0x102);

	addLinkFunction("_open" ,     0x200);
	addLinkFunction("_creat",     0x201);
	addLinkFunction("_unlink",    0x202);
	addLinkFunction("_close",     0x203);
	addLinkFunction("_read" ,     0x204);
	addLinkFunction("_write",     0x205);
	addLinkFunction("_lseek",     0x206);

	addLinkFunction("_opendir",   0x300);
	addLinkFunction("_readdir",   0x301);
	addLinkFunction("_closedir",  0x302);
	
	addLinkFunction("_stat" ,  0x400);
	addLinkFunction("_fstat",  0x401);


	addLinkFunction("_Sprintf", 0x500);
	addLinkFunction("_Sscanf",  0x501);
	addLinkFunction("_Ctime_r", 0x502);
	addLinkFunction("_Time",    0x503);
	addLinkFunction("_Strlen",  0x504);
	addLinkFunction("_Strcmp",  0x505);
	addLinkFunction("_Strncmp", 0x506);

	if( loadCoff(fd1, buf, sizeof(buf), 0x10000, &binsize) >= 0 ){
		write(fd2, buf, binsize);
	}
	
	
	close( fd1 );
	close( fd2 );

	return 0;
}

#endif
