#include "../sysinfo/src/incl/plugin.h"
#include "../sysinfo/src/incl/3069S.H"

#define MAX_VOLUME	0x05		// ق傫
#define MIN_VOLUME	0x80		

#define REM_PORT	((UB *)(0xFFFFD9))

#define SCK		2
#define DO		1
#define DI		0
#define CS		3

/*
 dcode |  button    dcode |  button   
-------+---------  -------+---------  
 0xef  |     1      0xf7  |   d    
 0xee  |     2            |           
 0xed  |     3      0xfd  |   Vol +   
 0xec  |     4      0xfc  |   Vol -   
 0xeb  |     5            |           
-----------------   0xff  |   Ch +    
 0xea  |     6      0xfe  |   Ch -    
 0xe9  |     7            |           
 0xe8  |     8      0xf6  |   Mute    
 0xe7  |     9            |           
 0xe6  |    10      0x53  | 3   
-----------------         |           
 0xe5  |    11      0xf5  | ͐ؑ  
 0xe4  |    12            |           
                    0xe1  |Off timer  
*/

#define KEY_1		0xef
#define KEY_2		0xee
#define KEY_3		0xed
#define KEY_4		0xec
#define KEY_5		0xeb
#define KEY_6		0xea
#define KEY_7		0xe9
#define KEY_8		0xe8
#define KEY_9		0xe7
#define KEY_10		0xe6
#define KEY_11		0xe5
#define KEY_12		0xe4

#define KEY_POWER	0xf7
#define KEY_VolUp	0xfd
#define KEY_VolDn	0xfc
#define KEY_ChUp	0xff
#define KEY_ChDn	0xfe
#define KEY_Mute	0xf6
#define KEY_3DInput	0x53
#define KEY_Src		0xf5
#define KEY_OffTimer	0xe1


/*
 * rbgNA
 */
static inline void
bitclr (UB *addr, UB bit)
{
    __asm__ volatile("bclr %1l, @%0" : : "r"(addr), "r"(bit));
}

/*
 * rbgZbg
 */
static inline void
bitset (UB *addr, UB bit)
{
    __asm__ volatile("bset %1l, @%0" : : "r"(addr), "r"(bit));
}

UB spi2_receive(void){
	UB i, res = 0;

	bitset(REM_PORT, DI);
	for( i=(1<<7); i != 0; i = (i>>1) ){
		bitclr(REM_PORT, SCK);			// L
		bitset(REM_PORT, SCK);			// H

		if( PADR.BYTE & (1<<DO) ) res |= i;	// L->H Ŏ荞
	}
	bitclr(REM_PORT, SCK);				// L

	return res;
}

void spi2_transmit(UB dat){
	UB i;

	for( i=(1<<7); i!=0; i=(i>>1) ){
		if(dat & i){
			bitset(REM_PORT, DI);
		}else{
			bitclr(REM_PORT, DI);
		}
		bitclr(REM_PORT, SCK);			// L
		bitset(REM_PORT, SCK);			// H
	}

	bitclr(REM_PORT, SCK);				// L
}



int main(int argc, char **argv){
	UW ipn, vol;
	UB dcode;
	char buf[10];

	PADDR = 0xf0 | (1<<DI) | (1<<SCK) | (1<<CS);

	bitset(REM_PORT, DI);
	bitset(REM_PORT, CS);
	bitclr(REM_PORT, SCK);


	// cs = 0
	bitclr(REM_PORT, CS);

	// RM@qĂȂ́AȂ
	spi2_transmit(0x00);
	if( spi2_receive() != 0xaa ){
		return 0;
	}


	spi2_transmit(0x01);
	dcode = spi2_receive();

	bitset(REM_PORT, CS);

	if( dcode == 0 ) return 0;

	sprintf(buf, " %d", dcode);
	print  (buf);

	switch( dcode ){
		case KEY_1: 
			// S K Y . F M - Mostly Classical - Listen and Relax, it's good for you! www.sky.fm 
			getipbyname("scfire-nyk0l-1.stream.aol.com", &ipn);
			vs1011e_play_shoutcast(ipn, 80, "/stream/1006");
			break;
		case KEY_2:
			// S K Y . F M - Smooth Jazz - the world's smoothest jazz 24 hours a day
			ipn = (64<<24) | (236<<16) | (99<<8) | 41;
			vs1011e_play_shoutcast(ipn, 80, "/stream/1010");
			break;
		case KEY_7: 
			//  k a w a i i - r a d i o | sr1 anime/japanese radio
			// 70.85.176.230:8000/
			ipn = (70<<24) | (85<<16) | (176<<8) | 230;
			vs1011e_play_shoutcast(ipn, 8000, "/");
			break;
		case KEY_10: 
			// 
			vs1011e_autoplay("/mp3");
			break;
		case KEY_VolUp:
			// volume up
			vol = -5 + (vs1011e_getVolume()&0xff);

			if( vol < MAX_VOLUME ) vol = MAX_VOLUME;
			if( vol > MIN_VOLUME ) vol = MIN_VOLUME;

			vs1011e_setVolume( vol | (vol<<8) );
			break;
		case KEY_VolDn:
			// volume down
			vol = 5 + (vs1011e_getVolume()&0xff);

			if( vol < MAX_VOLUME ) vol = MAX_VOLUME;
			if( vol > MIN_VOLUME ) vol = MIN_VOLUME;

			vs1011e_setVolume( vol | (vol<<8) );
			break;
		case KEY_Mute: 
			// mute 
			vs1011e_pause();
			break;
		case KEY_ChUp:
			// ch + 
			vs1011e_skip();
			break;
		case KEY_ChDn:
			// ch - 
			vs1011e_stop();
			break;
	}

	return 0;
}


