#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "fat_api.h"
#include "3069S.h"
#include "na2.h"
#include "webserver.h"
#include "telnet.h"
#include "util.h"


#include "coffload.h"
#include "exec.h"


#define N_EXEC_SIZE	(N_WWW_TASK+N_MAX_DAEMON+N_TELNET_TASK)

/*

task ID 0ɂ͂ȂȂ̂ŁȀꍇ0ł킷B

*/
UW                 pid_ary[N_EXEC_SIZE];
struct program_io  pio_ary[N_EXEC_SIZE];


UW		envid_ary[N_EXEC_SIZE];
struct env	*env_ary[N_EXEC_SIZE];


UB exec_init(void){
	UH i;

	for(i=0; i<N_EXEC_SIZE; i++){
		pid_ary[i] = 0;
	}

	for(i=0; i<N_EXEC_SIZE; i++){
		envid_ary[i] = 0;
	}

	return 0;
}

/*
	file	: svÕt@C

	buf	: vOi[̃
	bufsize : vOi[̗̈
	
	pio	: W/Wo/WG[o͂w
	
	argc	: ̐
	argv	: 

	res	: vOs̖߂l

߂l
	0ȏ   : 
	0	: s

*/
W exec(char *file, UB *buf, UW bufsiz, struct program_io *pio, int argc, char **argv, int *res){
	B fd;
	W tmp;
	
	if( (fd = open(file, O_RDONLY)) < 0 ) return -1;

	if( loadCoff(fd, buf, bufsiz, (UW)buf, &tmp) < 0 ){
		close(fd);
		return -2;
	}

	tmp = exec2(buf, pio, argc, argv, res);
	
	close(fd);

	return tmp;
}

W exec2(UB *buf, struct program_io *pio, int argc, char **argv, int *res){
	H i=-1;
	W tid;

	struct program_io bpio;
	UB bpio_enable = 0;

	get_tid(&tid);

	if( pio != NULL ){
		for(i=0; i<N_EXEC_SIZE; i++){
			if( pid_ary[i] != tid ) continue;

			// ---------------------------------
			// pid_arg ݂̓h
			wai_sem(EXEC_SEM);

			bpio_enable = 1;
			bpio        = pio_ary[i];

			pid_ary[i] = tid;
			pio_ary[i] = *pio;

			sig_sem(EXEC_SEM);
			// ---------------------------------

			break;
		}
		if(i>=N_EXEC_SIZE){
			for(i=0; i<N_EXEC_SIZE; i++){
				if( pid_ary[i] != 0 ) continue;

				// ---------------------------------
				// pid_arg ݂̓h
				wai_sem(EXEC_SEM);

				pid_ary[i] = tid;
				pio_ary[i] = *pio;

				sig_sem(EXEC_SEM);
				// ---------------------------------
	
				break;
			}
			if(i>=N_EXEC_SIZE) return -1;
		}
	}
	
	
	// buf̂͂߂̃[hɃX^[gʒũItZbgi[Ă
	*res = caller( (int (*)(int, char **))( ((UB *)buf) + *((UW *)buf)), argc, argv);

	// ̓Z}tH̕ی͂Ȃ
	if( i >= 0 ){
		if( bpio_enable == 1 ){
			pio_ary[i] = bpio;
		}else{
			pid_ary[i] = 0;
		}
	}

	return 0;
}

W exec_print(B *buf){
	return exec_print2(buf, strlen(buf));
}

W exec_print2(B *buf, W len){
	W tid, res=-1;
	UH i;
	B tmp;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++) if(tid==pid_ary[i]) break;
	
	if(i==N_EXEC_SIZE || pio_ary[i].io_mux_out == EXEC_IO_SERIAL ){
		tmp = buf[len];
		syslog(LOG_NOTICE,"%s",buf);
		buf[len] = tmp;

		res = len;
	}else if(pio_ary[i].io_mux_out == EXEC_IO_FILE){
		res = write(pio_ary[i].std_out, buf, len);
	}else if(pio_ary[i].io_mux_out == EXEC_IO_NETWORK){
		res = send_data(pio_ary[i].std_out, buf, len);
	}else{
		tmp = buf[len];
		syslog(LOG_NOTICE,"%s",buf);
		buf[len] = tmp;

		res = len;
	}

	return res;
}

W exec_errprint(B *buf){
	return exec_errprint2(buf, strlen(buf));
}

W exec_errprint2(B *buf, W len){
	W tid, res=-1;
	UH i;
	B tmp;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++) if(tid==pid_ary[i]) break;
	
	if(i==N_EXEC_SIZE || pio_ary[i].io_mux_err == EXEC_IO_SERIAL ){
		tmp = buf[len];
		syslog(LOG_NOTICE,"%s",buf);
		buf[len] = tmp;

		res = len;
	}else if(pio_ary[i].io_mux_err == EXEC_IO_FILE){
		res = write(pio_ary[i].std_err, buf, len);
	}else if(pio_ary[i].io_mux_err == EXEC_IO_NETWORK){
		res = send_data(pio_ary[i].std_err, buf, len);
	}else{
		tmp = buf[len];
		syslog(LOG_NOTICE,"%s",buf);
		buf[len] = tmp;

		res = len;
	}

	return res;
}

W exec_scan(B *buf, W len){
	return exec_scan_tmout(buf, len, TMO_FEVR);
}

W exec_scan_tmout(B *buf, W len, W tmo){
	W tid, res=-1;
	UH i;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++) if(tid==pid_ary[i]) break;
	
	if(i==N_EXEC_SIZE || pio_ary[i].io_mux_in == EXEC_IO_SERIAL ){

		res = -1;

	}else if(pio_ary[i].io_mux_in == EXEC_IO_FILE){

		res = read(pio_ary[i].std_in, buf, len);

	}else if(pio_ary[i].io_mux_in == EXEC_IO_NETWORK){

		res = tcp_rcv_dat(pio_ary[i].std_in, buf, len, tmo);

	}else{
		res = -1;
	}

	return res;
}



B     install_env(struct env *e){
	H i;
	W tid;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++){
		if( envid_ary[i] != tid ) continue;

		// ---------------------------------
		// pid_arg ݂̓h
		wai_sem(EXEC_SEM);

		envid_ary[i] = tid;
		env_ary[i] = e;

		sig_sem(EXEC_SEM);
		// ---------------------------------

		break;
	}
	if( i < N_EXEC_SIZE ) return 0;

	for(i=0; i<N_EXEC_SIZE; i++){
		if( envid_ary[i] != 0 ) continue;

		// ---------------------------------
		// pid_arg ݂̓h
		wai_sem(EXEC_SEM);

		get_tid(&tid);
		envid_ary[i] = tid;
		env_ary[i] = e;

		sig_sem(EXEC_SEM);
		// ---------------------------------

		break;
	}

	if(i>=N_EXEC_SIZE) return -1;

	return 0;
}

char *get_env(char *name){
	W tid;
	UH i,j;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++) if(tid==envid_ary[i]) break;

	if( i == N_EXEC_SIZE ) return NULL;

	for(j=0; (env_ary[i])[j].name != NULL; j++){
		if( ! strcmp((env_ary[i])[j].name, name) ){
			return (env_ary[i])[j].val;
		}
	}

	return NULL;
}

B     set_env(char *name, char *val){
	W tid;
	UH i,j;
	UH len;

	get_tid(&tid);

	for(i=0; i<N_EXEC_SIZE; i++) if(tid==envid_ary[i]) break;


	for(j=0; (env_ary[i])[j].name != NULL; j++){
		if( ! strcmp((env_ary[i])[j].name, name) ){
			len = strlen(val)+1;
			len = (len > (env_ary[i])[j].maxvalsize) ? (env_ary[i])[j].maxvalsize : len;
			memmove((env_ary[i])[j].val, val, len);
			(env_ary[i])[j].val[len-1] = '\0';

			return 1;
		}
	}

	return -1;
}

