#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fataccs.h"
#include "fatdatatype.h"
#include "fat16.h"
#include "mmc_access.h"
#include "mmc_config.h"



/***************************************************

	FAT ANZX֐

FAT̓LbVOB
݂̂ƂACgX[ŎĂ
(FAT̏ݎɂ́AMMCɂ݂ɍsB
ǂ̎_œd؂ĂAݒłȂΕs͋NȂ)

Z}tHł̕ی삪Kv

****************************************************/

extern UB FAT_cache[];
extern W  FAT_cache_sec;


extern UW firstSectorNumbers;
extern UW bytePerSec;
extern UW secPerCluster;
extern UW secPerFAT;
extern UW nFAT;
extern UW reservedSector;
extern UW totalSector;
extern UW totalCluster;


/*
ŗ^ꂽNX^̎̃NX^ԂB

sƂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~
*/
UW fat16_lookup_nextcluster(UW cluster){
	W  asec_FAT;
	UW res;

	if(cluster >= totalCluster+2){
		return 1;
	}

	asec_FAT = firstSectorNumbers + reservedSector + ((cluster<<1)>>9);

	if( FAT_cache_sec != asec_FAT ){
		FAT_cache_sec = asec_FAT;
		if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
			// FAT ̓ǂݎɎsꍇ
			flush_FATcache();
			return 1;
		}
	}

	res = FAT_cache[ (cluster*2)&0x01ff ] | (FAT_cache[ ((cluster*2)&0x01ff)+1 ]<<8);

//	syslog(LOG_NOTICE, "FAT 0x%x", res);

	return res;
}


B fat16_freeClusterChain(UW cluster){
	UW tmp;
	W  asec_FAT;
	B  k;

restart:
	if(cluster >= 0xfff8 || cluster >= totalCluster+2 || cluster<=2){
		return 0;
	}

	asec_FAT = firstSectorNumbers + reservedSector + ((cluster<<1)>>9);

	if( FAT_cache_sec != asec_FAT ){
		FAT_cache_sec = asec_FAT;
		if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
			// FAT ̓ǂݎɎsꍇ
			flush_FATcache();
			return -1;
		}
	}

	tmp = cluster;
	cluster = FAT_cache[ (cluster*2)&0x01ff ] | (FAT_cache[ ((cluster*2)&0x01ff)+1 ]<<8);

	FAT_cache[  (tmp*2)&0x01ff    ] = 0;
	FAT_cache[ ((tmp*2)&0x01ff)+1 ] = 0;

	for(k=0; k<nFAT; k++){
		if( 0 != mmc_write( FAT_cache_sec + secPerFAT*k , FAT_cache)) return -1;
	}

	goto restart;
}

/*
ŗ^ꂽNX^ŌNX^ɂB

*/
B fat16_terminateCluster(UW cluster){
	B  k;
	W  asec_FAT;

	if(cluster >= 0xfff8){
		return 0;
	}

	asec_FAT = firstSectorNumbers + reservedSector + ((cluster<<1)>>9);

	if( FAT_cache_sec != asec_FAT ){
		FAT_cache_sec = asec_FAT;
		if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
			// FAT ̓ǂݎɎsꍇ
			flush_FATcache();
			return -1;
		}
	}

	FAT_cache[  (cluster*2)&0x01ff    ] = 0xff;
	FAT_cache[ ((cluster*2)&0x01ff)+1 ] = 0xff;

	for(k=0; k<nFAT; k++){
		if( 0 != mmc_write( FAT_cache_sec + secPerFAT*k , FAT_cache)) return -1;
	}

	return 0;
}

/*
ŗ^ꂽNX^́ÃNX^mۂA
`FCB

Ƃ 0 ^ꂽꍇɂ́A擪̃NX^mۂB
NX^̊mۂɎsꍇɂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ꍇɂ͊mۂ̃NX^Ԃ
*/
UW fat16_alloc_nextcluster(UW cluster){
	W  asec_FAT, fat;
	UW i;
	B  k;

	for(i=2; i<totalCluster+2; i++){
		asec_FAT = firstSectorNumbers + reservedSector + ((i<<1)>>9);

		if( FAT_cache_sec != asec_FAT ){
			FAT_cache_sec = asec_FAT;
			if( 0 != mmc_read( FAT_cache_sec , FAT_cache) ){
				// FAT ̓ǂݎɎsꍇ
				flush_FATcache();
				return 1;
			}
		}

		fat = FAT_cache[ (i*2)&0x01ff ] | (FAT_cache[ ((i*2)&0x01ff)+1 ]<<8);
		
		if( fat == 0x00 ){
			// I[̃}[NB
			FAT_cache[  (i*2)&0x01ff    ] = 0xff;
			FAT_cache[ ((i*2)&0x01ff)+1 ] = 0xff;
			
			for(k=0; k<nFAT; k++){
				if( 0 != mmc_write( FAT_cache_sec + secPerFAT*k , FAT_cache)) return 1;
			}

			break;
		}
	}
	// NX^Ȃꍇ
	if( i == totalCluster+2 ) return 1;

	// `FC(܂ł̍ŌAVmۂNX^ւ̃N)
	if(cluster != 0){
		asec_FAT = firstSectorNumbers + reservedSector + ((cluster<<1)>>9);

		if( FAT_cache_sec != asec_FAT ){
			FAT_cache_sec = asec_FAT;
			if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
				flush_FATcache();
				return 1;
			}
		}
		FAT_cache[  (cluster*2)&0x01ff    ] =  i    &0xff;
		FAT_cache[ ((cluster*2)&0x01ff)+1 ] = (i>>8)&0xff;

		for(k=0; k<nFAT; k++){
			if(0 != mmc_write( FAT_cache_sec + secPerFAT*k , FAT_cache)) return 1;
		}
	}

	return i;
}
/****************************************************
	FAT ANZX֐܂
****************************************************/

