#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fataccs.h"
#include "fatdatatype.h"
#include "fat32.h"
#include "mmc_access.h"
#include "mmc_config.h"



/***************************************************

	FAT ANZX֐

FAT̓LbVOB
݂̂ƂACgX[ŎĂ
(FAT̏ݎɂ́AMMCɂ݂ɍsB
ǂ̎_œd؂ĂAݒłȂΕs͋NȂ)

Z}tHł̕ی삪Kv

****************************************************/

extern UB FAT_cache[];
extern W  FAT_cache_sec;


extern UW firstSectorNumbers;
extern UW bytePerSec;
extern UW secPerCluster;
extern UW secPerFAT;
extern UW nFAT;
extern UW reservedSector;
extern UW totalSector;
extern UW totalCluster;


/*
ŗ^ꂽNX^̎̃NX^ԂB

sƂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~
*/
UW fat32_lookup_nextcluster(UW cluster){
	W  asec_FAT;
	UW res;
	UW offset;

	if(cluster >= totalCluster+2){
		return 1;
	}

	offset   = cluster<<2;
	asec_FAT = firstSectorNumbers + reservedSector + (offset>>9);
	offset   = offset & 0x1ff;

	if( FAT_cache_sec != asec_FAT ){
		FAT_cache_sec = asec_FAT;
		if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
			// FAT ̓ǂݎɎsꍇ
			flush_FATcache();
			return 1;
		}
	}

	res = FAT_cache[offset] | (FAT_cache[offset+1]<<8) | (FAT_cache[offset+2]<<16) | (FAT_cache[offset+3]<<24);

//	syslog(LOG_NOTICE, "FAT 0x%x", res);

	return res;
}

B fat32_set_nextcluster(UW cluster, UW val){
	UW offset;
	W  asec_FAT;
	B  k;

	offset   = cluster<<2;
	asec_FAT = firstSectorNumbers + reservedSector + (offset>>9);
	offset   = offset & 0x1ff;

	if( FAT_cache_sec != asec_FAT ){
		FAT_cache_sec = asec_FAT;
		if( 0 != mmc_read( FAT_cache_sec , FAT_cache)){
			// FAT ̓ǂݎɎsꍇ
			flush_FATcache();
			return -1;
		}
	}

	FAT_cache[offset  ] =  val     &0xff;
	FAT_cache[offset+1] = (val>> 8)&0xff;
	FAT_cache[offset+2] = (val>>16)&0xff;
	FAT_cache[offset+3] = (val>>24)&0xff;

	for(k=0; k<nFAT; k++){
		if( 0 != mmc_write( FAT_cache_sec + secPerFAT*k , FAT_cache)) return -1;
	}

	return 0;
}
/*
ŗ^ꂽNX^̎̃NX^ԂB

*/
B fat32_freeClusterChain(UW cluster){
	UW tmp;

restart:
	if(cluster >= 0x0ffffff8 || cluster >= totalCluster+2 || cluster<2){
		return 0;
	}

	if( 1 == (tmp = fat32_lookup_nextcluster(cluster))) return -1;
	if( 0 != fat32_set_nextcluster(cluster, 0)) return -1;

	cluster = tmp;

	goto restart;
}

/*
ŗ^ꂽNX^ŌNX^ɂB

*/
B fat32_terminateCluster(UW cluster){

	if(cluster >= 0x0ffffff8){
		return 0;
	}

	return fat32_set_nextcluster(cluster, 0x0fffffff);
}

/*
ŗ^ꂽNX^́ÃNX^mۂA
`FCB

Ƃ 0 ^ꂽꍇɂ́A擪̃NX^mۂB
NX^̊mۂɎsꍇɂ1Ԃ
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
ꍇɂ͊mۂ̃NX^Ԃ
*/
UW fat32_alloc_nextcluster(UW cluster){
	UW i=0;

	for(i=2; i<totalCluster+2; i++){
		if( fat32_lookup_nextcluster(i) == 0 ) break;
	}

	// NX^Ȃꍇ
	if( i == totalCluster+2 ) return 1;

	if( 0 != fat32_set_nextcluster(      i, 0x0fffffff)) return 1;
	if( cluster != 0 ){
		if( 0 != fat32_set_nextcluster(cluster,          i)) return 1;
	}

	return i;
}
/****************************************************
	FAT ANZX֐܂
****************************************************/

