#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdir.h"
#include "fatbase.h"
#include "mmc_access.h"



extern UW secPerCluster;

/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;

/*
writeSector, readSector ̃G[mFɗL
*/
#define CHECK_IO(x)	if( 0 != x ){ syslog(LOG_NOTICE,"mkdir:%d: i/o error", __LINE__); goto err_exit; }



/*
:
	pathname : fBNg
	mode     : fBNg̑ݒ肷
	           0777 ȂUNIXł̃ANZX̃[hwB
	           ł user ̎ŵݎQƂB܂A
	           0733 ł 0700 ̕QƂăt@C̑肷B
	           
	           r (0400) : HIDDEN tO
	           w (0200) : READ_ONLY tO
	           x (0100) : FATɑΉ鑮Ȃ

 0 s -1 

*/
B mkdir(const char *pathname, UH mode){

	DirEntryPos filepos, parentpos;
	UB attr, buf[512];
	UW cluster, pcluster;
	B ret = -1;
	UH i;

	if(*pathname=='/') pathname++;
	
	// pX̌
	// (쐬fBNgɂt@CApX̐ɈȂ悤ɏ߂)
	// 擪'/'+1AfBNg؂蕶'/'ł+1
	if( strlen(pathname) + 1 + NAME_MAX + 1 > PATH_MAX ) return -1;

	wai_sem( FAT_SEM );

	// łɃfBNg݂ꍇ͎Ŏs
	if( lookUpDirEntry(pathname, LOOKUP_DIRENTRY_CREAT, buf, &filepos, &parentpos) < 0 ) goto err_exit;

	// ̃t@Cꍇ
	if( filepos.isValid ) goto err_exit;

	syslog(LOG_NOTICE, "mkdir:%d: directory allocated (DirEntry cluster:%d, sector:%d, offset:%d)", __LINE__, filepos.cluster, filepos.sector, filepos.offset);


	attr = ATTR_DIRECTORY;
	if(!(mode&0400)) attr |= 0x02;  // r (0400) : HIDDEN tO
	if(!(mode&0200)) attr |= 0x01;  // w (0200) : READ_ONLY tO

	// NX^̊mۂɎs
	if( 1 == (cluster = alloc_nextcluster(0)) ) goto err_exit;

	setDirectryEntry(
		(DirEntry *)&buf[filepos.offset<<5],	// fBNgGg
		DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		NULL,			// t@C	(t@ClookupDirEntryŐݒ肳)
		attr,			// Attribute 
		cluster,		// cluster
		0);			// Size

	CHECK_IO( writeSector(filepos.cluster, filepos.sector, buf) )

	//------------------------------------------------------------------------
	// fBNg̒g
	//------------------------------------------------------------------------
	for( i=0; i<512; i++ ) buf[i] = 0;
	for(i=1; i<secPerCluster; i++){ CHECK_IO( writeSector(cluster, i, buf) ) }

	// fBNg "."
	setDirectryEntry(
		(DirEntry *)&buf[0],	// fBNgGg
		DE_CHANGE_NAME | DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		".          ",		// t@C
		attr,			// Attribute 
		cluster,		// cluster
		0);			// Size

	CHECK_IO( writeSector(cluster, 0, buf) )
	//------------------------------------------------------------------------
	// ".." ̃Gg͂Ƃō
	//------------------------------------------------------------------------


	// t@CfBNgɂď݁EANZXXV
	// ȂƁAt@CWindowsXPŃA[JCu̃t@CɂȂ悤
	// [gfBNgł͕sKv
	if(parentpos.isValid){
		CHECK_IO( readSector(parentpos.cluster, parentpos.sector, buf) )

		setDirectryEntry(
			(DirEntry *)&buf[parentpos.offset<<5],		// fBNgGg
			DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,		// 
			NULL,			// t@C
			0,			// Attribute 
			0,			// cluster
			0);			// Size
		CHECK_IO( writeSector(parentpos.cluster, parentpos.sector, buf) )

		pcluster = getClusterAtDirEntry( (DirEntry *)&buf[(parentpos.offset<<5)] );
		attr     = getAttrAtDirEntry   ( (DirEntry *)&buf[(parentpos.offset<<5)] );
	}else{
		// [gfBNg
		pcluster = 0;
		attr     = ATTR_DIRECTORY;
	}

	//------------------------------------------------------------------------
	// fBNg ".."

	CHECK_IO( readSector(cluster, 0, buf) )
	setDirectryEntry(
		(DirEntry *)&buf[1<<5],	// fBNgGg
		DE_CHANGE_NAME | DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		"..         ",		// t@C
		attr,			// Attribute 
		pcluster,		// cluster
		0);			// Size

	CHECK_IO( writeSector(cluster, 0, buf) )
	//------------------------------------------------------------------------

	ret = 0;

err_exit:
	sig_sem( FAT_SEM );
	return ret;			// ret -1ŏĂ
}

