#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>
#include <netapp/netapp_var.h>

#include "fat_api.h"
#include "exec.h"
#include "vs1011e_app.h"

#include <string.h>
#include <stdio.h>

void mix_path(char *org, const char *mix){
	UH i, j, tmp;


	i = strlen(org);

	if( *mix == '/' ){
		i = 0;
	}else{
		// fBNg̖ '/' (pwd̖'/'ȂAroot)
		if(i!=1) org[i++] = '/';
	}

	while(!(*mix == '\0')){
		if( *mix == '.' && (*(mix+1)=='/' || *(mix+1)=='\0') ){
			mix+=1;
			if(*mix == '/') mix+=1;
		}else if( *mix == '.' && *(mix+1) == '.' && (*(mix+2)=='/' || *(mix+2)=='\0') ){
			mix+=2;
			if(*mix == '/') mix+=1;

			if( i != 1 ){
				tmp = 0;
				for(j=0; j<i-1; j++) tmp = (org[j]=='/') ? j : tmp;
				i = tmp+1;	// Ō / ͎c
			}
		}else{
			if( i > PATH_MAX ){
				org[i] = '\0'; return;
			}
			org[i++] = *mix++;
		}
	}
	if(i!=1 && org[i-1] == '/'){
		org[i-1] = '\0';
	}else{
		org[i] = '\0';
	}
}

char *abs_path(const char *ppath, char *abspath){
	char *c;

	c = get_env("PWD");
	sprintf(abspath, "%s", c==NULL ? "/" : c);
	
	mix_path(abspath, ppath);
	
	return abspath;
}




B  pwd_open (const char *pathname, W flags){
	char path[PATH_MAX+1];
	
	return open( abs_path(pathname, path), flags);
}

B  pwd_creat(const char *pathname, UH mode){
	char path[PATH_MAX+1];
	
	return creat( abs_path(pathname, path), mode);
}

B  pwd_unlink(const char *pathname){
	char path[PATH_MAX+1];
	
	return unlink( abs_path(pathname, path) );
}

DIR *pwd_opendir(const char *pathname){
	char path[PATH_MAX+1];
	
	return opendir( abs_path(pathname, path));
}

B pwd_rmdir(const char *pathname){
	char path[PATH_MAX+1];
	
	return rmdir( abs_path(pathname, path) );
}

B pwd_mkdir(const char *pathname, UH mode){
	char path[PATH_MAX+1];
	
	return mkdir( abs_path(pathname, path), mode);
}

B pwd_stat(const char *fname, struct stat *buf){
	char path[PATH_MAX+1];
	
	return stat( abs_path(fname, path), buf);
}


W pwd_vs1011e_play(char *fname){
	char path[PATH_MAX+1];
	
	return vs1011e_play( abs_path(fname, path) );
}
W pwd_vs1011e_autoplay(char *dir){
	char path[PATH_MAX+1];
	
	return vs1011e_autoplay( abs_path(dir, path) );
}

W pwd_exec(char *file, UB *buf, UW bufsiz, struct program_io *pio, int argc, char **argv, int *res){
	char path[PATH_MAX+1];
	
	return exec( abs_path(file, path), buf, bufsiz, pio, argc, argv, res);
}

