#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fat_api.h"
#include "fatdir.h"
#include "fatbase.h"
#include "mmc_access.h"



extern UW secPerCluster;

/*
mmc_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;

/*
fatdir.c Œ`
*/
extern DIR		DIRM[];


/*
writeSector, readSector ̃G[mFɗL
*/
#define CHECK_IO(x)	if( 0 != x ){ syslog(LOG_NOTICE,"rmdir:%d: i/o error", __LINE__); goto err_exit; }


/*
:
	pathname : 폜fBNg

  0
s -1 

*/
B rmdir(const char *pathname){

	DirEntryPos filepos, parentpos;
	UB buf[512], j, fname[12];
	UW cluster;
	B ret = -1, de_end;
	UH i, sector;

	if(*pathname=='/') pathname++;

	wai_sem( FAT_SEM );

	// fBNgEt@CT (ȂƃG[ƂȂ) 
	if( lookUpDirEntry(pathname, LOOKUP_DIRENTRY_FILEDIR, buf, &filepos, &parentpos) < 0 ) goto err_exit;

	// t@Cꍇ̓G[Ƃď
	if( getAttrAtDirEntry( (DirEntry *)&buf[filepos.offset<<5] ) != ATTR_DIRECTORY ) goto err_exit;


	cluster = getClusterAtDirEntry( (DirEntry *)&buf[filepos.offset<<5] );

	//--------------------------------------------------------------------
	// fBNgJĂA폜Ȃ
	for(i=0; i<N_DIR; i++){
		// gĂȂ DIR \̂𖳎
		if( DIRM[i].isValid <= 0 ) continue;

		if( DIRM[i].cluster == cluster ) goto err_exit;
	}

	//--------------------------------------------------------------------
	// t@C܂fBNgɎcĂꍇ̓fBNg폜łȂ
	sector = i = 0;
	do{
		// ̍s cluster, sector ̎QƐ悪1̃ZN^Ɉړ
		if( (de_end = readCluster(&cluster, &sector, buf)) < 0 ) goto err_exit;

		for(j=0; j<16; j++){
			// 󂾂ApĂȂt@C΂
			if( 0 == buf[(j<<5)] || 0x05 == buf[(j<<5)] || 0xe5 == buf[(j<<5)]) continue;

			i++;
		}
	}while(!de_end);

	if( i != 2 ) goto err_exit;	// "."  ".." ̕

	//--------------------------------------------------------------------
	// fBNgGgǂݏoAfBNgGg̍폜̐ݒ
	// (ŏɓǂݏofBNgGg̏(bufɊi[)͏Ă̂ŁA
	//  xǂݏo)

	CHECK_IO( readSector(filepos.cluster, filepos.sector, buf) )
	cluster = getClusterAtDirEntry( (DirEntry *)&buf[filepos.offset<<5] );

	if( freeClusterChain(cluster) != 0 ){
		syslog(LOG_NOTICE, "rmdir:%d: failed to free a cluster chain (started at %d)", __LINE__, cluster);
	}

	fname[0] = 0xe5;	// fBNgGg󂫂ɂ
	fname[1] = '\0';

	setDirectryEntry(
		(DirEntry *)&buf[filepos.offset<<5],	// fBNgGg
		DE_CHANGE_NAME | DE_CHANGE_ATTR | DE_CHANGE_CLUSTER | DE_CHANGE_SIZE |		// 
		DE_CHANGE_CRETIME | DE_CHANGE_ACCDATE | DE_CHANGE_WRITIME,
		fname,			// t@C	(폜)
		0,			// Attribute 
		0,			// cluster
		0);			// Size

	CHECK_IO( writeSector(filepos.cluster, filepos.sector, buf) )

	ret = 0;			// ߂l̐ݒ

err_exit:
	sig_sem( FAT_SEM );
	return ret;			// ret -1ŏĂ
}

