#include <s_services.h>
#include <t_services.h>
#include <time.h>
#include "kernel_id.h"

#include "fatbase.h"
#include "fatdesc.h"
#include "fatdir.h"
#include "mmc_io.h"
#include "mmc_access.h"


/*
mma_access.c Œ`

J[h̏(Ă邩? t@CVXeĂ邩? ̏)
*/
extern B card_status;


/*
----------------------------------------------------------------------

                    File System level I/O

----------------------------------------------------------------------
*/
UW firstSectorNumbers = 0;
UW bytePerSec    = 0;
UW secPerCluster = 0;
UW secPerFAT     = 0;
UW nFAT          = 0;
UW reservedSector= 0;
UW totalSector   = 0;
UW totalCluster  = 0;

UW rootDirEntrySector=0;
UW rootCluster   = 0;

UB FATSize       = 0;	// FAT12, FAT16, FAT32 ?


/*
t@CVXeǂݏ̏
512 byte̍ƗpƂė^KvB

Ώۂ́Ap[eBV0ŁAt@CVXeFATł邱ƂOƂB
łȂꍇɂ͓삪ۏłȂȂB
FATłȂƂ𔻕ʂꍇɂ̓G[ԂB

܂AFAT16łȂꍇɃG[ԂB


:
	tmp: Ɨp(512oCgȏ)

߂l: ɐꍇɂ 0
	sƂ -1

*/
B fsInit(UB *tmp){
	B  ret = 0;
	UW fsector, nsector;
	UH rootEntCnt=0;
	UH fatsz16=0;
	UW fatsz32=0;

	if( (card_status & MMC_CARD_NOTINSERTED) ||
	    (card_status & MMC_CARD_NOT_INIT) ){
		return -1;
	}


	if( 0 != mmc_read(0, tmp) ){
		// MMCǂݎȂ
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}

	// p[eBV0Ώۂɂ
	fsector = (tmp[446+11]<<24)|(tmp[446+10]<<16)|(tmp[446+ 9]<<8)|tmp[446+ 8];
	nsector = (tmp[446+15]<<24)|(tmp[446+14]<<16)|(tmp[446+13]<<8)|tmp[446+12];

	syslog(LOG_NOTICE, "     Partition 0"           );
	syslog(LOG_NOTICE, "        bootable         %d", tmp[446  ]);
	syslog(LOG_NOTICE, "        FS descripter    %d", tmp[446+4]);
	syslog(LOG_NOTICE, "        first sector     %d", fsector);
	syslog(LOG_NOTICE, "        number of sector %d", nsector);

	/*
		file system ̊mFKv
	*/
	if( tmp[510] != 0x55 || tmp[511] != 0xaa ){
		syslog(LOG_NOTICE, "Partition 0 is not a FAT File System");
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}

	if( fsector == 0 ){
		syslog(LOG_NOTICE, "Partition 0 is not allocated");
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}

	if( 0 != mmc_read(fsector, tmp) ){
		// MMCǂݎȂ
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}

	firstSectorNumbers = fsector;
	bytePerSec    = tmp[11] | (tmp[12]<<8);
	secPerCluster = tmp[13];

	fatsz16       = tmp[22] | (tmp[23]<<8);
	fatsz32       = tmp[36] | (tmp[37]<<8) | (tmp[38]<<16) | (tmp[39]<<24);
	secPerFAT     = (fatsz16==0) ? fatsz32 : fatsz16;

	nFAT          = tmp[16];
	rootEntCnt    = tmp[17] | (tmp[18]<<8);
	reservedSector= tmp[14] | (tmp[15]<<8);
	totalSector   = tmp[19] | (tmp[20]<<8);
	if( totalSector == 0 ) totalSector = tmp[32] | (tmp[33]<<8) | (tmp[34]<<16) | (tmp[35]<<24);

	rootDirEntrySector = ((rootEntCnt<<5) + (bytePerSec-1)) / bytePerSec;
	totalCluster = (totalSector - (reservedSector + nFAT*secPerFAT + rootDirEntrySector)) / secPerCluster;

	syslog(LOG_NOTICE, "        bytesPerSector    %d", bytePerSec);
	syslog(LOG_NOTICE, "        sectorsPerCluster %d", secPerCluster);
	syslog(LOG_NOTICE, "        sectorsPerFAT     %d", secPerFAT);
	syslog(LOG_NOTICE, "        numberOfFATs      %d", nFAT);
	syslog(LOG_NOTICE, "        rootEntCnt        %d", rootEntCnt);
	syslog(LOG_NOTICE, "        reservedSector    %d", reservedSector);
	syslog(LOG_NOTICE, "        totalSector       %d", totalSector);
	syslog(LOG_NOTICE, "        totalCluster      %d", totalCluster);

	if( bytePerSec != 512 ){
		syslog(LOG_NOTICE, "File System: Bytes Per Sector is not 512");
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}
	if( rootEntCnt != 512 && rootEntCnt != 0 ){
		syslog(LOG_NOTICE, "File System: RootEntry count is not 512");
		ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
	}

	/*
		Microsoft hardware white paper,
		"FAT: General overview of on-disk format," version 1.02, pp.13-14, May 1999.
		Q
	*/
	if(totalCluster < 4085){
		FATSize = 12;
		rootCluster = 0;
	}else if(totalCluster < 65525){
		FATSize = 16;
		rootCluster = 0;
	}else{
		FATSize = 32;
		rootCluster = tmp[44] | (tmp[45]<<8) | (tmp[46]<<16) | (tmp[47]<<24);

		syslog(LOG_NOTICE, "        rootCluster       %d", rootCluster);

		UH FSinfo = tmp[48] | (tmp[49]<<8);

		syslog(LOG_NOTICE, "        fsinfo            %d", FSinfo);

		if( 0 != mmc_read(fsector+FSinfo, tmp) ){
			// MMCǂݎȂ
			ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
		}

		tmp[488] = tmp[488+1] = tmp[488+2] = tmp[488+3] = 0xff;	// FSI_FreeCount
		tmp[492] = tmp[492+1] = tmp[492+2] = tmp[492+3] = 0xff; // FSI_Nxt_Free

		if( 0 != mmc_write(fsector+FSinfo, tmp) ){
			// MMC߂Ȃ
			ret = -1; card_status |= MMC_CARD_NOT_FSINIT; goto exit;
		}
	}
	syslog(LOG_NOTICE, "        FATSize           %d", FATSize);



	clearFD();		// fd    ׂ close (isValid  <= 0)
	clearVNODE();		// vnode ׂĊJ   ( refcount<= 0)
	clearDIR();		// DIRM  ׂ close (isValid  <= 0)

	flush_FATcache();	// FAT ̃LbV


	card_status &= (0xff - MMC_CARD_NOT_FSINIT);		// ŃNAĂ

exit:
	return ret;
}






/****************************************************

	FAT NX^AZN^ǂݏ֐


****************************************************/


/*
Ŏw肵NX^̃ZN^ǂݏoB

NX^ƂāA0w肵Ƃɂ́A
RootDirEntry ̎wZN^ǂݏoB

buf : 512 bytẽobt@

߂l: NX^̃`FCǂ(*cluster==0̏ꍇɂRootDirEntry݂̑)Ԃ0ԂB
        ȏソǂȂƂɂ 1 ԂB
	ǂݍ݃G[ꍇ -1 Ԃ
*/
B readCluster(UW *cluster, UH *sector, UB *buf){
	B ret = 0;

	if( *cluster == 1 || *cluster >= totalCluster+2 ) return -1;

	if(*cluster==0){
		// [gfBNg
		if( 0 != mmc_read(firstSectorNumbers + reservedSector + nFAT*secPerFAT + (*sector), buf)){
			return -1;
		}
		if(++(*sector) == rootDirEntrySector) ret = 1;
	}else{
		UW nxt_cluster = *cluster;
		if(*sector == secPerCluster-1){
			if(1 == (nxt_cluster = lookup_nextcluster(*cluster))) return -1;

			if(FATSize==16 && nxt_cluster >=     0xfff8) ret = 1;
			if(FATSize==32 && nxt_cluster >= 0x0ffffff8) ret = 1;
			if(FATSize==12 && nxt_cluster >=      0xff8) ret = 1;
		}

		if( 0 != mmc_read( firstSectorNumbers + reservedSector + nFAT*secPerFAT + rootDirEntrySector + 
		                  ((*cluster)-2)*secPerCluster + (*sector), buf)){
			return -1;
		}

		*sector  = ((*sector)+1 == secPerCluster) ? 0 : (*sector)+1;
		*cluster = nxt_cluster;
	}

	return ret;
}

/*
Ŏw肵NX^̃ZN^ǂݏoB

NX^ƂāA0w肵Ƃɂ́A
RootDirEntry ̎wZN^ǂݏoB

buf : 512 bytẽobt@

߂l: ꍇ 0AsƂ -1
*/
B readSector(UW cluster, UH sector, UB *buf){
	B ret = 0;

	if( cluster == 1 || cluster >= totalCluster+2 ) return -1;

	if(cluster==0){
		// [gfBNg
		ret = mmc_read(firstSectorNumbers + reservedSector + nFAT*secPerFAT + sector, buf);
	}else{
		ret = mmc_read( firstSectorNumbers + reservedSector + nFAT*secPerFAT + rootDirEntrySector + 
		               (cluster-2)*secPerCluster + sector, buf);
	}
	return (ret==0)? 0 : -1;
}

/*
Ŏw肵NX^̃ZN^Ƀobt@eoB

NX^ƂāA0w肵Ƃɂ́A
RootDirEntry ̎wZN^ɏoB

buf : 512 bytẽobt@

߂l: NX^̃`FCǂ(*cluster==1̏ꍇɂRootDirEntry݂̑)A
        邢̓NX^`FC΂ƂłԂ0ԂB
        ȏソǂȂVɃNX^쐬łȂꍇɂ 1 ԂB
	݃G[ꍇ -1 Ԃ
*/
B writeCluster(UW *cluster, UH *sector, UB *buf){
	B ret = 0, tmp;

	if( *cluster == 1 || *cluster >= totalCluster+2 ) return -1;

	if(*cluster==0){
		// [gfBNg
		tmp = mmc_write(firstSectorNumbers + reservedSector + nFAT*secPerFAT + (*sector), buf);
		if( tmp != 0 ) return -1;

		if(++(*sector) == rootDirEntrySector) ret = 1;
	}else{
		UW nxt_cluster = *cluster;
		if(*sector == secPerCluster-1){
			if( 1 == (nxt_cluster = lookup_nextcluster(*cluster))) return -1;

			if((FATSize==16 && nxt_cluster >= 0xfff8) ||
			   (FATSize==32 && nxt_cluster >= 0x0ffffff8) ||
			   (FATSize==12 && nxt_cluster >= 0xff8)){

				if( 1 == (nxt_cluster = alloc_nextcluster(*cluster))) ret = 1;
			}
		}

		tmp = mmc_write( firstSectorNumbers + reservedSector + nFAT*secPerFAT + rootDirEntrySector + 
		               ((*cluster)-2)*secPerCluster + (*sector), buf);
		if( tmp != 0 ) return -1;

		*sector  = ((*sector)+1 == secPerCluster) ? 0 : (*sector)+1;
		*cluster = nxt_cluster;
	}

	return ret;
}

/*
Ŏw肵NX^̃ZN^Ƀobt@eoB

NX^ƂāA0w肵Ƃɂ́A
RootDirEntry ̎wZN^ɏoB

buf : 512 bytẽobt@

߂l: NX^̃`FCǂ(*cluster==1̏ꍇɂRootDirEntry݂̑)A
        邢̓NX^`FC΂ƂłԂ0ԂB
        ȏソǂȂVɃNX^쐬łȂꍇɂ 1 ԂB
	݃G[ꍇ -1 Ԃ
*/
B writeClusterM(UW *cluster, UH *sector, UB *buf, UB count){
	B ret = 0, tmp;
	UW wcount;

	if( *cluster == 1 || *cluster >= totalCluster+2 ) return -1;

	if(count == 0) return 0;

restart:
	if(*cluster==0){
		// [gfBNgGg
		wcount = count;
		if( count + *sector > rootDirEntrySector ) wcount = rootDirEntrySector - *sector;

		tmp = mmc_write_multiple(firstSectorNumbers + reservedSector + nFAT*secPerFAT + (*sector), buf, wcount);
		if( tmp != 0 ) return -1;

		*sector = (*sector) + wcount;

		if( wcount != count ){
			ret = -1;
		}else if( (*sector) == rootDirEntrySector){
			ret = 1;
		}
	}else{
		UW nxt_cluster = *cluster;
		if(*sector+count >= secPerCluster){
			if( 1 == (nxt_cluster = lookup_nextcluster(*cluster))) return -1;

			if((FATSize==16 && nxt_cluster >= 0xfff8) ||
			   (FATSize==32 && nxt_cluster >= 0x0ffffff8) ||
			   (FATSize==12 && nxt_cluster >= 0xff8)){

				if( 1 == (nxt_cluster = alloc_nextcluster(*cluster))) ret = 1;
			}
			wcount = secPerCluster - *sector;
		}else{
			wcount = count;
		}

		tmp = mmc_write_multiple( firstSectorNumbers + reservedSector + nFAT*secPerFAT + rootDirEntrySector + 
		                        ((*cluster)-2)*secPerCluster + (*sector), buf, wcount);
		if(tmp != 0) return -1;

		*sector  = (nxt_cluster != *cluster) ? 0 : (*sector)+wcount;
		*cluster = nxt_cluster;
		buf     += (wcount << 9);
		count   -= wcount;

		if(count !=0 && ret != -1 && ret != 1) goto restart;
	}

	return ret;
}


/*
Ŏw肵NX^̃ZN^oB

NX^ƂāA0w肵Ƃɂ́A
RootDirEntry ̎wZN^oB

buf : 512 bytẽobt@

߂l: ꍇ 0AsƂ -1
*/
B writeSector(UW cluster, UH sector, UB *buf){
	B ret = 0;

	if( cluster == 1 || cluster >= totalCluster+2 ) return -1;

	if(cluster==0){
		// [gfBNg
		ret = mmc_write(firstSectorNumbers + reservedSector + nFAT*secPerFAT + sector, buf);
	}else{
		ret = mmc_write( firstSectorNumbers + reservedSector + nFAT*secPerFAT + rootDirEntrySector + 
		               (cluster-2)*secPerCluster + sector, buf);
	}
	return (ret==0)? 0 : -1;
}

/****************************************************
	FAT NX^AZN^ǂݏ֐܂
****************************************************/


