#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "tinet_app_config.h"
#include "ftpserv.h"
#include "tokenize.h"
#include "fat_api.h"
#include "util.h"

#define TIMEZONE	(-9*60*60)				// GMT ̐̕b

extern T_IN4_ADDR  ipv4_addr;

UB tcp_ftpct_cep_sbuf[N_FTP_TASK][TCP_FTPD_CEP_SBUF_SIZE];
UB tcp_ftpct_cep_rbuf[N_FTP_TASK][TCP_FTPD_CEP_RBUF_SIZE];

UB tcp_ftpdt_cep_sbuf[N_FTP_TASK][TCP_FTPD_CEP_SBUF_SIZE];
UB tcp_ftpdt_cep_rbuf[N_FTP_TASK][TCP_FTPD_CEP_RBUF_SIZE];


/*

user , passwd Ƃɍő128ȓ


	file   : ݒǂݏot@C
	user   : [Ui[郁
	ulen   : ̑傫
	passwd : pX[hi[郁
	plen   : ̑傫


ꍇ 0 ԂB
-2 : file not found
-1 : syntax error

`(Rggp\)
--------------------------
user     (domainA󔒂Ȃǂꍇɂ""Ŋ)
password (pX[hA󔒂Ȃǂꍇɂ""Ŋ)
--------------------------

*/
B lookupFTPDSetting(const char *file, char *user, UB ulen, char *passwd, UB plen){
	B fd;
	B buf[16];
	UH token;
	UH  nval;

	*user=*passwd='\0';

	if( (fd = open(file, O_RDONLY)) < 0 ) return -2;

	while( (token = nextToken(fd, &nval, buf, sizeof(buf))) != TT_EOF ){
		if(token==TT_WORD && !strcmp(buf, "user")){
			if( nextToken(fd, &nval, user, ulen) != TT_WORD ) goto err;

		}else if(token==TT_WORD && !strcmp(buf, "password")){
			if( nextToken(fd, &nval, passwd, plen) != TT_WORD ) goto err;
		}else{
			goto err;
		}
	}

	close(fd);
	return 0;

err:
	close(fd);
	return -1;
}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf T[õR}h
	tbuf obt@

*/
B ftp_cmd_USER(UB *pbuf, UB *tbuf, int exinf, B *user, UB length){
	UH nval;

	if( nextToken_m(pbuf, &pbuf, &nval, user, length-1) != TT_WORD ){
		sprintf(tbuf, "501 Syntax error in parameters or arguments. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
		
		return -1;
	}
	sprintf(tbuf, "331 Password required for %s\r\n", user);
	send_data(exinf, tbuf, strlen(tbuf));

	return 1;
}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf T[õR}h
	tbuf obt@

	user [U
*/
B ftp_cmd_PASS(UB *pbuf, UB *tbuf, int exinf, B *user){
	UH nval;
	B  res, i;
	B ipasswd[17];
	B rd_user[17];
	B rd_passwd[17];


	if( nextToken_m(pbuf, &pbuf, &nval, ipasswd, sizeof(ipasswd)-1) != TT_WORD ){
		sprintf(tbuf, "501 Syntax error in parameters or arguments. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));

		return -1;
	}
	
	res = lookupFTPDSetting( FTP_PASSWD_PATH, rd_user, sizeof(rd_user)-1, rd_passwd, sizeof(rd_passwd)-1 );
	
	if( res == 0 ){
		if( (! strcmp(user, rd_user)) && (! strcmp(ipasswd, rd_passwd)) ){
			// ꉞAŜ߂ɏ
			for(i=0; i<sizeof(ipasswd)  ; i++) ipasswd[i]   = 0;
			for(i=0; i<sizeof(rd_passwd); i++) rd_passwd[i] = 0;

			sprintf(tbuf, "230 User Logged in\r\n");
			send_data(exinf, tbuf, strlen(tbuf));

			return 1;
		}
	}
	sprintf(tbuf, "530 User name or password incorrect. \r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	return -1;
}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf T[õR}h
	tbuf obt@

*/
B ftp_cmd_TYPE(UB *pbuf, UB *tbuf, int exinf){
	UH nval;
	B sval[8];

	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_WORD ){
		sprintf(tbuf, "501 Syntax error in parameters or arguments. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));

		return -1;
	}
	sprintf(tbuf, "200 Type set to %s.\r\n", sval);
	send_data(exinf, tbuf, strlen(tbuf));
	
	return 1;
}



/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@
	transmode	M[hwp̕ϐ
			wȂ(0), PASSIVE(1), ACTIVE(2) ̃[hێ
*/
B ftp_cmd_PASV(UB *pbuf, UB *tbuf, int exinf,int dtcepid, int repid, UH pasv_port, T_IPV4EP *dst, UB *transmode){
	ER	error = E_OK;


	sprintf(tbuf, "227 Entering Passive Mode (%d,%d,%d,%d,%d,%d) \r\n",
		ipv4_addr>>24, 0xff&(ipv4_addr>>16), 0xff&(ipv4_addr>>8), 0xff&ipv4_addr,
		pasv_port>>8, pasv_port&0xff);
	send_data(exinf, tbuf, strlen(tbuf));

	if (tcp_acp_cep( dtcepid, repid, dst, TMO_FEVR) != E_OK) {
		syslog(LOG_NOTICE, "[TCP FTPDT ACP] error: %s", itron_strerror(error));
	}else{
		*transmode = 1;
	}

	return 1;
}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@
	transmode	M[hwp̕ϐ
			wȂ(0), PASSIVE(1), ACTIVE(2) ̃[hێ
*/
B ftp_cmd_PORT(UB *pbuf, UB *tbuf, int exinf, int dtcepid, UB *transmode){
	UH       nval;
	B        sval[8];
	ER       error = E_OK;
	UW       ip, port;

	T_IPV4EP myaddr;
	T_IPV4EP dstaddr;


	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	ip = nval;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != ','       ) goto error_port;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	ip = (ip<<8) | nval;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != ','       ) goto error_port;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	ip = (ip<<8) | nval;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != ','       ) goto error_port;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	ip = (ip<<8) | nval;

	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != ','       ) goto error_port;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	port = nval;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != ','       ) goto error_port;
	if( nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval)) != TT_NUMBER ) goto error_port;
	port = (port<<8) | nval;
	
	
	myaddr.ipaddr  = ipv4_addr;
	myaddr.portno  = FTP_SERV_ACT_PORT;

	dstaddr.ipaddr = ip;
	dstaddr.portno = port;

	// ڑv(\I[v)
	if ((error=tcp_con_cep(dtcepid, &myaddr, &dstaddr, 10000)) != E_OK) {
		syslog(LOG_NOTICE, "[TCP DDNS] error: %s", itron_strerror(error));
		if ((error = tcp_sht_cep(dtcepid)) != E_OK)
			syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

		if ((error = tcp_cls_cep(dtcepid, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));
	}
	
	goto port_success;

error_port:
	sprintf(tbuf, "501 Syntax error in parameters or arguments. \r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	return -1;

port_success:
	sprintf(tbuf, "200 PORT Command successful. \r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	*transmode = 2;


	return 1;
}



/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	transmode	M[hwp̕ϐ
			wȂ(0), PASSIVE(1), ACTIVE(2) ̃[hێ

*/
B ftp_cmd_LIST(UB *pbuf, UB *tbuf, int exinf, int dtcepid, UB *pwd, UB *transmode){
	ER     error = E_OK;
	DIR    *dir;
	dirent *entry;
	B      fd;
	UW     tmp;
	struct stat st;
	struct tm   tmc, tmn;
	time_t ntime;

	char* month[] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" };


	sprintf(tbuf, "150 Opening ASCII mode data connection. \r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	if( NULL == (dir = opendir(pwd)) ){
		goto err_end;
	}

	while( NULL != (entry = readdir(dir)) ){
		sprintf(tbuf, "%s/%s",
			(*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, entry->d_name);

		if( stat(tbuf, &st) < 0 ){
				sprintf(tbuf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %4d %s\r\n",
					(entry->attr&0x10) ? 'd' : '-',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					0,			// t@CTCY
					"Apr",			// 
					1,			// 
					2000,			//  ()
					entry->d_name );	// t@C
		}else{
			st.st_mtime -= TIMEZONE;
			gmtime_r((time_t *)&(st.st_mtime), &tmc);
			
			ntime = get_ntp_time() - TIMEZONE;
			gmtime_r(&ntime, &tmn);

			if(tmc.tm_year != tmn.tm_year){
				sprintf(tbuf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %4d %s\r\n",
					(entry->attr&0x10) ? 'd' : '-',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					st.st_size,		// t@CTCY
					month[tmc.tm_mon],	// 
					tmc.tm_mday,		// 
					1900+tmc.tm_year,	//  ()
					entry->d_name );	// t@C
			}else{
				sprintf(tbuf,"%c%c%c-%c%c-%c%c-  0 root staff %8d %s %2d %2d:%02d %s\r\n",
					(entry->attr&0x10) ? 'd' : '-',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					(entry->attr&0x02) ? '-' : 'r', (entry->attr&0x01) ? '-' : 'w',
					st.st_size,		// t@CTCY
					month[tmc.tm_mon],	// 
					tmc.tm_mday,		// 
					tmc.tm_hour,		// 
					tmc.tm_min,		// 
					entry->d_name );	// t@C
			}
		}
		send_data(dtcepid, tbuf, strlen(tbuf));
	}

	closedir(dir);


err_end:
	if ((error = tcp_sht_cep(dtcepid)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

//	if ((error = tcp_cls_cep(dtcepid, TMO_FEVR)) != E_OK)
	if ((error = tcp_cls_cep(dtcepid, 1000)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));

	sprintf(tbuf, "226 Transfer complete. \r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	return 1;
}



/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_DELE(UB *pbuf, UB *tbuf, int exinf, UB *pwd, UB *tpwd){
	ER	error = E_OK;
	B	res;
	UH	tmp;



	while(*pbuf ==' ') pbuf++;
	tmp = 0;
	while(*pbuf != '\n' && *pbuf != '\r' && *pbuf != ' ' && *pbuf != '\t') tpwd[tmp++] = *pbuf++;
	tpwd[tmp] = '\0';

	if(*tpwd=='/'){
		sprintf(tbuf, "%s", tpwd);
	}else{
		sprintf(tbuf, "%s/%s", (*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, tpwd);
	}

	res = unlink(tbuf);

	if( res < 0 ){
		// t@CJȂꍇ
		sprintf(tbuf, "550 File not deleted. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}else{
		sprintf(tbuf, "250 File Deleted. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}

	return (res < 0) ? -1 : 1;

}
/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_RMD(UB *pbuf, UB *tbuf, int exinf, UB *pwd, UB *tpwd){
	ER	error = E_OK;
	B	res;
	UH	tmp;



	while(*pbuf ==' ') pbuf++;
	tmp = 0;
	while(*pbuf != '\n' && *pbuf != '\r' && *pbuf != ' ' && *pbuf != '\t') tpwd[tmp++] = *pbuf++;
	tpwd[tmp] = '\0';

	if(*tpwd=='/'){
		sprintf(tbuf, "%s", tpwd);
	}else{
		sprintf(tbuf, "%s/%s", (*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, tpwd);
	}

	res = rmdir(tbuf);

	if( res < 0 ){
		// fBNgȂꍇ
		sprintf(tbuf, "550 Directory not removed. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}else{
		sprintf(tbuf, "250 Directory removed. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}

	return (res < 0) ? -1 : 1;

}

/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_MKD(UB *pbuf, UB *tbuf, int exinf, UB *pwd, UB *tpwd){
	ER	error = E_OK;
	B	res;
	UH	tmp;



	while(*pbuf ==' ') pbuf++;
	tmp = 0;
	while(*pbuf != '\n' && *pbuf != '\r' && *pbuf != ' ' && *pbuf != '\t') tpwd[tmp++] = *pbuf++;
	tpwd[tmp] = '\0';

	if(*tpwd=='/'){
		sprintf(tbuf, "%s", tpwd);
	}else{
		sprintf(tbuf, "%s/%s", (*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, tpwd);
	}

	res = mkdir(tbuf, 0777);

	if( res < 0 ){
		// fBNgȂꍇ
		sprintf(tbuf, "550 Directory not created. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}else{
		sprintf(tbuf, "250 Directory created. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}

	return (res < 0) ? -1 : 1;

}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@(512 byteȏ)

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_RETR(UB *pbuf, UB *tbuf, int exinf, int dtcepid, UB *pwd, UB *tpwd){
	ER	error = E_OK;
	B	fd;
	UH	tmp;
	UW	size;



	while(*pbuf ==' ') pbuf++;
	tmp = 0;
	while(*pbuf != '\n' && *pbuf != '\r' && *pbuf != ' ' && *pbuf != '\t') tpwd[tmp++] = *pbuf++;
	tpwd[tmp] = '\0';

	if(*tpwd=='/'){
		sprintf(tbuf, "%s", tpwd);
	}else{
		sprintf(tbuf, "%s/%s", (*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, tpwd);
	}

	fd = open(tbuf, O_RDONLY);

	if( fd < 0 ){
		// t@CJȂꍇ
		sprintf(tbuf, "550 File not found. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}else{
		sprintf(tbuf, "150 Opening BINARY mode data connection. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));

		do{
			if( (size = read(fd, tbuf, 512)) < 0 ){ break; }
			if( 0 == send_data(dtcepid,  tbuf, size) ){ break; }
		}while(size != 0);
		close(fd);
	}

	if ((error = tcp_sht_cep(dtcepid)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(dtcepid, TMO_FEVR)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));

	if( fd >= 0 ){
		sprintf(tbuf, "226 Transfer complete. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}

	return (fd < 0) ? -1 : 1;

}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@(2000 byteȏ)

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_STOR(UB *pbuf, UB *tbuf, int exinf, int dtcepid, UB *pwd, UB *tpwd){
	ER	error = E_OK;
	B	fd;
	UH	tmp, i;
	W	size;
	W	vsize;



	while(*pbuf ==' ') pbuf++;
	tmp = 0;
	while(*pbuf != '\n' && *pbuf != '\r' && *pbuf != ' ' && *pbuf != '\t' && (*pbuf > 0x20 || *pbuf==0x05) ) tpwd[tmp++] = *pbuf++;
	tpwd[tmp] = '\0';

	if(*tpwd=='/'){
		sprintf(tbuf, "%s", tpwd);
	}else{
		sprintf(tbuf, "%s/%s", (*pwd=='/' && *(pwd+1)=='\0') ? "" : (char *)pwd, tpwd);
	}

	fd = creat(tbuf, 0777);

	if( fd < 0 ){
		// t@CȂꍇ
		sprintf(tbuf, "550 File not created. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));

	}else{
		sprintf(tbuf, "150 Opening BINARY mode data connection. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));

		vsize = 0;
		do{
			if( (size = tcp_rcv_dat(dtcepid, tbuf+vsize, RECV_BLOCKSIZE, FTP_CONNECTION_TIMEOUT)) < 0 ) break;
			vsize += size;

			for( tmp = 0; vsize - tmp >= STOR_BLOCKSIZE; tmp+=STOR_BLOCKSIZE ){
				if( write(fd, tbuf+tmp, STOR_BLOCKSIZE) < 0 ) break;
			}

			if( tmp != 0 ){
				vsize -= tmp;
				for(i=0; i < vsize; i++){
					tbuf[i] = tbuf[tmp+i];
				}
			}
		}while(size != 0);

		if( vsize != 0 ) write(fd, tbuf, vsize);

		close(fd);
	}

	if ((error = tcp_sht_cep(dtcepid)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV SHT] error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(dtcepid, TMO_FEVR)) != E_OK)
		syslog(LOG_NOTICE, "[TCP SRV CLS] error: %s", itron_strerror(error));


	if( fd >= 0 ){
		sprintf(tbuf, "226 Transfer complete. \r\n");
		send_data(exinf, tbuf, strlen(tbuf));
	}

	return (fd < 0) ? -1 : 1;

}

/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
	tpwd		t@CʒuvẐ߂̃e|̈
*/
B ftp_cmd_CWD(UB *pbuf, UB *tbuf, int exinf, UB *pwd, UB *tpwd){
	DIR *dir;
	UH i, j, tmp;


	for(i=0; pwd[i]!='\0'; i++) tpwd[i] = pwd[i];
	tpwd[i] = '\0';

	while(*pbuf ==' ') pbuf++;

	if( *pbuf == '/' ){
		i = 0;
	}else{
		// fBNg̖ '/' (pwd̖'/'ȂAroot)
		if(i!=1) tpwd[i++] = '/';
	}

	while(!(*pbuf ==' ' || *pbuf=='\r' || *pbuf=='\n')){
		if( *pbuf == '.' && (*(pbuf+1)=='/' || *(pbuf+1)==' ' || *(pbuf+1)=='\r' || *(pbuf+1)=='\n') ){
			if( *(pbuf+1) == '/' ) pbuf+=2;
			else pbuf++;
		}else if( *pbuf == '.' && *(pbuf+1) == '.' &&
		   (*(pbuf+2)=='/' || *(pbuf+2)==' ' || *(pbuf+2)=='\r' || *(pbuf+2)=='\n') ){
			if( *(pbuf+2) == '/' ) pbuf+=3;
			else pbuf+=2;
			
			if( i != 1 ){
				tmp = 0;
				for(j=0; j<i-1; j++) tmp = (tpwd[j]=='/') ? j : tmp;
				i = tmp+1;	// Ō / ͎c
			}
		}else{
			tpwd[i++] = *pbuf++;
		}
	}
	if(i!=1 && tpwd[i-1] == '/'){
		tpwd[i-1] = '\0';
	}else{
		tpwd[i] = '\0';
	}

	// ړ̃fBNg݂邩mF
	if( NULL != (dir = opendir(tpwd)) ){

		for(i=0; tpwd[i]!='\0'; i++) pwd[i] = tpwd[i];
		pwd[i] = '\0';
		closedir(dir);
	}
	
	syslog(LOG_NOTICE, "[TCP FTP] current pwd: %s %d", pwd, strlen(pwd));

	sprintf(tbuf, "250 CWD command successful.\r\n");
	send_data(exinf, tbuf, strlen(tbuf));


	return 1;
}


/*
Ƃ 1 Ԃ
sƂ̐Ԃ

:
	pbuf		T[õR}h
	tbuf		obt@

	pwd		JgfBNg
			(pwd̖'/'ȂAroot)
*/
B ftp_cmd_CDUP(UB *pbuf, UB *tbuf, int exinf, UB *pwd){
	UH i, j, tmp;

	j = strlen(pwd); tmp = 0;
	for(i=0; i<j; i++) tmp = (pwd[i]=='/') ? i : tmp;
	if( tmp == 0 ){
		pwd[tmp+1] = '\0';
	}else{
		// [gfBNgȊOł́AŌ/폜
		pwd[tmp]   = '\0';
	}
	
	sprintf(tbuf, "250 CWD command successful.\r\n");
	send_data(exinf, tbuf, strlen(tbuf));

	return 1;
}


int ftpd_repid[]    = {TCP_FTPDT_REPID1, TCP_FTPDT_REPID2, TCP_FTPDT_REPID3, TCP_FTPDT_REPID4, TCP_FTPDT_REPID5};
UH  ftpd_repport[]  = {            1500,             1501,             1502,             1503,             1504};
int ftpd_ct_cepid[] = {TCP_FTPCT_CEPID1, TCP_FTPCT_CEPID2, TCP_FTPCT_CEPID3, TCP_FTPCT_CEPID4, TCP_FTPCT_CEPID5};
int ftpd_dt_cepid[] = {TCP_FTPDT_CEPID1, TCP_FTPDT_CEPID2, TCP_FTPDT_CEPID3, TCP_FTPDT_CEPID4, TCP_FTPDT_CEPID5};


void
tcp_ftp_task(VP_INT exinf)
{
	int idx = (int)exinf;

	UB login = 0;		// login == 0 F. login == 1 Fؐ

	UB sval[8];
	UB pwd [128] = "/";
	UB tpwd[128] = "/";
	UB buf[128], *pbuf;
	UB tbuf[FTPD_BUF_SIZE];
	UB addr[sizeof("123.123.123.123")];

	char user[16];

	UH nval, token;
	UB transmode = 0;		// wȂ(0), PASSIVE(1), ACTIVE(2) ̃[hێ

	T_IPV4EP dst;
	W	rlen;
	ID	tskid;
	ER	error = E_OK;


	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP FTP:%d,%d] started.", tskid, ftpd_ct_cepid[idx]);



waitconnection:

	if (tcp_acp_cep(ftpd_ct_cepid[idx], TCP_FTPD_REPID, &dst, TMO_FEVR) != E_OK) {
		syslog(LOG_NOTICE, "[TCP WWW ACP] error: %s", itron_strerror(error));
		goto waitconnection;
	}

	ip2str(addr, &dst.ipaddr);
	syslog(LOG_NOTICE, "[TCP FTP ACP] connected from %s:%d", addr, dst.portno);

	sprintf(tbuf, "220 FTP server ready.\r\n");
	send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));

	login = 0;		// F؂NA
	user[0] = '\0';		// [UNA

	while(TRUE){
		if ((rlen = tcp_rcv_dat(ftpd_ct_cepid[idx], buf, sizeof(buf) - 1, FTP_CMD_WAIT_TIMEOUT)) <= 0) {
			if (rlen != E_OK)
				syslog(LOG_NOTICE, "[TCP FTP RCV] error: %s", itron_strerror(rlen));
			goto err_fin;
		}
		buf[rlen] = '\0';	// ^[~l[g
		
		/*
		   buf : ͂Ώە
		   pbuf: ̎͂̊Jnʒuݒ肳
		   
		   nval: ͂̌ʊi[p()
		   sval: ͂̌ʊi[p()    ߂lŐ񂩂𔻒f
		   sizeof(sval): sval ̒w
		*/
		token = nextToken_m(buf, &pbuf, &nval, sval, sizeof(sval));
		
	restart:
		if( token == TT_EOF ){ continue; }
		if( token != TT_WORD ){ break; }

		syslog(LOG_NOTICE, "[TCP FTP] Command %s", sval);

		if( !login ){
			/*
				F؂̏ꍇ̂ݎs
			*/
			if( ! strcmp(sval, "USER") ){
				ftp_cmd_USER(pbuf, tbuf, ftpd_ct_cepid[idx], user, sizeof(user));
			}else if( !strcmp(sval, "PASS") ){
				if( ftp_cmd_PASS(pbuf, tbuf, ftpd_ct_cepid[idx], user) > 0 ){
					login = 1;

					sprintf(tbuf, "FTP Access from %s, login succeed (USER %s)\n", addr, user);
					chg_pri( 0, TCP_FTP_MAIN_PRIORITY + 1 );
				}else{
					sprintf(tbuf, "FTP Access from %s, login failed (USER %s)\n", addr, user);
				}
				systemlog(tbuf);
			}else{
				sprintf(tbuf, "500 Syntax error, command unrecognized.\r\n");
				send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));
			}
			goto end_cmdexec;
		}

		/*
			F؂ĂƂ̂ݎs
		*/
		if( !strcmp(sval, "PASV") ){		ftp_cmd_PASV(pbuf, tbuf, ftpd_ct_cepid[idx], ftpd_dt_cepid[idx], ftpd_repid[idx], ftpd_repport[idx], &dst, &transmode);
		}else if( !strcmp(sval, "PORT") ){	ftp_cmd_PORT(pbuf, tbuf, ftpd_ct_cepid[idx], ftpd_dt_cepid[idx], &transmode);
		}else if( !strcmp(sval, "TYPE") ){	ftp_cmd_TYPE(pbuf, tbuf, ftpd_ct_cepid[idx]);
		}else if( !strcmp(sval, "RETR") ){	ftp_cmd_RETR(pbuf, tbuf, ftpd_ct_cepid[idx], ftpd_dt_cepid[idx], pwd, tpwd);
		}else if( !strcmp(sval, "STOR") ){	ftp_cmd_STOR(pbuf, tbuf, ftpd_ct_cepid[idx], ftpd_dt_cepid[idx], pwd, tpwd);
		}else if( !strcmp(sval, "CWD" ) ){	ftp_cmd_CWD (pbuf, tbuf, ftpd_ct_cepid[idx], pwd, tpwd);
		}else if( !strcmp(sval, "CDUP") ){	ftp_cmd_CDUP(pbuf, tbuf, ftpd_ct_cepid[idx], pwd);
		}else if( !strcmp(sval, "LIST") ){	ftp_cmd_LIST(pbuf, tbuf, ftpd_ct_cepid[idx], ftpd_dt_cepid[idx], pwd, &transmode);
		}else if( !strcmp(sval, "DELE") ){	ftp_cmd_DELE(pbuf, tbuf, ftpd_ct_cepid[idx], pwd, tpwd);
		}else if( !strcmp(sval, "RMD")  ){	ftp_cmd_RMD (pbuf, tbuf, ftpd_ct_cepid[idx], pwd, tpwd);
		}else if( !strcmp(sval, "MKD")  ){	ftp_cmd_MKD (pbuf, tbuf, ftpd_ct_cepid[idx], pwd, tpwd);

		}else if( !strcmp(sval, "PWD" ) ){
			sprintf(tbuf, "257 \"%s\" is current directory.\r\n", pwd);
			send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));

		}else if( !strcmp(sval, "SYST") || !strcmp(sval, "syst")){
			sprintf(tbuf, "215 UNIX\r\n");
			send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));
			
		}else if( !strcmp(sval, "QUIT") ){
			sprintf(tbuf, "221 Goodbye.\r\n");
			send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));
			break;

		}else if( !strcmp(sval, "ABOR") || !strcmp(sval, "opts") ){
			sprintf(tbuf, "502 Command not implemented. \r\n");
			send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));

		}else{
			sprintf(tbuf, "500 Syntax error, command unrecognized.\r\n");
			send_data(ftpd_ct_cepid[idx], tbuf, strlen(tbuf));
		}
	end_cmdexec:
	
		// ̃R}h܂œǂݔ΂B
		while(*pbuf !='\n') pbuf++;

		if( (token = nextToken_m(pbuf, &pbuf, &nval, sval, sizeof(sval))) != TT_EOF ){
			goto restart;
		}

	}
err_fin:
	if ((error = tcp_sht_cep(ftpd_ct_cepid[idx])) != E_OK)
		syslog(LOG_NOTICE, "[TCP FTP SHT] error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(ftpd_ct_cepid[idx], TMO_FEVR)) != E_OK)
		syslog(LOG_NOTICE, "[TCP FTP CLS] error: %s", itron_strerror(error));

	syslog(LOG_NOTICE, "[TCP FTP] Connection closed");
	chg_pri( 0, TCP_FTP_MAIN_PRIORITY );

	pwd[0]='/';
	pwd[1]='\0';

	goto waitconnection;


}
