#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include "fatio.h"
#include "mmc_access.h"
#include "mmc_io.h"
#include "spi.h"

/*
J[h̏܂ł
mF(CMD1)̉񐔂̏

ȏɂȂꍇA^CAEgG[ƂȂB
*/
#define INIT_TIMEOUT	((W)10000)

/*
R}hɑ΂鉞AĂ܂ł́A
ǂݎ(spi_receive)񐔂̏

ȏɂȂꍇA^CAEgG[ƂȂB
*/
#define CMD_TIMEOUT	((W)10)


/*
rW[Ԃ܂ł́ANbNo񐔂̏

ȏɂȂꍇA^CAEgG[ƂȂB
*/
#define BUSY_TIMEOUT	2000




B card_status = MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT;


/*
----------------------------------------------------------------------

                    Intterupt

----------------------------------------------------------------------
*/

void mmc_cardcheck_task(VP_INT exinf){
	static B prev = MMC_nCARDINSERT;
	B cardinst, res;
	UB buf[512];
	UB mmc_fsInit(UB *tmp);

	while(TRUE){
		if( card_status != 0 ){
			MMC_CARDACTLED_OFF;
		}else{
			MMC_CARDACTLED_ON;
		}

		cardinst = MMC_INSERTED;
		if(prev^cardinst){
			if(cardinst){
				syslog(LOG_NOTICE, "MMC Inserted");
				card_status = MMC_CARD_NOT_INIT | MMC_CARD_NOT_FSINIT;

				dly_tsk(200);

				res = mmc_init();
				if(res!=0) goto nextloop;
				syslog(LOG_NOTICE, "Card Initialized");
				card_status &= (0xff-MMC_CARD_NOT_INIT);

#ifdef USE_FS
				res = fsInit(buf);
				if(res!=0) goto nextloop;
				card_status &= (0xff-MMC_CARD_NOT_FSINIT);
#endif
			}else{
				card_status = MMC_CARD_NOTINSERTED;
				syslog(LOG_NOTICE, "MMC Removed");
			}
		}
		nextloop:
		prev = cardinst;

		dly_tsk(100);
	}
}

/*
mmc_init Ȃǂ͕Kvł͂ȂȂ邪A
^C~OȂ̂ŁAIɌĂяoĂ悢B
̏ꍇAhotplugƋȂB
*/
void mmc_enable_hotplug(void){
	static B init = 0;

	if(!init){
		init = 1;
		act_tsk(MMC_CARDCHECK_TASK);
	}
}

/*
----------------------------------------------------------------------

                    Middle level I/O

----------------------------------------------------------------------
*/


/*
MMCւ̃R}h̔s

:
	dat1...dat6: R}hƂ̈Ȃ


߂l: R}hɑ΂MMC̃X|XB
	^CAEgꍇAŌ̊mFX|X߂lƂB
	(܂A^CAEgꍇɂ́A߂l8rbgڂĂ)

*/
UB transmit_command(UB dat1, UB dat2, UB dat3, UB dat4, UB dat5, UB dat6){
	UB res;
	W cycle = 0;

	spi_transmit(dat1);
	spi_transmit(dat2);
	spi_transmit(dat3);
	spi_transmit(dat4);
	spi_transmit(dat5);
	spi_transmit(dat6);

	// X|XAĂƂɂ 7bitڂ0ɂȂĂ͂
	while( ((res=spi_receive())&0x80) != 0 ){
		if(++cycle > CMD_TIMEOUT) return res;
	}
	
	return res;
}


/*
MMCCIDWX^̎擾

:
	buf: f[^i[̂߂̃obt@(CIDWX^16oCg)


߂l: WX^擾R}hɑ΂郌X|X

*/
UB mmc_getCID(UB *buf){
	UB res,res2;

	wai_sem( SPI_SEM );
	MMC_ENABLE_CS;

	// oXnCCs[_XԂ߂߂ɃNbN̑oKv
	spi_send_clock();			// NbN𑗏o

	res  = transmit_command(0x4a ,0x00, 0x00, 0x00, 0x00, 0x1b);
	res2 = spi_receive_mmcblock(buf, 16);		// 16 byte M

	syslog(LOG_NOTICE, "CMD10 responce %d"    , res);
	syslog(LOG_NOTICE, "    MID: %d"          , buf[0]);
	syslog(LOG_NOTICE, "    OID: 0x%x"        , (buf[1]<<8)+buf[2]);
	syslog(LOG_NOTICE, "    PNM: %c%c%c%c"    , buf[3], buf[4], buf[5], buf[6]);
	syslog(LOG_NOTICE, "       : %c%c"        , buf[7], buf[8]);
	syslog(LOG_NOTICE, "    PRV: %d%d"        , buf[9]>>4, (buf[9]&0x0f));
	syslog(LOG_NOTICE, "    PSN: 0x%x"        , (buf[10]<<24)|(buf[11]<<16)|(buf[12]<<8)|buf[13] );
	syslog(LOG_NOTICE, "    PRV: %d/%d"       , buf[14]>>4, (buf[14]&0x0f));

	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );

	return res;
}

/*
MMCCSDWX^̎擾

:
	buf: f[^i[̂߂̃obt@(CSDWX^16oCg)


߂l: WX^擾R}hɑ΂郌X|X

*/
UB mmc_getCSD(UB *buf){
	UB res,res2;
	W blocklen, tmp1, tmp2, tmp3, C_size, C_size_mult, Mult, MAX_LAB;

	wai_sem( SPI_SEM );
	MMC_ENABLE_CS;

	// oXnCCs[_XԂ߂߂ɃNbN̑oKv
	spi_send_clock();			// NbN𑗏o

	res  = transmit_command(0x49 ,0x00, 0x00, 0x00, 0x00, 0xaf);
	res2 = spi_receive_mmcblock(buf, 16);	// 16 byte M

	blocklen = (1<<(buf[5]&0xf));

	tmp1 = (buf[6]&3)<<10;
	tmp2 = buf[7]<<2;
	tmp3 = (buf[8]>>6)&3;
	C_size = tmp1 | tmp2 | tmp3;

	tmp1 = (buf[9]&3)<<1;
	tmp2 = (buf[10]>>7)&1;
	C_size_mult = tmp1|tmp2;

	Mult = 1<<(C_size_mult+2);
	MAX_LAB = (C_size +1 )*Mult;

	syslog(LOG_NOTICE, "CMD9 responce %d"  , res);
	syslog(LOG_NOTICE, "    C_SIZE_MULT %d", C_size_mult);
	syslog(LOG_NOTICE, "    C_SIZE      %d", C_size);
	syslog(LOG_NOTICE, "    MULT        %d", Mult);
	syslog(LOG_NOTICE, "    BLOCK_LEN   %d", blocklen);
	syslog(LOG_NOTICE, "    MAX LBA     %d", MAX_LAB);

	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );

	return res;
}

/*
----------------------------------------------------------------------

                    High level I/O


̃xŁACS̐M̐Ɣrs
----------------------------------------------------------------------
*/

/*
MMC̃ZN^Pʂł̓ǂݏo
ZN^TCY512oCgł邱ƂB

:
	sec: ǂݎZN^ԍ
	buf: f[^i[p̃obt@(512oCgȏKv)

߂l: ǂݎR}h(CMD17)ɑ΂MMC̃X|X(R1`)B
	ǂݎR}hs̃X|XMŃ^CAEgꍇɂ́A
	߂l8rbgڂĂB
	̂ƂAf[^̓ǂݎ͂ĂȂB
	(̂ق̃G[̏ꍇ́A8bitڂ͂Ȃ̂ŒׂKv)

	J[h̏G[NĂAJ[h}ĂȂiKŌĂ΂ꂽƂ
	߂l8rbgڂĂB

	ȏꍇ0

*/
UB mmc_read(UW sec, UB *buf){
	UB res;
	UW addr;
	UH loop=0;

	if( (card_status & MMC_CARD_NOTINSERTED) ||
	    (card_status & MMC_CARD_NOT_INIT) ){
		return 0xff;
	}


	wai_sem( SPI_SEM );
	MMC_ENABLE_CS;

restart:

	// oXnCCs[_XԂ߂߂ɃNbN̑oKv
	spi_send_clock();				// NbN𑗏o

	if( spi_mmcbusywait() ){
		syslog(LOG_NOTICE, "Error: busy at mmc_read (line:%d)",__LINE__);
		res = 0xff;
		goto exit;
	}

	addr = sec << 9; //sec*512;
	res = transmit_command(0x51, (addr>>24)&0xff, (addr>>16)&0xff, (addr>> 8)&0xff, addr&0xff, 0xff);

	if(res!=0) goto exit;

	// MŃ^CAEgG[Nꍇɂ́AxĎs
	if(0 != spi_receive_mmcblock(buf, 512)){
		if(loop++<BUSY_TIMEOUT){
			syslog(LOG_NOTICE, "mmc_read : operation restart (line:%d)", __LINE__);
			goto restart;
		}
	}


exit:
	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );
	return res;
}

/*
MMC̃ZN^Pʂł̏o
ZN^TCY512oCgł邱ƂB

:
	sec: oZN^ԍ
	buf: ݃f[^(512oCg)

߂l: ǂݎR}hɑ΂MMC̃X|XB
	ǂݎR}hs̃X|XMŃ^CAEgꍇɂ́A
	߂l8rbgڂĂB
	̂ƂAf[^̓ǂݎ͂ĂȂB

	J[h̏G[NĂAJ[h}ĂȂiKŌĂ΂ꂽƂ
	߂l8rbgڂĂB

*/
UB mmc_write(UW sec, UB *buf){
	UB res;
	UW addr;

	if( (card_status & MMC_CARD_NOTINSERTED) ||
	    (card_status & MMC_CARD_NOT_INIT) ){
		return 0xff;
	}

	wai_sem( SPI_SEM );
	MMC_ENABLE_CS;

	// oXnCCs[_XԂ߂߂ɃNbN̑oKv
	spi_send_clock();				// NbN𑗏o

	if( spi_mmcbusywait() ){
		syslog(LOG_NOTICE, "Error: busy at mmc_write (line:%d)",__LINE__);
		res = 0xff;
		goto exit;
	}

	addr = sec << 9; //sec*512;
	res = transmit_command(0x58, (addr>>24)&0xff, (addr>>16)&0xff, (addr>> 8)&0xff, addr&0xff, 0xff);

	spi_send_clock();				// NbN𑗏o

	if(res != 0){
		syslog(LOG_NOTICE, "Error: mmc_write (cmd responce %d, line:%d)", res, __LINE__);
		goto exit;
	}
	res = spi_transmit_mmcblock(buf, 512, MMC_IO_TRANSMIT_SINGLE_BLOCK);

	if(res != 0)
		syslog(LOG_NOTICE, "Error: mmc_write (transmit responce %d, line:%d)", res, __LINE__);

exit:
	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );
	return res;
}

/*
MMC̃ZN^Pʂł̏o
ZN^TCY512oCgł邱ƂB

:
	sec: oZN^ԍ
	buf: ݃f[^(512oCg)

߂l: ǂݎR}hɑ΂MMC̃X|XB
	ǂݎR}hs̃X|XMŃ^CAEgꍇɂ́A
	߂l8rbgڂĂB
	̂ƂAf[^̓ǂݎ͂ĂȂB

	J[h̏G[NĂAJ[h}ĂȂiKŌĂ΂ꂽƂ
	߂l8rbgڂĂB

*/
UB mmc_write_multiple(UW sec, UB *buf, UB count){
	UB res;
	UW addr, j;

	if(count == 0) return 0xff;

	if( (card_status & MMC_CARD_NOTINSERTED) ||
	    (card_status & MMC_CARD_NOT_INIT) ){
		return 0xff;
	}

	wai_sem( SPI_SEM );
	MMC_ENABLE_CS;

	// oXnCCs[_XԂ߂߂ɃNbN̑oKv
	spi_send_clock();				// NbN𑗏o

	if( spi_mmcbusywait() ){
		syslog(LOG_NOTICE, "Error: busy at mmc_write_multiple (line:%d)", __LINE__);
		res = 0xff;
		goto exit;
	}

	addr = sec << 9; //sec*512;
	res = transmit_command(0x40+25, (addr>>24)&0xff, (addr>>16)&0xff, (addr>> 8)&0xff, addr&0xff, 0xff);

	spi_send_clock();				// NbN𑗏o

	if(res != 0){
		syslog(LOG_NOTICE, "Error: mmc_write_multiple (cmd responce %d, line:%d)", res, __LINE__);
		goto exit;
	}

	for(j=0; j<count; j++){
		res = spi_transmit_mmcblock(buf, 512, MMC_IO_TRANSMIT_MULTI_BLOCK);
		if(res != 0)
			syslog(LOG_NOTICE, "Error: mmc_write_multiple (transmit responce %d, line:%d)", res, __LINE__);
		if( spi_mmcbusywait() ){
			syslog(LOG_NOTICE, "Error: busy at mmc_write_multiple (line:%d)", __LINE__);
			res = 0xff;
			goto exit;
		}
		buf+=512;
	}
	// stop tran token
	spi_transmit(0xfd);

	spi_send_clock();				// NbN𑗏o

exit:
	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );
	return res;
}

/*
MMC̏
A|[g̓o͐ݒ͌ĂяoōsĂKvB


߂l: ɐ0

*/
UB mmc_init(void){
	UB i,res;
	W  cycle = 0;


	if( card_status & MMC_CARD_NOTINSERTED ){
		return 1;
	}

	spi_init();

	wai_sem( SPI_SEM );
	MMC_DISABLE_CS;

	// NbN800񑗏o
	for(i=0; i<100; i++) spi_send_clock();		// NbN𑗏o

	MMC_ENABLE_CS;

	// oXnCCs[_XԂ߂߂ɃNbN𑗏o
	spi_send_clock();

	res = transmit_command(0x40 ,0x00, 0x00, 0x00, 0x00, 0x95);
	res = transmit_command(0x40 ,0x00, 0x00, 0x00, 0x00, 0x95);
	do{
		spi_send_clock();			// NbN𑗏o
		res = transmit_command(0x41 ,0x00, 0x00, 0x00, 0x00, 0xf9);

		if(++cycle > INIT_TIMEOUT){		// ^CAEg̊mF
			syslog(LOG_NOTICE, "mmc initialized time out (line: %d)", __LINE__);
			res = 1;
			card_status |= MMC_CARD_NOT_INIT;
			goto exit;
		}
	}while(res!=0);
	res = 0;
/*
	getCID(tmp);
	getCSD(tmp);					// Kɉݒ肷Kv邩
*/
	card_status &= (0xff - MMC_CARD_NOT_INIT);	// ŃNAĂ
exit:
	MMC_DISABLE_CS;

	// oX̊JɕKv
	spi_send_clock();				// NbN𑗏o

	sig_sem( SPI_SEM );
	return res;
}



