#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "tinet_app_config.h"
#include "fat_api.h"
#include "mmc_access.h"
#include "ntp.h"
#include "parse.h"
#include "util.h"
#include "peripheral.h"
#include "vs1011e_app.h"
#include "resolv.h"
#include "DDNS_IP.h"
#include "coffload.h"
#include "fatio.h"
#include "exec.h"
#include "na2.h"
#include "fat_pwd.h"


#define TIMEZONE	(-9*60*60)				// GMT ̐̕b

T_IN4_ADDR  ipv4_addr            = IPV4_ADDR_LOCAL;
T_IN4_ADDR  ipv4_addr_mask       = IPV4_ADDR_LOCAL_MASK;
T_IN4_ADDR  ipv4_addr_default_gw = IPV4_ADDR_DEFAULT_GW;
T_IN4_ADDR  ipv4_addr_nameserver = IPV4_ADDR_DEFAULT_GW;


#include "tokenize.h"


/*
	Ni[
*/
UW	startuptime;





void systemlog(char *str){
	char date[30];
	char datestr[40];
	struct tm ttm;

	// Z}t@̊m
	wai_sem( LOGGING_SEM );

	B fd;
	if( (fd=open("system.log", O_WRONLY)) < 0 ){
		fd = creat("system.log", 0777);
	}

	if( fd >= 0 ){
		lseek(fd, 0, SEEK_END);
		
		UW tim = get_ntp_time() - TIMEZONE;
		asctime_r(gmtime_r((time_t *)&tim, &ttm), date);
		date[strlen(date)-1] = '\0';

		sprintf(datestr, "[%26s] ", date);

		write(fd, datestr, strlen(datestr));
		write(fd,     str, strlen(    str));
		close(fd);
	}

	sig_sem( LOGGING_SEM );
}


struct DaemonInfo{
	char name[sizeof(DAEMON_DIR)+1+NAME_MAX];
	UW daemon_prog[DAEMON_PROG_SIZE/4];		// ACgSɂ邽 32bit Ŋm
};


/*


ƂāAUDPʐM̂߂̐lĂB

*/
void
na2_main_task (VP_INT exinf)
{
	ID		tskid;
	unsigned char	buf[512];
	UH		i;
	T_IN4_ADDR	ip, mask, gw, ns;

	static struct DaemonInfo daemon[N_MAX_DAEMON];



	get_tid(&tskid);
	syslog(LOG_NOTICE, "[NA2] started.");


	// MMC ̏
	if( 0 == mmc_init() ){
		syslog(LOG_NOTICE, "[NA2] MMC Initialized.");
	}
	mmc_enable_hotplug();
	
	if( 0 == fsInit(buf) ){
		syslog(LOG_NOTICE, "[NA2] MMC FS Initialized.");
	}


	// VS1011e ̏
	if( 0 == vs1011e_init() ){
		syslog(LOG_NOTICE, "[NA2] VS1011e Initialized.");
	}


	// IP AhX̐ݒ
	ip = mask = gw = ns = 0;
	if( lookupIPsetting("etc/ip.cfg", &ip, &mask, &gw, &ns) == 0 ){
		ipv4_addr            = (ip == 0) ? ipv4_addr            : ip;
		ipv4_addr_mask       = (mask==0) ? ipv4_addr_mask       : mask;
		ipv4_addr_default_gw = (gw == 0) ? ipv4_addr_default_gw : gw;
		ipv4_addr_nameserver = (ns == 0) ? ipv4_addr_nameserver : ns;
		
		in4_add_ifaddr (ipv4_addr, ipv4_addr_mask);
		syslog(LOG_NOTICE, "[NA2] Initialized Network Address: addr:%x mask:%x gw:%x  ns:%x.",
		       ipv4_addr, ipv4_addr_mask, ipv4_addr_default_gw, ipv4_addr_nameserver);
		
		in4_add_route (0,                          0,              0, ipv4_addr_default_gw);
		in4_add_route (1, ipv4_addr & ipv4_addr_mask, ipv4_addr_mask,                    0);
		in4_add_route (2,                 0xffffffff,     0xffffffff,                    0);
	}else{
		syslog(LOG_NOTICE, "[NA2] Initialized Network Address(use default value): addr:%x mask:%x gw:%x ns:%x.",
		       ipv4_addr, ipv4_addr_mask, ipv4_addr_default_gw, ipv4_addr_nameserver);
	}

	// DDNS ̐ݒ
	if( lookupDDNSsetting("etc/ddns.cfg", buf, 64, buf+128, 64) == 0 ){
		syslog(LOG_NOTICE, "[NA2] Initialized DDNS Setting.");

		initDDNS(buf, buf+128);

		for(i=0; i<sizeof(buf); i++) buf[i] = 0;
	}else{
		syslog(LOG_NOTICE, "[NA2] Don't use DDNS Services");
	}


	act_tsk(SNTP_CLI_TASK);	// NTP 擾^XN𓮂

	// NTP ̎擾 ̂҂
	do{
		dly_tsk(1000);
	}while(get_ntp_basetime()==0);


	// N̐ݒ
	startuptime = get_ntp_time();


	/*
		VXeO֒ǉ
	*/
	sprintf(buf,"DIAG System started (NTP time acquired)  IP: %d.%d.%d.%d, Mask: %d.%d.%d.%d, GW: %d.%d.%d.%d\n",
		ipv4_addr           >>24, 0xff&(ipv4_addr           >>16), 0xff&(ipv4_addr           >>8), 0xff&(ipv4_addr           >>0),
		ipv4_addr_mask      >>24, 0xff&(ipv4_addr_mask      >>16), 0xff&(ipv4_addr_mask      >>8), 0xff&(ipv4_addr_mask      >>0),
		ipv4_addr_default_gw>>24, 0xff&(ipv4_addr_default_gw>>16), 0xff&(ipv4_addr_default_gw>>8), 0xff&(ipv4_addr_default_gw>>0));
	systemlog(buf);

	// vOs̏
	exec_init();

	addLinkFunction("_syslog"   , syslog);
	addLinkFunction("_nextToken", nextToken);
	addLinkFunction("_print"    , exec_print);
	addLinkFunction("_print2"   , exec_print2);
	addLinkFunction("_errprint" , exec_errprint);
	addLinkFunction("_errprint2", exec_errprint2);
	addLinkFunction("_scan"     , exec_scan);
	addLinkFunction("_scan_tmout",exec_scan_tmout);
	addLinkFunction("_exec"     , pwd_exec);
	addLinkFunction("_exec2"    , exec2);
	addLinkFunction("_get_env"  , get_env);
	addLinkFunction("_set_env"  , set_env);
	addLinkFunction("_get_cgi_value", get_cgi_value);
	addLinkFunction("_get_ad_value" ,  get_ad_value );

	addLinkFunction("_getipbyname", getipbyname);
	addLinkFunction("_getnamebyip", getnamebyip );
	addLinkFunction("_get_ip_setting", get_ip_setting );

	addLinkFunction("_vs1011e_getplayID", vs1011e_getplayID );
	addLinkFunction("_vs1011e_stop"     , vs1011e_stop      );
	addLinkFunction("_vs1011e_skip"     , vs1011e_skip      );
	addLinkFunction("_vs1011e_pause"    , vs1011e_pause     );
	addLinkFunction("_vs1011e_play"     , pwd_vs1011e_play      );
	addLinkFunction("_vs1011e_autoplay" , pwd_vs1011e_autoplay  );
	addLinkFunction("_vs1011e_play_shoutcast", vs1011e_play_shoutcast      );
	addLinkFunction("_vs1011e_setVolume", vs1011e_setVolume );
	addLinkFunction("_vs1011e_getVolume", vs1011e_getVolume );

	addLinkFunction("_Open" ,   pwd_open);
	addLinkFunction("_Creat",   pwd_creat);
	addLinkFunction("_Unlink",  pwd_unlink);
	addLinkFunction("_Close",   close);
	addLinkFunction("_Read" ,    read);
	addLinkFunction("_Write",   write);
	addLinkFunction("_Lseek",   lseek);

	addLinkFunction("_Opendir",   pwd_opendir);
	addLinkFunction("_Readdir",   readdir);
	addLinkFunction("_Closedir", closedir);

	addLinkFunction("_Rmdir",   pwd_rmdir);
	addLinkFunction("_Mkdir",   pwd_mkdir);
	
	addLinkFunction("_Stat" ,  pwd_stat);
	addLinkFunction("_Fstat", fstat);
	addLinkFunction("_diskfree", diskfree);


	addLinkFunction("_Sprintf", sprintf);
	addLinkFunction("_Sscanf",  sscanf);
	addLinkFunction("_Ctime_r", ctime_r);
	// _gmtime_r ̕񂪂 make̍ŌɎschkɈ̂ŉ̂߂
	// قƂ͈قȂKp
	addLinkFunction("_lgmtime_r",gmtime_r);	
	addLinkFunction("_Time",    get_ntp_time);
	addLinkFunction("_Strlen",  strlen);
	addLinkFunction("_Strcmp",  strcmp);
	addLinkFunction("_Strncmp", strncmp);
	addLinkFunction("_Dly_tsk", dly_tsk);

	addLinkFunction("_mmc_getCID", mmc_getCID);
	addLinkFunction("_mmc_getCSD", mmc_getCSD);

	addLinkFunction("_addLinkFunction", addLinkFunction);


	
	// 
	act_tsk(ROUNDROBIN_TASK);
	act_tsk(TCP_DDNS_TASK);
	act_tsk(TCP_WWW_TASK1);
	act_tsk(TCP_WWW_TASK2);
	act_tsk(TCP_WWW_TASK3);
	act_tsk(TCP_WWW_TASK4);
	act_tsk(TCP_WWW_TASK5);
	
	act_tsk(TCP_FTP_TASK1);
	act_tsk(TCP_FTP_TASK2);
	act_tsk(TCP_FTP_TASK3);
	act_tsk(TCP_FTP_TASK4);
	act_tsk(TCP_FTP_TASK5);
	
	act_tsk(TELNET_TASK1);
	act_tsk(TELNET_TASK2);

	
	DIR *dir;
	dirent *entry;
	B fd;
	UW binsize;
	int n_daemon = 0;

	dir = opendir(DAEMON_DIR);
	while( (entry=readdir(dir)) != NULL ){
		if( entry->attr&0x10 ) continue;	// fBNg̏ꍇ
		
		//---------------------------------------------------------------
		// bin t@Cǂ̊mF(gq bin ɂȂĂ邩mF)
		i=0;
		while( entry->d_name[i] != '.' && entry->d_name[i] != '\0') i++;
		if( entry->d_name[i] == '\0' ) continue;
		if(!(((entry->d_name[i+1]=='e') || (entry->d_name[i+1]=='E')) &&
		     ((entry->d_name[i+2]=='x') || (entry->d_name[i+2]=='X')) &&
		     ((entry->d_name[i+3]=='e') || (entry->d_name[i+3]=='E')) &&
		      (entry->d_name[i+4]=='\0'))) continue;
		//---------------------------------------------------------------
		
		sprintf(buf, "%s/%s", DAEMON_DIR, entry->d_name);
		if( (fd = open(buf, O_RDONLY)) >= 0 && n_daemon < N_MAX_DAEMON ){
			if( loadCoff(fd, (UB *)daemon[n_daemon].daemon_prog, DAEMON_PROG_SIZE, (UW)daemon[n_daemon].daemon_prog, &binsize) >= 0){
				sprintf(daemon[n_daemon].name, "%s", buf);
				n_daemon++;
			}
			close(fd);
		}
	}



	while(TRUE){
		for(i=0; i<n_daemon; i++){
			char* argv[2];
			struct program_io pio;
			W res;

			argv[0] = daemon[i].name;	// 0 : fname
			argv[1] = NULL;

			// W, Wo, WG[o: VA
			pio.io_mux_in = pio.io_mux_out = pio.io_mux_err= EXEC_IO_SERIAL;
			pio.std_in    = pio.std_out    = pio.std_err   = 0;

			exec2((UB *)daemon[i].daemon_prog, &pio, 1, argv, &res);
		}
		
		dly_tsk(1000);
	}

/*
	while(TRUE){
		dly_tsk(5*60*60*1000);
	}
*/
}



