#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

struct st_ad {                                          /* struct A/D   */
             UH                 ADDRA;                  /* ADDRA        */
             UH                 ADDRB;                  /* ADDRB        */
             UH                 ADDRC;                  /* ADDRC        */
             UH                 ADDRD;                  /* ADDRD        */
             union {                                    /* ADCSR        */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char ADF :1;         /*    ADF       */
                          unsigned char ADIE:1;         /*    ADIE      */
                          unsigned char ADST:1;         /*    ADST      */
                          unsigned char SCAN:1;         /*    SCAN      */
                          unsigned char CKS :1;         /*    CKS       */
                          unsigned char CH  :3;         /*    CH        */
                          }      BIT;                   /*              */
                   }            ADCSR;                  /*              */
             union {                                    /* ADCR         */
                   unsigned char BYTE;                  /*  Byte Access */
                   struct {                             /*  Bit  Access */
                          unsigned char TRGE:1;         /*    TRGE      */
                          }      BIT;                   /*              */
                   }            ADCR;                   /*              */
};                                                      /*              */


#define AD      (*(volatile struct st_ad    *)0xFFFFE0) /* A/D   Address*/


/*
vAD`l(0-7܂)Ƃė^B
x10rbgBvʂʃrbgɋl߂`16rbgŖ߂B
݂Ȃ`lw肷0ԂB
*/

UH get_ad_value(B ch){

	UH res;
	UB cmd;

	wai_sem( PERIPHERAL_ADC_SEM );

	cmd = 0x20 |        // ADX^[g(bit5)
	                    // Pꃂ[h(bit4)
	                    // NbNZNg=134state(bit3)
	      (ch & 0x07);  // `lI

	AD.ADCSR.BYTE = cmd&(0xff-0x20);
	AD.ADCSR.BYTE = cmd;			// A/DX^[g
	
	while( (AD.ADCSR.BYTE&0x80) == 0 ) ;	// ADItO̂҂

	switch(ch){
		case 0: 
		case 4: res = AD.ADDRA; break;
		case 1: 
		case 5: res = AD.ADDRB; break;
		case 2:
		case 6: res = AD.ADDRC; break;
		case 3:
		case 7: res = AD.ADDRD; break;
		default: res = 0; break;
	}
	
	sig_sem( PERIPHERAL_ADC_SEM );

	return res;
}

