#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <string.h>
#include <stdio.h>

#include <net/net.h>
#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netapp/netapp_var.h>

static UH resolver_msg[512/2];		// ACg킹

static UH header_id = 1;

extern T_IN4_ADDR  ipv4_addr_nameserver;


// ̏ꍇ̃fR[h
B decode_answer_query(UB *msg, T_IN4_ADDR *addr){
	UH n_quest = *((UH *)(msg+4));
	UH n_ans   = *((UH *)(msg+6));
	UH i;
	UB *sect;
	
	syslog(LOG_NOTICE, "[getipbyname] question %d, answer %d", n_quest, n_ans);

	sect = msg + 12;
	for( i=0; i<n_quest; i++){
		
		for( ; *sect!=0 && 0xc0!=(*sect&0xc0); sect++) ;
		if(*sect != 0){
			sect += 2;
		}else{
			sect += 1;
		}
		
		sect += 4;
	}

	for( i=0; i<n_ans; i++){
		for( ; *sect!=0 && 0xc0!=(*sect&0xc0); sect++) ;
		if(*sect != 0){
			sect += 2;
		}else{
			sect += 1;
		}
		
		// Type  A(zXgAhX)ɂȂĂ̂T
		if( ( ((*sect)<<8) | (*(sect+1)) ) != 1 ){
			syslog(LOG_NOTICE, "[getipbyname] type %d", ((*sect)<<8) | (*(sect+1)));
			//      type   class   ttl
			sect +=    2 +     2 +   4;
			//      rdlength                      rdlength
			sect +=        2 + (((*sect)<<8) | (*(sect+1)));

			continue;
		}
		
		sect+=2;
		// Class  IN(C^[lbgVXe)ɂȂĂ̂T
		if( ( ((*sect)<<8) | (*(sect+1)) ) != 1 ){
			syslog(LOG_NOTICE, "[getipbyname] class %d", ((*sect)<<8) | (*(sect+1)));
			//      class   ttl
			sect +=     2 +   4;
			//      rdlength                      rdlength
			sect +=        2 + (((*sect)<<8) | (*(sect+1)));
			continue;
		}
		sect+= 2 + 4 + 2;	// class + ttl + rdlength
		
		*addr = MAKE_IPV4_ADDR( *sect, *(sect+1), *(sect+2), *(sect+3) );

		return 0;
	}

	return -1;
}

// t̏ꍇ̃fR[h
B decode_answer_iquery(UB *msg, char *name){
	UH n_quest = *((UH *)(msg+4));
	UH n_ans   = *((UH *)(msg+6));
	UH i,j;
	UB *sect, *ans;
	
	syslog(LOG_NOTICE, "[getipbyname] question %d, answer %d", n_quest, n_ans);

	sect = msg + 12;
	for( i=0; i<n_quest; i++){
		
		for( ; *sect!=0 && 0xc0!=(*sect&0xc0); sect++) ;
		if(*sect != 0){
			sect += 2;
		}else{
			sect += 1;
		}
		
		sect += 4;
	}

	for( i=0; i<n_ans; i++){
		for( ; *sect!=0 && 0xc0!=(*sect&0xc0); sect++) ;
		if(*sect != 0){
			sect += 2;
		}else{
			sect += 1;
		}
		
		// Type  PTR(hCXy[X̂ق̕ւ̃|C^)ɂȂĂ̂T
		if( ( ((*sect)<<8) | (*(sect+1)) ) != 12 ){
			syslog(LOG_NOTICE, "[getipbyname] type %d", ((*sect)<<8) | (*(sect+1)));
			//      type   class   ttl
			sect +=    2 +     2 +   4;
			//      rdlength                      rdlength
			sect +=        2 + (((*sect)<<8) | (*(sect+1)));

			continue;
		}
		
		sect+=2;
		// Class  IN(C^[lbgVXe)ɂȂĂ̂T
		if( ( ((*sect)<<8) | (*(sect+1)) ) != 1 ){
			syslog(LOG_NOTICE, "[getipbyname] class %d", ((*sect)<<8) | (*(sect+1)));
			//      class   ttl
			sect +=     2 +   4;
			//      rdlength                      rdlength
			sect +=        2 + (((*sect)<<8) | (*(sect+1)));
			continue;
		}
		sect+= 2 + 4 + 2;	// class + ttl + rdlength
		
		ans = sect;
		do{
			if( (*ans&0xc0) == 0xc0 ) ans = msg + ((*ans-0xc0)<<8) + *(ans+1);
			for(j=0; j<*ans; j++) *name++ = ans[1+j];
			*name++ = '.';
			if(*ans!=0) ans += 1 + *ans;
		}while( *ans != 0 );
		
		*--name = '\0';
		
		return 0;
	}

	return -1;
}


B getipbyname(char *name, T_IN4_ADDR *addr){
	T_IPV4EP dst;
	W stat,len;
	UH i;
	UB *st1, *st2, *msg=(UB *)resolver_msg;
	B res = 0;
	
	wai_sem( RESOLVER_SEM );
	
	dst.ipaddr = ipv4_addr_nameserver;	/* nameserver */
	dst.portno = 53;			/* nameserver port */
	
	
	// H8  rbNGfBAȂ̂ł̂܂܏
	// ڐAɂ͒
	*((UH *)(msg+0)) = header_id++;		//  (16bit)
	*((UB *)(msg+2)) = 0<<7 | 0<<3 |		// QR(1bit:₢킹ł0) | Opcode(4bit:W₢킹(0))
	                            0<<2 | 0<<1 | 1;		// AA(1bit:?) | TC(1bit:bZ[W͒Zk?) | RD(1bit:₢킹ōċAĂяo?)
	*((UB *)(msg+3)) = 0<<7 |			// RA(1bit:T[o͍ċA񋟂ł(ɗL))
	                            0<<4 | 0;			// Res(3bit:gp̈) | RCode(4bit:G[Ȃ(0))
	*((UH *)(msg+4)) = 1;				// ̐ (16bit)
	*((UH *)(msg+6)) = 0;				// 񓚂̐ (16bit)
	*((UH *)(msg+8)) = 0;				// I[\eB̐ (16bit)
	*((UH *)(msg+10)) = 0;				// ǉ̐ (16bit)

	for(i=0; name[i] != '\0'; i++) msg[13+i] = name[i];
	msg[13+i] = '\0';

	st1 = msg+13;
	do{
		for(st2 = st1; *st2!='\0' && *st2!='.'; st2++) ;
		*(st1 - 1) = st2 - st1;
		st1 = st2+1;
	}while(*st2 != '\0');

	*st2++ = 0;	// kx
	*st2++ = 0;
	*st2++ = 1;	// QType ( A: zXgAhX(1) )
	*st2++ = 0;
	*st2++ = 1;	// QClass ( IN: C^[lbgVXe(1) )

	if ((int)(stat = udp_snd_dat(RESOLVER_CEPID, &dst, (VP)resolver_msg, st2-msg, TMO_FEVR)) < 0){
		syslog(LOG_NOTICE, "[getipbyname] error: %s", itron_strerror(stat));
	}

receive:
	if ((int)(len = udp_rcv_dat(RESOLVER_CEPID, &dst, (VP)resolver_msg, 512, 1000)) >= 0) {

		if( ! msg[2]&0x80 ){
			syslog(LOG_NOTICE, "[getipbyname] QR code is not proper");
			goto receive;
		}
		syslog(LOG_NOTICE, "[getipbyname] getipbyname: answer received");
		
		if( decode_answer_query((UB *)resolver_msg, addr) < 0 ) res=-1;
		
		if( res < 0 ){
			syslog(LOG_NOTICE, "[getipbyname] getipbyname: failed");
		}else{
			syslog(LOG_NOTICE, "[getipbyname] getipbyname: %s -> %d.%d.%d.%d",
			                   name, ((*addr)>>24)&0xff, ((*addr)>>16)&0xff, ((*addr)>>8)&0xff, (*addr)&0xff);
		}
	}else{
		syslog(LOG_NOTICE, "[getipbyname] error: %s", itron_strerror(len));

		udp_can_cep(RESOLVER_CEPID, TFN_UDP_RCV_DAT);	// YƁA̎sŎs
	}

	sig_sem( RESOLVER_SEM );

	return res;
}

B getnamebyip(T_IN4_ADDR addr, char *name){
	T_IPV4EP dst;
	W stat,len;
	UB *st1, *st2, *msg=(UB *)resolver_msg;
	B res = 0;
	
	wai_sem( RESOLVER_SEM );
	
	dst.ipaddr = ipv4_addr_nameserver;	/* nameserver */
	dst.portno = 53;			/* nameserver port */

	// H8  rbNGfBAȂ̂ł̂܂܏
	// ڐAɂ͒
	*((UH *)(msg+0)) = header_id++;		//  (16bit)
	*((UB *)(msg+2)) = 0<<7 | 0<<3 |	// QR(1bit:₢킹ł0) | Opcode(4bit:₢킹(0))
	                   0<<2 | 0<<1 | 1;	// AA(1bit:?) | TC(1bit:bZ[W͒Zk?) | RD(1bit:₢킹ōċAĂяo?)
	*((UB *)(msg+3)) = 0<<7 |		// RA(1bit:T[o͍ċA񋟂ł(ɗL))
	                   0<<4 | 0;		// Res(3bit:gp̈) | RCode(4bit:G[Ȃ(0))
	*((UH *)(msg+4)) = 1;			// ̐ (16bit)
	*((UH *)(msg+6)) = 0;			// 񓚂̐ (16bit)
	*((UH *)(msg+8)) = 0;			// I[\eB̐ (16bit)
	*((UH *)(msg+10)) = 0;			// ǉ̐ (16bit)

	sprintf(msg+13,"%d.%d.%d.%d.in-addr.arpa", addr&0xff, (addr>>8)&0xff, (addr>>16)&0xff, (addr>>24)&0xff);

	st1 = msg+13;
	do{
		for(st2 = st1; *st2!='\0' && *st2!='.'; st2++) ;
		*(st1 - 1) = st2 - st1;
		st1 = st2+1;
	}while(*st2 != '\0');

	*st2++ = 0;	// kx
	*st2++ = 0;
	*st2++ = 12;	// QType ( PTR: hCXy[X̂ق̕ւ̃|C^ (12) )
	*st2++ = 0;
	*st2++ = 1;	// QClass ( IN:  C^[lbgVXe (1) )

	if ((int)(stat = udp_snd_dat(RESOLVER_CEPID, &dst, (VP)resolver_msg, st2-msg, TMO_FEVR)) < 0){
		syslog(LOG_NOTICE, "[getnamebyip] error: %s", itron_strerror(stat));
	}

receive:
	if ((int)(len = udp_rcv_dat(RESOLVER_CEPID, &dst, (VP)resolver_msg, 512, 1000)) >= 0) {
		if( ! msg[2]&0x80 ){
			syslog(LOG_NOTICE, "[getnamebyip] QR code is not proper");
			goto receive;
		}
		if( 0 != (msg[3]&0x0f) ){
			syslog(LOG_NOTICE, "[getnamebyip] R code is %d", msg[3]&0x0f);
		}
		syslog(LOG_NOTICE, "[getnamebyip] getipbyname: answer received");
		
		name[0] = '\0';
		if( decode_answer_iquery((UB *)resolver_msg, name) < 0 ) res=-1;
		
		if( res < 0 ){
			syslog(LOG_NOTICE, "[getnamebyip] getipbyname: failed");
		}else{
			syslog(LOG_NOTICE, "[getnamebyip] getipbyname:  %d.%d.%d.%d -> %s",
			                   (addr>>24)&0xff, (addr>>16)&0xff, (addr>>8)&0xff, addr&0xff, name);
		}

	}else{
		syslog(LOG_NOTICE, "[getnamebyip] error: %s", itron_strerror(len));

		udp_can_cep(RESOLVER_CEPID, TFN_UDP_RCV_DAT);	// YƁA̎sŎs
	}

	sig_sem( RESOLVER_SEM );

	return res;
}


