#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "mmc_io.h"
#include "vs1011e_io.h"
#include "spi.h"

/*
rW[Ԃ܂ł́ANbNo񐔂̏

ȏɂȂꍇA^CAEgG[ƂȂB

Ƃ2000AA-DATA512MB SDł͕ŝő
8000łAA-DATA1GB SDł͕ŝő
*/
#define BUSY_TIMEOUT	16000

/*
ݎAf[^X|Xg[N߂Ă܂ł
ǂݎ񐔂̏

ȏɂȂꍇA^CAEgG[ƂȂB

Ƃ100AA-DATA512MB SDł͕ŝő
*/
#define DRT_TIMEOUT	400


/*
----------------------------------------------------------------------

                    Low level I/O

----------------------------------------------------------------------
*/



/*
SPI1oCgf[^M

߂l: Mf[^
*/
UB spi_receive(void){
	UB res, c;


	while(1){
		c = SCI2.SSR.BYTE;
		// c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		if(c&0x20){
			syslog(LOG_NOTICE, "[SPI] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}

	sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xff);
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);

	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

	res = sil_reb_mem((VP)(H8SCI2 + H8RDR));
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;

	return res;
}


/*
MMCf[^M

:
	data: Mf[^obt@
	len:  Mf[^(oCgP)


߂l: ꍇ0Ԃ
*/
UB spi_receive_mmcblock(UB *data, UH len){		// UH == uint_16t
	UH j=0;
	UB c;

	while(1){
		c = SCI2.SSR.BYTE;
		// c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		if(c&0x20){
			syslog(LOG_NOTICE, "[MMC] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}

	do{
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xff);
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);
		
		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

		c = sil_reb_mem((VP)(H8SCI2 + H8RDR));
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x80) ) ;

		// ̕ŔȂꍇAG[Ƃď
		if(++j > BUSY_TIMEOUT) return 1;
	}while(c != 0xfe);		// data token for single/multi block read (@SD/MMC mem)


	for(j=0; j<len; j++){
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xff);
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);
		
		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

		*(data++) = sil_reb_mem((VP)(H8SCI2 + H8RDR));
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x80) ) ;
	}
	spi_send_clock();
	spi_send_clock();

	return 0;
}


/*
MMC1oCgf[^o

:
	dat: of[^
*/
void spi_transmit(UB dat){
	UB c;

	while(1){
		c = sil_reb_mem((VP)(H8SCI2 + H8SSR));

		if(c&0x20){
			syslog(LOG_NOTICE, "[SPI] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}

	sil_wrb_mem((VP)(H8SCI2 + H8TDR), dat);
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);


	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;

}

/*
f[^𑗐M

:
	data: Mf[^
	len:  Mf[^(oCgP)


߂l: ꍇ0Ԃ
*/
UB spi_transmit_block(UB *data, UH len){
	UH j;
	UB c;

	while(1){
		c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		// c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		if(c&0x20){
			syslog(LOG_NOTICE, "[MMC] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}

	for(j=0; j<len; j++){
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), *data); data++;
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);
		
		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;
	}

	return 0;
}


/*
MMCփf[^𑗐M

:
	data: Mf[^
	len:  Mf[^(oCgP)


߂l: ꍇ0Ԃ
*/
UB spi_transmit_mmcblock(UB *data, UH len, UB mode){		// UH == uint_16t
	UH j;
	UB c;

	while(1){
		c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		// c = sil_reb_mem((VP)(H8SCI2 + H8SSR));
		if(c&0x20){
			syslog(LOG_NOTICE, "[MMC] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}
	if( MMC_IO_TRANSMIT_SINGLE_BLOCK == mode){
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xfe);		// data token(single block write)
	}else if( MMC_IO_TRANSMIT_MULTI_BLOCK == mode){
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xfc);		// data token(multi block write)
	}

	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);
	
	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;

	for(j=0; j<len; j++){
		sil_wrb_mem((VP)(H8SCI2 + H8TDR), *data); data++;
		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);
		
		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

		sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

		while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;
	}
	spi_transmit(0xff);		// dummy CRC
	spi_transmit(0xff);		// dummy CRC

	// f[^EX|XEg[Ñ`FbN
	for(j=0; j<DRT_TIMEOUT; j++){
		c = spi_receive() & 0x1f;

		if(c==0x5) break;	// f[^͎󂯓ꂽ
		if(c==0xb) break;	// CRCG[̂߃f[^͋ۂꂽ
		if(c==0xd) break;	// CgEG[̂߃f[^͋ۂꂽ
	}

	if(c==0x5        ) return 0;
	if(j==DRT_TIMEOUT) return 0xff;

	return c;
}



/*
MMC8NbN𑗂
*/
void spi_send_clock(void){
	UB c;

	while(1){
		c = sil_reb_mem((VP)(H8SCI2 + H8SSR));

		if(c&0x20){
			syslog(LOG_NOTICE, "[MMC] overrun error.");
		}
		if(c&0x40){
			sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);
			continue;
		}
		if(c&0x80) break;
	}

	sil_wrb_mem((VP)(H8SCI2 + H8TDR), 0xff);
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x78);


	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x40) ) ;

	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0xb8);

	while(! (sil_reb_mem((VP)(H8SCI2 + H8SSR)) & 0x04) ) ;
}

/*
rW[Ԃ܂ŃNbN𑗏o

߂l:  0 ԂB
        ^CAEgƂɂ́AȊOԂB

*/
UB spi_mmcbusywait(void){
	
	UH i;
	UB c;

	for(i=0; i<BUSY_TIMEOUT; i++){
		c = spi_receive();
		// rW[ԂłMMC̏o͂0ɂȂĂ̂ŎMf[^0x00
		// 0ȊOɂȂƂɁArW[ꂽ
		if(c) return 0;
	}

	return 1;
}

UB spi_init(void){
	volatile UB i;

	// VIN ͋@푤猩̕Ȃ̂ŁA
	// }CRł͏o
	PBDDR = MMC_nCS | CLK | VIN | MMC_nCARDACTLED;

	PBDR.BYTE  = 0xff;

	// VS1011e̕ꏏɏȂƏo͂Ԃ
	PADR.BYTE = 0xff;
	PADDR     = VS1011E_nCS | VS1011E_nDCS | VS1011E_nRESET;
	PADR.BYTE = 0xff;


	//-------------------------------------------------------
	// SCI 
	sil_wrb_mem((VP)(H8SCI2 + H8SCR), 0x00);
	sil_wrb_mem((VP)(H8SCI2 + H8SCR), 0x00);	// MfB[[u 荞ݖgp SCKNbNo
	i = sil_reb_mem((VP)(H8SCI2 + H8SSR));
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x00);
	sil_wrb_mem((VP)(H8SCI2 + H8SCMR),0x08);	// SDIR=1 MSBt@[XgŎM
	sil_wrb_mem((VP)(H8SCI2 + H8BRR), 0x00);
	sil_wrb_mem((VP)(H8SCI2 + H8SMR), 0x80);
//	syslog(LOG_NOTICE, "[MMC] test.");

	for(i=0; i<200; i++) ;

	i = sil_reb_mem((VP)(H8SCI2 + H8SSR));
	sil_wrb_mem((VP)(H8SCI2 + H8SSR), 0x00);
	sil_wrb_mem((VP)(H8SCI2 + H8SCR), 0x30);	// MCl[u 荞ݖgp SCKNbNo
	//-------------------------------------------------------


}


