#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "tinet_app_config.h"
#include "ftpserv.h"
#include "tokenize.h"
#include "fat_api.h"
#include "util.h"
#include "telnet.h"
#include "exec.h"
#include "na2.h"

#define TIMEZONE	(-9*60*60)				// GMT ̐̕b

//extern T_IN4_ADDR  ipv4_addr;

UB telnet_cep_sbuf[N_TELNET_TASK][TELNET_CEP_SBUF_SIZE];
UB telnet_cep_rbuf[N_TELNET_TASK][TELNET_CEP_RBUF_SIZE];


/*

user , passwd Ƃɍő128ȓ


	file   : ݒǂݏot@C
	user   : [Ui[郁
	ulen   : ̑傫
	passwd : pX[hi[郁
	plen   : ̑傫


ꍇ 0 ԂB
-2 : file not found
-1 : syntax error

`(Rggp\)
--------------------------
user     ([UA󔒂Ȃǂꍇɂ""Ŋ)
password (pX[hA󔒂Ȃǂꍇɂ""Ŋ)
--------------------------

*/
B lookup_telnet_setting(const char *file, char *user, UB ulen, char *passwd, UB plen){
	B fd;
	B buf[16];
	UH token;
	UH  nval;

	*user=*passwd='\0';

	if( (fd = open(file, O_RDONLY)) < 0 ) return -2;

	while( (token = nextToken(fd, &nval, buf, sizeof(buf))) != TT_EOF ){
		if(token==TT_WORD && !strcmp(buf, "user")){
			if( nextToken(fd, &nval, user, ulen) != TT_WORD ) goto err;

		}else if(token==TT_WORD && !strcmp(buf, "password")){
			if( nextToken(fd, &nval, passwd, plen) != TT_WORD ) goto err;
		}else{
			goto err;
		}
	}

	close(fd);
	return 0;

err:
	close(fd);
	return -1;
}

/*
Ƃ 0 Ԃ
sƂ̐Ԃ

:
	pbuf T[õR}h
	tbuf obt@

	user [U
*/
B telnet_check_passwd(B *user, B *passwd){
	B  res, i;
	B rd_user[17];
	B rd_passwd[17];

	rd_user[0] = rd_passwd[0] = 0;

	res = lookup_telnet_setting( TELNET_PASSWD_PATH, rd_user, sizeof(rd_user)-1, rd_passwd, sizeof(rd_passwd)-1 );
	
	
	res = (res == 0) &&
	      (! strcmp(user, rd_user)) &&
	      (! strcmp(passwd, rd_passwd));

	// ꉞAŜ߂ɏ
	for(i=0; i<sizeof(rd_passwd); i++) rd_passwd[i] = 0;

	return res ? 0 : -1;
}

H readline(ID cepid, UB *buf, UH length, B echo){
	H res=0, len=0;

	B env_echo = 0;
	char *c;

	if( (c=get_env("ECHO")) != NULL ){
		if( *c == '1' ) env_echo = 1;
	}

	while( (length-1 > 0) && (res = tcp_rcv_dat(cepid, buf, 1, TELNET_WAIT_TIMEOUT)) > 0 ){

		if( *buf == 0xff ){
			// 2 oCg
			if( (res = tcp_rcv_dat(cepid, buf, 1, TELNET_WAIT_TIMEOUT)) < 0 ) break;

			if( *buf == 250 ){	// SB
				// TuIvVlSVG[V

				while( *buf != 240 ){
					if( (res = tcp_rcv_dat(cepid, buf, 1, TELNET_WAIT_TIMEOUT)) < 0 ) goto exit;
				}

			}else if( *buf == 253 ){// DO
				// 3 oCg
				if( (res = tcp_rcv_dat(cepid, buf, 1, TELNET_WAIT_TIMEOUT)) < 0 ) break;
				
				if( *buf == 1 ){// echo
					// IAC DO echo
					set_env("ECHO", "1"); env_echo = 1;
				}
			}else{
				// 3 oCg
				if( (res = tcp_rcv_dat(cepid, buf, 1, TELNET_WAIT_TIMEOUT)) < 0 ) break;
			}

			continue;
		}

		if( env_echo ){
			if( echo ){
				send_data(cepid, buf, 1);
				if( *buf == '\r' ){
					send_data(cepid, "\n", 1);
				}
			}
		}

		if( *buf == '\n' ){  continue; }
		if( *buf == 0    ){  continue; }	// NUL (Ȃ)

		len++; length--;

		if( *buf++ == '\r' ) break;
	}

	exit:

	if (res < 0){
		syslog(LOG_NOTICE, "[TELNET RCV] error: %s", itron_strerror(res));
		return -1;
	}

	*buf = '\0';	// ^[~l[g

	return len;
}


void
telnet_task(VP_INT exinf){

	ID cepid = (int)exinf;

	UB count = 0;

	UB tbuf[512];
	UB addr[sizeof("123.123.123.123")];
	UW exec_buff[TELNET_EXEC_BUFSIZE/4];		// ACglUWŊm

	char user[16], *s;
	char* argv[3];

	T_IPV4EP dst;
	ID	tskid;
	ER	error = E_OK;
	struct program_io pio;
	W	res;

	struct env e[5];
	char echo[5];
	char pwd[128];

	sprintf(echo, "0");
	sprintf(pwd,  "/");

	e[0].name = "ECHO"; e[0].val=echo; e[0].maxvalsize = sizeof(echo);
	e[1].name = "PWD" ; e[1].val=pwd;  e[1].maxvalsize = sizeof(pwd);
	e[2].name = NULL  ; e[2].val=NULL; e[2].maxvalsize = -1;

	install_env(e);


	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TELNET:%d,%d] started.", tskid, cepid);

waitconnection:

	if (tcp_acp_cep(cepid, TCP_TELNET_REPID, &dst, TMO_FEVR) != E_OK) {
		syslog(LOG_NOTICE, "[TELNET ACP] error: %s", itron_strerror(error));
		goto waitconnection;
	}

	ip2str(addr, &dst.ipaddr);
	syslog(LOG_NOTICE, "[TELNET ACP] connected from %s:%d", addr, dst.portno);

	sprintf(tbuf, "Network Appliance 2. \r\n");
	send_data(cepid, tbuf, strlen(tbuf));

	user[0] = '\0';		// [UNA
	count = 0;

	sprintf(echo, "0");	// ϐNA
	sprintf(pwd,  "/");

	while(TRUE){
		if( ++count == 3 ) goto err_fin;

		//--------------------------------------------------------------
		sprintf(tbuf, "\r\nlogin: ");
		send_data( cepid, tbuf, strlen(tbuf));

		if( readline(cepid, user, sizeof(user), 1) < 0) goto err_fin;
		
		if( (s=strchr(user, '\n')) != NULL ) *s = '\0';
		if( (s=strchr(user, '\r')) != NULL ) *s = '\0';

		//--------------------------------------------------------------
		sprintf(tbuf, "\r\npassword: \033[8m");
		send_data( cepid, tbuf, strlen(tbuf));

		if( readline(cepid, tbuf, sizeof(tbuf), 0) < 0) goto err_fin;
		if( (s=strchr(tbuf, '\n')) != NULL ) *s = '\0';
		if( (s=strchr(tbuf, '\r')) != NULL ) *s = '\0';

		send_data( cepid, "\033[0m\r\n", strlen("\033[0m\r\n"));

		if( telnet_check_passwd(user, tbuf) < 0 ){
			dly_tsk(5000);
			continue;
		}

		sprintf(tbuf, "Telnet Access from %s, login succeed (USER %s)\n", addr, user);
		systemlog(tbuf);

		//--------------------------------------------------------------

		argv[0] = TELNET_SHELL_PATH;			// 0 : st@C
		argv[1] = NULL;

		// W, Wo, WG[o: ڑ
		pio.io_mux_in = pio.io_mux_out = pio.io_mux_err = EXEC_IO_NETWORK;
		pio.std_in    = pio.std_out    = pio.std_err    = cepid;


		exec(TELNET_SHELL_PATH, (UB *)exec_buff, TELNET_EXEC_BUFSIZE, &pio, 1, argv, &res);

		goto fin;
	}

err_fin:
	sprintf(tbuf, "Telnet Access from %s, login failed\n", addr);
	systemlog(tbuf);

fin:

	if ((error = tcp_sht_cep(cepid)) != E_OK)
		syslog(LOG_NOTICE, "[TELNET SHT] error: %s", itron_strerror(error));

	if ((error = tcp_cls_cep(cepid, TMO_FEVR)) != E_OK)
		syslog(LOG_NOTICE, "[TELNET CLS] error: %s", itron_strerror(error));

	syslog(LOG_NOTICE, "[TELNET] Connection closed");

	goto waitconnection;
}
