#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>
#include <netapp/netapp_var.h>


extern T_IN4_ADDR  ipv4_addr;
extern T_IN4_ADDR  ipv4_addr_mask;
extern T_IN4_ADDR  ipv4_addr_default_gw;
extern T_IN4_ADDR  ipv4_addr_nameserver;


void get_ip_setting(T_IN4_ADDR *ip, T_IN4_ADDR *mask, T_IN4_ADDR *gw, T_IN4_ADDR *ns){
	*ip   = ipv4_addr;
	*mask = ipv4_addr_mask;
	*gw   = ipv4_addr_default_gw;
	*ns   = ipv4_addr_nameserver;
}

int send_data(ID cepid, UB *buffer, INT rlen){
	int soff = 0, slen;

	while (rlen > 0) {
		if ((slen = tcp_snd_dat(cepid, &buffer[soff], rlen, TMO_FEVR)) < 0) {
			syslog(LOG_NOTICE, "[TCP SND] error: %s", itron_strerror(slen));
			return 0;
		}
		rlen -= slen;
		soff += slen;
	}

	return soff;
}

/*

length mۂĂoCg
*/
void get_cgi_value(char *str, char *prop, char *val, UH length){
	UH i=0;
	UH proplen = strlen(prop);
	UB *rep;
	UB v;

	*val = '\0';
	rep  = val;

	do{
		if( (! strncmp(str, prop, proplen)) && str[proplen]== '=' ){
			str += proplen+1;
			for(i=0; (i<length-1) && *str !='\0' && *str !='&'; str++,i++){
				val[i] = *str;
			}
			val[i] = '\0';
			
			break;
		}else{
			for( ; *str!='\0' && *str!='&'; str++) ;
			if( *str == '&' ) str++;
		}
	}while(*str!='\0');

	val = rep;

	for( ;*val!='\0'; val++){
//		syslog(5, "rep 0x%x %c buf 0x%x %c", rep, *rep, buf, *buf);

		if(*val!='%'){
			*rep++ = (*val != '+') ? *val : ' ';
			continue;
		}

		if(!(   ('0' <= val[1] && '9' >= val[1])
		     || ('a' <= val[1] && 'f' >= val[1])
		     || ('A' <= val[1] && 'F' >= val[1])) ) continue;

		if(!(   ('0' <= val[2] && '9' >= val[2])
		     || ('a' <= val[2] && 'f' >= val[2])
		     || ('A' <= val[2] && 'F' >= val[2])) ) continue;

		v = ('0' <= val[1] && '9' >= val[1]) ? (val[1] - '0'    )<<4 : 0;
		v+= ('a' <= val[1] && 'f' >= val[1]) ? (val[1] - 'a' +10)<<4 : 0;
		v+= ('A' <= val[1] && 'F' >= val[1]) ? (val[1] - 'A' +10)<<4 : 0;

		v+= ('0' <= val[2] && '9' >= val[2]) ? (val[2] - '0'    ) : 0;
		v+= ('a' <= val[2] && 'f' >= val[2]) ? (val[2] - 'a' +10) : 0;
		v+= ('A' <= val[2] && 'F' >= val[2]) ? (val[2] - 'A' +10) : 0;
		
		*rep++ = v;
		val+=2;
	}

	*rep = '\0';
}
