#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include "spi.h"
#include "vs1011e_io.h"


B vs1011e_spi_speed=4;

#define BBR_SLOW	({sil_wrb_mem((VP)(H8SCI2 + H8BRR), 4); })
#define BBR_MID		({sil_wrb_mem((VP)(H8SCI2 + H8BRR), vs1011e_spi_speed); })
#define BBR_FAST	({sil_wrb_mem((VP)(H8SCI2 + H8BRR), 0x00); })

void sci_write(UB addr, UH dat)
{

	wai_sem( SPI_SEM );
	BBR_SLOW;
	VS1011E_ENABLE_CS;

	spi_transmit(0x02);
	spi_transmit(addr);
	spi_transmit(dat>>8);
	spi_transmit(dat);

	VS1011E_DISABLE_CS;

	// oX̊JɕKv?
	spi_send_clock();

	BBR_FAST;
	sig_sem( SPI_SEM );

}

UH sci_read(UB addr)
{
	UH dat;

	wai_sem( SPI_SEM );
	BBR_SLOW;
	VS1011E_ENABLE_CS;

	spi_transmit(0x03);
	spi_transmit(addr);
	dat  = ((UH)spi_receive())<<8;
	dat |= ((UH)spi_receive());

	VS1011E_DISABLE_CS;


	// oX̊JɕKv?
	spi_send_clock();


	BBR_FAST;
	sig_sem( SPI_SEM );

	return dat;
}

void sdi_write(UB s)
{
	wai_sem( SPI_SEM );
	BBR_MID;
	VS1011E_ENABLE_DCS;

	spi_transmit( s );

	VS1011E_DISABLE_DCS;


	// oX̊JɕKv?
	spi_send_clock();


	BBR_FAST;
	sig_sem( SPI_SEM );
}

void sdi_write_block(B *buf, UH size)
{
	UH i;



	for(i=0; i<size;){
		if( VS1011E_STAT_DREQ ){

			wai_sem( SPI_SEM );
			BBR_MID;
			VS1011E_ENABLE_DCS;

		send:
			if( i+32 <= size ){
				spi_transmit_block( buf+i, 32 );
				i+= 32;
			}else{
				spi_transmit_block( buf+i, size - i );
				i = size;
			}

			if( VS1011E_STAT_DREQ && (i < size) ) goto send;

			VS1011E_DISABLE_DCS;

			// oX̊JɕKv?
			spi_send_clock();

			BBR_FAST;
			sig_sem( SPI_SEM );

		}else{
			dly_tsk(2);
		}
	}
}


void vs1011e_accessInit(void){

	volatile UH i;

	PADR.BYTE = 0xff;
	PADDR     = VS1011E_nCS | VS1011E_nDCS | VS1011E_nRESET;
	PADR.BYTE = 0xff;

	VS1011E_ENABLE_RESET;
	for(i=0; i<200; i++) ;
	VS1011E_DISABLE_RESET;

//	SPCR = _BV(SPE) | _BV(MSTR) | _BV(CPOL) | _BV(CPHA) | 1;	// VS1011̃NbN2{܂łSPIx߂ (fosc/8)
//	SPSR = 0;

	for(i=0; i<200; i++) ;

	sci_write(0, 0xffff);
	for(i=0; i<200; i++) ;

	sci_write(0, 0x0802);

#if VS1011E_CLOCK < 13000000
	sci_write(3, 0x8000 + (int)(VS1011E_CLOCK/2000));	// VS1011e̔Uq12-13 MHz ̏ꍇ
#else
	sci_write(3,          (int)(VS1011E_CLOCK/2000));	// VS1011e̔Uq24-26 MHz ̏ꍇ
#endif
/*
	sci_write(11, 0x2020);		// volume ݒ(ʍŏ)
	sci_read(11);

	for(i=0; i<2000; i++) ;
*/

#if CPU_CLOCK < 24000000
	vs1011e_spi_speed = 0;
#else
	vs1011e_spi_speed = 1;
#endif

}

