#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>
#include <netapp/netapp_var.h>


#include "mmc_io.h"
#include "fat_api.h"
#include "vs1011e_io.h"
#include "vs1011e_access.h"
#include "vs1011e_app.h"
#include "util.h"

UB tcp_iradio_cep_sbuf[TCP_IRADIO_CEP_SBUF_SIZE];
UB tcp_iradio_cep_rbuf[TCP_IRADIO_CEP_RBUF_SIZE];


#define MAX_VOLUME		0x05		// lقǉ傫


#define CMD_PLAY		10
#define CMD_PLAY_SC		11
#define CMD_STOP		20
#define CMD_PAUSE		30


struct vs1011e_autoplay_msg{
	T_MSG	pk_msg;
	ID	tid;
	B	cmd;
	char	path[64];
};

struct vs1011e_ctrl_msg{
	T_MSG	pk_msg;
	ID	tid;
	T_IN4_ADDR addr;
	UW	port;
	UW	playid;
	B	cmd;
	char	fname[64];
};

struct vs1011e_data_msg{
	T_MSG	pk_msg;
	UH	count;
	UB	isfree;
	UB	data[MSG_BUF_SIZE];
};

extern T_IN4_ADDR  ipv4_addr;


B close_musicstream(void){
	ER	stat = E_OK;

	if( (stat=tcp_can_cep(TCP_IRADIO_CEPID, TFN_TCP_ALL)) != E_OK)
		syslog(LOG_NOTICE, "[close_shoutcast CAN] error: %s", itron_strerror(stat));

	if( (stat = tcp_sht_cep(TCP_IRADIO_CEPID)) != E_OK)
		syslog(LOG_NOTICE, "[close_shoutcast SHT] error: %s", itron_strerror(stat));

	if( (stat = tcp_cls_cep(TCP_IRADIO_CEPID, 1000)) != E_OK)
		syslog(LOG_NOTICE, "[close_shoutcast CLS] error: %s", itron_strerror(stat));

	return 0;
}

#define STREAM_SHOUTCAST	2
#define STREAM_HTTP		1


B open_musicstream(T_IN4_ADDR addr, UW port, char *dir){
	T_IPV4EP myaddr;
	T_IPV4EP dstaddr;
	ER	stat = E_OK;
	UH	retry = 0;

	static B shoutcast_snd_buf[1024];
	static B shoutcast_rcv_buf[1024];

restart:

	myaddr.ipaddr  = 0;
	myaddr.portno  = 0;

	dstaddr.ipaddr = addr;
	dstaddr.portno = port;

	sprintf(shoutcast_snd_buf, "GET %s HTTP/1.1\r\n"  \
	             "Host: %d.%d.%d.%d\r\n"
	             "Accept: */*\r\n\r\n", dir, (addr>>24)&0xff, (addr>>16)&0xff, (addr>>8)&0xff, (addr>>0)&0xff);


	// ڑv(\I[v)
	if ((stat=tcp_con_cep(TCP_IRADIO_CEPID, &myaddr, &dstaddr, 500)) != E_OK) {
		syslog(LOG_NOTICE, "[open_shoutcast CON] error: %s", itron_strerror(stat));

		tcp_can_cep(TCP_IRADIO_CEPID, TFN_TCP_CON_CEP);

		if( retry++ < 3 ) goto restart;

		return -1;
	}

	if( send_data(TCP_IRADIO_CEPID, (UB *)shoutcast_snd_buf, strlen(shoutcast_snd_buf)) <= 0 ){
		if( (stat = tcp_can_cep(TCP_IRADIO_CEPID, TFN_TCP_ALL)) != E_OK)
			syslog(LOG_NOTICE, "[open_shoutcast CAN] error: %s", itron_strerror(stat));

		if( (stat = tcp_sht_cep(TCP_IRADIO_CEPID)) != E_OK)
			syslog(LOG_NOTICE, "[open_shoutcast SHT] error: %s", itron_strerror(stat));

		if( (stat = tcp_cls_cep(TCP_IRADIO_CEPID, 1000)) != E_OK)
			syslog(LOG_NOTICE, "[open_shoutcast CLS] error: %s", itron_strerror(stat));

		if( retry++ < 3 ) goto restart;

		return -1;
	}
	if( (stat=tcp_rcv_dat(TCP_IRADIO_CEPID, shoutcast_rcv_buf, sizeof(shoutcast_rcv_buf)-1, 2*1000)) < 0 ){
		syslog(LOG_NOTICE, "[open_shoutcast RCV] receiv error %s", itron_strerror(stat));
		close_musicstream();

		if( retry++ < 3 ) goto restart;

		return -1;
	}else{
		shoutcast_rcv_buf[stat] = '\0';
		if( 0 == strncmp("ICY 200 OK", shoutcast_rcv_buf, sizeof("ICY 200 OK")-1) ){	// sizeof͍Ō'\0'܂ނ̂1
			// SHOUTcast ̏ꍇ
			return STREAM_SHOUTCAST;
		}else{
			syslog(LOG_NOTICE, "[open_shoutcast] not shoutcast protocol");
			if( NULL==strstr(shoutcast_rcv_buf, "audio/mp3"  ) &&
			    NULL==strstr(shoutcast_rcv_buf, "audio/mpeg" ) &&
			    NULL==strstr(shoutcast_rcv_buf, "audio/mpg"  ) &&
			    NULL==strstr(shoutcast_rcv_buf, "audio/x-mp3") &&
			    NULL==strstr(shoutcast_rcv_buf, "audio/x-mpg")){
				syslog(LOG_NOTICE, "[open_shoutcast] not mp3 stream");
				close_musicstream();
				return -2;
			}else{
				// HTTP MP3ĂĂ
				return STREAM_HTTP;
			}
		}
	}

	return 0;
}

void vs1011e_streamout(VP_INT exinf){
	struct vs1011e_data_msg *msg;

	while(1){
		if( rcv_mbx(VS1011E_DATA_MBX, (T_MSG **)&msg) != E_OK ) continue;
		
		if(msg->isfree)   continue;
		if(msg->count!=0) sdi_write_block(msg->data, msg->count);
		msg->isfree = 1;
	}

}

/*
lbg[NoRŃXg[~OĐƂ̎MPʗ
*/
#define RECV_BLOCKSIZE 2000

/*
VS1011e ̃obt@Ô߂̃bZ[W̐
(obt@ / 1̃bZ[Wł̃obt@)
*/
#define N_MSG_BUF	(VS1011E_BUFSIZE/MSG_BUF_SIZE)

/*
vs1011e_playōĐt@C܂ĐȂׂ̂邽߂ɁA
play ID Ƃ@\gB

vs1011e_play̖߂lœꂽplay ID 
Đ̊Ԓۂ vs1011e_getplayID ŊmF邱ƂłB

ĐĂȂƂ-1AĐĂƂplay ID  1 ȏƂȂ
*/
static W npid = 1;		// Play ID
static W ppid = -1;		// ݍĐPlay ID

/*
Ȃ̋fɂ́AVS1011eɘA0̃f[^𑗐MKvB
(ȂƁA̍ĐɃmCY)
A0𑗏o邽߂̐pbZ[WpӂB
*/
static struct vs1011e_data_msg 	blanc_data_msg;


void vs1011e_clear_streambuff(struct vs1011e_data_msg data_msg[]){
	W i;

	for(i=0; i<N_MSG_BUF; i++) data_msg[i].count = 0;

	blanc_data_msg.isfree = 0;
	snd_mbx(VS1011E_DATA_MBX, (T_MSG *)&blanc_data_msg);
}



#define PROCESS_AT_STOP		1
#define PROCESS_AT_PLAYING	2

B vs1011e_process_messages(B mode, struct vs1011e_ctrl_msg *msg, B *fd, B *iradio, B *pause, T_IN4_ADDR *addr, UW *port, char *url, UH url_length, struct vs1011e_data_msg data_msg[]){
	B fdt;
	W i;


	if(msg->cmd == CMD_PLAY){
		if( mode == PROCESS_AT_STOP ){
			if( *pause && !(*iradio) ) close(*fd);

			*fd = open(msg->fname, O_RDONLY);

		}else if( mode == PROCESS_AT_PLAYING ){
			if( (fdt = open(msg->fname, O_RDONLY)) < 0) return 0;

			if(*iradio) close_musicstream();
			else        close(*fd);

			*fd=fdt;
			vs1011e_clear_streambuff(data_msg);
		}
		ppid = msg->playid = (*fd>=0) ? npid++ : -1;
		*pause = *iradio = 0;

	}if(msg->cmd == CMD_PLAY_SC){
		if( mode == PROCESS_AT_STOP ){
			if(*pause&& !(*iradio)) close(*fd);

		}else if( mode == PROCESS_AT_PLAYING ){
			if(*iradio) close_musicstream();
			else        close(*fd);

			vs1011e_clear_streambuff(data_msg);
		}

		*addr = msg->addr;
		*port = msg->port;
		for(i=0; i < url_length; i++) url[i] = msg->fname[i];
		url[url_length - 1] = '\0';

		*fd = -1;
		*pause = 0;
		*iradio = open_musicstream(*addr, *port, url);
		if( *iradio < 0 ) *iradio = 0;
		ppid = msg->playid = (*iradio) ? npid++ : -1;

	}else if(msg->cmd == CMD_PAUSE){
		if( mode == PROCESS_AT_STOP ){
			if( *iradio ){
				if( *pause ) *iradio = open_musicstream(*addr, *port, url);
				if( *iradio < 0 ) *iradio = 0;
			}else{
				*fd = (pause) ? *fd : -1;
			}
			*pause = 0;
		}else if( mode == PROCESS_AT_PLAYING ){
			if( *iradio ) close_musicstream();

			vs1011e_clear_streambuff(data_msg);

			*pause = 1;
		}
		msg->playid = ppid;

	}else if(msg->cmd == CMD_STOP){
		if( mode == PROCESS_AT_STOP ){
			if(*pause && !(*iradio))  close(*fd);
		}else if( mode == PROCESS_AT_PLAYING ){
			if( *iradio ) close_musicstream();
			else          close(*fd);

			vs1011e_clear_streambuff(data_msg);
		}
		*fd = -1;
		*pause = *iradio = 0;
		msg->playid = ppid;
		ppid = -1;
	}

	return 0;
}





void vs1011e_ctrl (VP_INT exinf){
	B fd;
	W count=0, i;
	B pause = 0, iradio=0;
	T_IN4_ADDR addr;
	UW port, vsize;
	char url[64];


	struct vs1011e_ctrl_msg *msg;
	struct vs1011e_data_msg data_msg[N_MSG_BUF];

	for(i=0; i<N_MSG_BUF; i++) data_msg[i].isfree = 1;

	//--------------------------------------------
	// Ȃ̋fɑ}0f[^p̃bZ[W
	for(i=0; i<MSG_BUF_SIZE; i++){
		blanc_data_msg.data[i] = 0;
	}
	blanc_data_msg.count = MSG_BUF_SIZE;
	//--------------------------------------------


	while(1){
		syslog(LOG_NOTICE, "[VS1011E_CTRL] Start");
		if( rcv_mbx(VS1011E_CTRL_MBX, (T_MSG **)&msg) != E_OK) continue;

		syslog(LOG_NOTICE, "[VS1011E_CTRL] receive msg from %d", msg->tid);


		vs1011e_process_messages(PROCESS_AT_STOP, msg, &fd, &iradio, &pause, &addr, &port, url, sizeof(url), data_msg);

		wup_tsk(msg->tid);

		if( fd < 0 && !iradio) continue;

		do{
			// SD̃t@CĐ̓obt@炷
			UW limit = (iradio) ? N_MSG_BUF : N_MSG_BUF/3;

			for(i=0; i<limit; i++){
				if( ! data_msg[i].isfree ) continue;
				if(! iradio){
					count = data_msg[i].count =
						read(fd, data_msg[i].data, sizeof(data_msg[i].data));
				}else{
					
					for(vsize=0 ; vsize <= MSG_BUF_SIZE - RECV_BLOCKSIZE; vsize+= count){
						count = tcp_rcv_dat(TCP_IRADIO_CEPID, (data_msg[i].data)+vsize, RECV_BLOCKSIZE, 2*1000);
						if(count < 0){
							syslog(LOG_NOTICE, "[VS1011E_CTRL] receiv error %s", itron_strerror(count));
							close_musicstream();
							count = 0;
							if( iradio==STREAM_SHOUTCAST && open_musicstream(addr, port, url) >= 0 ){
								count = 0;
								continue;
							}
							break;
						}
					}
					data_msg[i].count = vsize;
				}

				if(data_msg[i].count > 0){
					data_msg[i].isfree = 0;
					snd_mbx(VS1011E_DATA_MBX, (T_MSG *)&data_msg[i]);
				}
				if(count <= 0) break;
			}


			if( trcv_mbx(VS1011E_CTRL_MBX, (T_MSG **)&msg, iradio ? 1 : 10 ) == E_OK){
				vs1011e_process_messages(PROCESS_AT_PLAYING, msg, &fd, &iradio, &pause, &addr, &port, url, sizeof(url), data_msg);

				wup_tsk(msg->tid);
			}
		}while(count > 0 && !pause && !(fd < 0 && !iradio));

		syslog(LOG_NOTICE, "[VS1011E_CTRL] fin fd:%d iradio:%d pause:%d", fd, iradio, pause);

		if(! pause ){
			// ʏ̍ĐI(stopȂǂĂȂƂ)ł͂܂ ppid -1ɂȂĂȂB
			ppid = -1;

			if( fd >= 0 ){
				close(fd);
				fd = -1;
			}
			if( iradio ){
				close_musicstream();
				iradio = 0;
			}
		}
	}
}

B vs1011e_check_mp3file(char *fname){

	if( NULL != strstr(fname, ".MP3") ) return 0;
	if( NULL != strstr(fname, ".mp3") ) return 0;

	return -1;
}

B vs1011e_get_filesequence(char *fname){
	B i = -1;

	if( fname[0]>='0' && fname[0]<='9' ){
		i= fname[0]-'0';
		if( fname[1]>='0' && fname[1]<='9' ){
			i=i*10+fname[1]-'0';
			if( fname[2]>='0' && fname[2]<='9' ){
				i=i*10+fname[2]-'0';
			}
		}
	}

	return i;
}

B vs1011e_get_filerange(H *min, H *max, char *path){
	H i;
	DIR *dir;
	dirent *entry;

	*min = 1000;
	*max = -1;

	dir = opendir(path);
	while( (entry=readdir(dir)) != NULL ){
		// fBNg̏ꍇ͔΂
		if( entry->attr&0x10 ) continue;

		i = vs1011e_get_filesequence(entry->d_name);

		if( i >= 0 ){
			*min = (*min > i)? i : *min;
			*max = (*max < i)? i : *max;
		}
	}
	closedir(dir);

	return 0;
}

#define PLAY_DIR_LEVEL 3

B vs1011e_lookupnext_file(B mode, H *min, H *max, H *cur, char *path, UB *depth, char *fname){
	DIR *dir;
	dirent *entry;
	char *str;

	if( *cur == -1  ) fname[0] = '\0';
//	if( *cur > *max ) fname[0] = '\0';

	if(*path != '/') return -1;

restart:
	syslog(LOG_NOTICE, "[VS1011E_AUTOPLAY_MGR] path %s depth %d cur %d max %d", path, *depth, *cur, *max);
//	dly_tsk(1000);

	if( *cur == -1 ){
		if( (dir = opendir(path)) == NULL ) return -1;
		while( (entry=readdir(dir)) != NULL ){

			if( (entry->attr&0x10) && (entry->d_name[0] != '.') ){	// fBNgƐefBNg͒TȂ悤ɂ
				// fBNg̏ꍇ
	
				if(*depth >= PLAY_DIR_LEVEL) continue;
				
				if(path[1]!='\0') strcat(path, "/");
				strcat(path, entry->d_name);
				(*depth)++;

				closedir(dir);
				fname[0]='\0';
				goto restart;
			}
		}
		closedir(dir);

		vs1011e_get_filerange(min, max, path);
		*cur = 0;
		fname[0]='\0';
		goto restart;

	}else if(*cur <= *max){
		if( (dir = opendir(path)) == NULL ) return -1;

		while( (entry=readdir(dir)) != NULL ){
			if( (entry->attr&0x10) ) continue ;
			
			if( vs1011e_check_mp3file(entry->d_name) < 0 ) continue;  // MP3t@CȂꍇ΂
			
			if( vs1011e_get_filesequence(entry->d_name) == *cur ){
				strcpy(fname, entry->d_name);
				closedir(dir); (*cur)++; return 0;
			}
		}
		closedir(dir);
		(*cur)++; goto restart;

	}else if(*max < *cur){
		if( (dir = opendir(path)) == NULL ) return -1;

		while( (entry=readdir(dir)) != NULL ){
			if( entry->attr&0x10 ) continue;
			if( fname[0] != '\0' && !(fname[0]>='0'&&fname[0]<='9') ){
				if( 0 != strcmp(entry->d_name, fname) ) continue;
				if( (entry=readdir(dir)) == NULL ){
					closedir(dir);
					break;
				}
			}

			// ɍĐt@CT
			do{
				if( (entry->attr&0x10) ) continue ;
				if( vs1011e_check_mp3file(entry->d_name) < 0 ) continue;  // MP3t@CȂꍇ΂
				if( entry->d_name[0] >= '0' && entry->d_name[0] <= '9' ) continue;

				break;
			}while( (entry=readdir(dir)) != NULL );
			closedir(dir);
			if( entry == NULL ) break;
			
			// t@C
			strcpy(fname, entry->d_name);
			return 0;
		}

		// t@CȂꍇ̓obNgbN

		if( *depth == 0 ) return 1;	// obNgbNłȂ

		(*depth) --;

		str = strrchr(path,'/') + 1;
		if( str-1 == path ){
			dir = opendir("/");
		}else{
			*(str-1) = '\0';
			dir = opendir(path);
		}

		while( (entry=readdir(dir)) != NULL ){
			if( !(entry->attr&0x10) || entry->d_name[0]=='.' || 0 != strcmp(entry->d_name, str) ) continue ;

			// ɍĐfBNgT
			while( (entry=readdir(dir)) != NULL ){
				if( !(entry->attr&0x10) ) continue ;
				break;
			}
			if( entry == NULL ) break;

			// ɍĐfBNg
			(*depth)++; closedir(dir);

			if( str-1 == path ) sprintf(path, "/%s", entry->d_name);
			else{ strcat (path, "/"); strcat (path, entry->d_name); }

			*cur = -1;
			fname[0]='\0';
			goto restart;
		}
		closedir(dir);
		// ЂƂ̃fBNg̃t@CT
		if( str-1 == path ) sprintf(path, "/");

		vs1011e_get_filerange(min, max, path);
		*cur = 0;
		fname[0]='\0';
		goto restart;
	}

	return -1;
}



void vs1011e_autoplay_mgr (VP_INT exinf){

	struct vs1011e_autoplay_msg *msg;
	W playid = 0;
	B mode = 0, ret;
	B path[256];
	B fname[NAME_MAX+1];

	H  min, max, cur;
	UB depth=0;
	
	while(1){
		if( trcv_mbx(VS1011E_AUTOPLAY_MBX, (T_MSG **)&msg, 200) == E_OK){
			if( msg->cmd == CMD_STOP ){
				mode = 0;
			}else if(msg->cmd == CMD_PLAY ){
				mode = 1;
				strcpy(path, msg->path);
				cur = -1;
				depth = 0;
			}
			wup_tsk(msg->tid);
		}


		if( vs1011e_getplayID() < 0 && mode == 1){
			ret = vs1011e_lookupnext_file(0, &min, &max, &cur, path, &depth, fname);

			if( 1 == ret || ret < 0 ){
				mode = 0;
			}else{
				H len = strlen(path);

				strcat(path, "/");
				strcat(path, fname);

				syslog(LOG_NOTICE, "[VS1011E_AUTOPLAY_MGR] playing %s", path);

				vs1011e_play(path);

				path[len] = '\0';
			}
		}
	}
}


W vs1011e_getplayID(void){
	return ppid;
}

W vs1011e_stop(void){
	struct vs1011e_ctrl_msg msg;
	struct vs1011e_autoplay_msg msga;

	msg.cmd = msga.cmd = CMD_STOP;
	get_tid(&(msg.tid));
	msga.tid = msg.tid;

	msg.fname[0] = msga.path[0] = '\0';

	snd_mbx(VS1011E_CTRL_MBX, (T_MSG *)&msg);

	slp_tsk();

	snd_mbx(VS1011E_AUTOPLAY_MBX, (T_MSG *)&msga);

	slp_tsk();

	return msg.playid;
}

W vs1011e_skip(void){
	struct vs1011e_ctrl_msg msg;

	msg.cmd = CMD_STOP;
	get_tid(&(msg.tid));

	msg.fname[0] = '\0';

	snd_mbx(VS1011E_CTRL_MBX, (T_MSG *)&msg);

	slp_tsk();

	return msg.playid;
}

W vs1011e_pause(void){
	struct vs1011e_ctrl_msg msg;

	msg.cmd = CMD_PAUSE;
	get_tid(&(msg.tid));

	msg.fname[0]='\0';

	snd_mbx(VS1011E_CTRL_MBX, (T_MSG *)&msg);

	slp_tsk();

	return msg.playid;
}

W vs1011e_play(char *fname){
	UH i;
	struct vs1011e_ctrl_msg msg;

	msg.cmd = CMD_PLAY;
	get_tid(&(msg.tid));

	for(i=0; i<sizeof(msg.fname)-1; i++){
		msg.fname[i] = fname[i];
	}
	msg.fname[i]='\0';

	snd_mbx(VS1011E_CTRL_MBX, (T_MSG *)&msg);

	slp_tsk();

	return msg.playid;
}

W vs1011e_autoplay(char *dir){
	UH i;
	struct vs1011e_autoplay_msg msg;

	msg.cmd = CMD_PLAY;
	get_tid(&(msg.tid));

	for(i=0; i<sizeof(msg.path)-1; i++){
		msg.path[i] = dir[i];
	}
	msg.path[i]='\0';

	snd_mbx(VS1011E_AUTOPLAY_MBX, (T_MSG *)&msg);

	slp_tsk();

	return 0;
}

W vs1011e_play_shoutcast(T_IN4_ADDR addr, UW port, char *fname){
	UH i;
	struct vs1011e_ctrl_msg msg;

	msg.cmd = CMD_PLAY_SC;
	get_tid(&(msg.tid));

	for(i=0; i<sizeof(msg.fname)-1; i++){
		msg.fname[i] = fname[i];
	}
	msg.fname[i]='\0';
	msg.addr = addr;
	msg.port = port;

	snd_mbx(VS1011E_CTRL_MBX, (T_MSG *)&msg);

	slp_tsk();

	return msg.playid;
}

/*

*/
void vs1011e_setVolume(UH vol){
	volatile UH i;
	sci_write(11, vol);		// volume ݒ
	for(i=0; i<2000; i++) ;
}

UH vs1011e_getVolume(void){
	volatile UH i;
	UH vol = sci_read(11);

	for(i=0; i<2000; i++) ;
	return vol;
}


/*

	SO	PB4 (MISO)
	SI	PB3 (MOSI)
	SCLK	PB5 (SCK)
	XCS	PB2 
	XRESET	PB1
	DREQ	PB0
	xDCS	PB6
*/


/*
0̏ꍇ평
*/
UB vs1011e_init(void){

	UH vol = 0x4040;

	vs1011e_accessInit();

	vs1011e_setVolume(vol);		// volume ݒ
	if( vs1011e_getVolume() != vol ){
		syslog(LOG_NOTICE, "VS1011e: Can't set volume = 0x%x (0x%x)", vol, vs1011e_getVolume());
		return 1;
	}else{
		syslog(LOG_NOTICE, "VS1011e: Set volume = %x", vol);
	}

	return 0;
}
