#ifndef _VS1011E_IO_H_
#define _VS1011E_IO_H_

/*
---------------------------------------
dir	vs1011e	H8		
---------------------------------------
OUT	SO	PB7(RxD2)	CN1-40
IN	SI	PB6(TxD2)	CN1-39
IN	SCLK	PB5(SCK2)	CN1-38
OUT	DREQ	PB0		CN1-33
IN	NXCS	PA7		CN1-32
IN	NXDCS	PA6		CN1-31
IN	NXRESET	PA5		CN1-30
---------------------------------------
*/

#define VS1011E_BIT_RVOUT	7	// SO     : PB7(RxD2)
#define VS1011E_BIT_VIN		6	// SI     : PB6(TxD2)
#define VS1011E_BIT_CLK		5	// SCLK   : PB5(SCK2)
#define VS1011E_BIT_DREQ	0	// DREQ   : PB0

#define VS1011E_BIT_nCS		7	// NXCS   : PA7
#define VS1011E_BIT_nDCS	6	// NXDCS  : PA6
#define VS1011E_BIT_nRESET	5	// NXRESET: PA5


#define VS1011E_RVOUT		(1<<VS1011E_BIT_RVOUT)
#define VS1011E_VIN		(1<<VS1011E_BIT_VIN)
#define VS1011E_CLK		(1<<VS1011E_BIT_CLK)
#define VS1011E_DREQ		(1<<VS1011E_BIT_DREQ)

#define VS1011E_nCS		(1<<VS1011E_BIT_nCS)
#define VS1011E_nDCS		(1<<VS1011E_BIT_nDCS)
#define VS1011E_nRESET		(1<<VS1011E_BIT_nRESET)

#define VS1011E_STAT_DREQ	(PBDR.BYTE & VS1011E_DREQ)

#define VS1011E_ENABLE_CS	(PADR.BYTE &= (0xff - VS1011E_nCS))
#define VS1011E_DISABLE_CS	(PADR.BYTE |= VS1011E_nCS)

#define VS1011E_ENABLE_DCS	(PADR.BYTE &= (0xff - VS1011E_nDCS))
#define VS1011E_DISABLE_DCS	(PADR.BYTE |= VS1011E_nDCS)

#define VS1011E_ENABLE_RESET	(PADR.BYTE &= (0xff - VS1011E_nRESET))
#define VS1011E_DISABLE_RESET	(PADR.BYTE |= VS1011E_nRESET)



#ifndef _MACRO_ONLY


#endif	/* of #ifndef _MACRO_ONLY */

#endif	/* of #ifndef _VS1011E_IO_H_ */

