#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"
#include <time.h>
#include <string.h>
#include <stdio.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>
#include <netinet/tcp.h>

#include "tinet_app_config.h"
#include "webserver.h"
#include "fat_api.h"
#include "mmc_access.h"
#include "ntp.h"
#include "parse.h"
//#include "coffload.h"
#include "3069S.h"
#include "util.h"
#include "exec.h"
#include "na2.h"

#define TIMEZONE	(-9*60*60)		// GMT ÿ

#define HTTP_DOC_ROOT      "/http"			// Web ХɥȤΥ롼ȥǥ쥯ȥ
#define HTTP_DOC_ROOT_LEN  (strlen(HTTP_DOC_ROOT))	// Web ХɥȤΥ롼ȥǥ쥯ȥʸĹ


/*
 *  ؿ
 */

extern const char *itron_strerror (ER ercd);


/*
 *  !!
 *  BUF_SIZE  TCP 
 *  ɥХåե + ɥХåե
 *  礭ʤСǥåɥåǽ롣
 */

/*
 *  TCP Хåե
 */


UB tcp_wwwd_cep_sbuf[N_WWW_TASK][TCP_WWWD_CEP_SBUF_SIZE];
UB tcp_wwwd_cep_rbuf[N_WWW_TASK][TCP_WWWD_CEP_RBUF_SIZE];


/*
-------------------------------------------------------------------------
Web Server


-------------------------------------------------------------------------
*/

#define RES_SVRHEADER	     "Server: Network Appliance Web Server (running on H8/3069 with ITRON)\r\n"

static const char res_hdr200[] =
     "HTTP/1.0 200 OK\r\n"
     RES_SVRHEADER
     "Content-Type: %s\r\n"
     "Content-Length: %d\r\n"
     "Connection: close\r\n"
     "\r\n";

static const char res_hdr200_cgi[] =
     "HTTP/1.0 200 OK\r\n"
     RES_SVRHEADER
     "Connection: close\r\n";


static const char res_hdr401[] =
     "HTTP/1.1 401 Authorization Required\r\n"
     RES_SVRHEADER
     "Content-Type: text/html\r\n"
     "Content-Length: %d\r\n"
     "Connection: close\r\n"
     "WWW-Authenticate: Basic realm=\"member only\""
     "\r\n";

static const char res_bdy401[] =
     "<HTML><HEAD><TITLE>401 Authorization Required</TITLE></HEAD>\r\n"
     "<BODY><H1>Authorization Required</H1></BODY></HTML>\r\n";

static const char res_hdr404[] =
     "HTTP/1.0 404 OK\r\n"
     RES_SVRHEADER
     "Content-Type: text/html\r\n"
     "Content-Length: %d\r\n"
     "Connection: close\r\n"
     "\r\n";

static const char res_bdy404[] =
     "file not found";

static const char res_bdyAccess_head[] =
	"<HTML><HEAD><TITLE>Access Log</TITLE></HEAD><BODY bgcolor=\"#FFEEAA\">"
	"<H1></H1><br><hr>";
static const char res_bdyAccess_tail[] =
	"<hr></BODY></HTML>";


#define WWW_BUF_SIZE	256



/*
ե̾Ϳȡ
ĥҤĴ١бMIMEפ֤

ΤϿƤʤˤϡ
text/html֤롣


:
	file : MIMEפĴ٤ե̾
	type : եΥפǼ
		1 : ̾Υե
		2 : ե
		3 : ¹Բǽե


: MIMEʸ
        Web ФǸʤĥҤä硢
	NULLݥ󥿤ˤʤ
*/
char *file2mime(char *file, char *type){
	char suffix[10];
	B i;

	char *p;
	char *mime[] = {
		"html"	, "text/html",	            (char *)1,	// Default(褯ʬʤϤǤ)
		"htm"	, "text/html",              (char *)1,
		"css"	, "text/css",               (char *)1,
		"jpg"	, "image/jpeg",             (char *)1,
		"jpeg"	, "image/jpeg",             (char *)1,
		"png"	, "image/png",              (char *)1,
		"svg"	, "image/svg-xml",          (char *)1,
		"txt"	, "text/plain",             (char *)1,
		"log"	, "text/plain",             (char *)1,
		"mp3"	, "audio/mp3",              (char *)1,
		"z"	, "application/x-compress", (char *)1,
		"gz"	, "application/x-compress", (char *)1,
		"tgz"	, "application/x-compress", (char *)1,
		"taz"	, "application/x-compress", (char *)1,
		"tar"	, "application/x-compress", (char *)1,
		"lha"	, "application/x-compress", (char *)1,
		"zip"	, "application/x-compress", (char *)1,
		"cfg"	, NULL,                     (char *)2,	// .cfg Υեϸʤ
		"exe"	, NULL,                     (char *)3,	// .exe Υեϸʤ
		"cgi"	, NULL,                     (char *)3,	// .cgi Υեϸʤ
		"" 				// ʼ
	};

	// Ǹ '.' иսõ
	p = strrchr(file, '.');

	// '.'ĤʤˤϥǥեȤư
	if( p == NULL ){
		*type = (char)(mime[2]);
		return  mime[1];
	}

	// եåʸѴ
	for(i=0, p++; i < sizeof(suffix)-1 && ((*p) !='\0'); i++, p++)
		suffix[i] = (*p >= 'A') && (*p <= 'Z') ? (*p - 'A' + 'a') : (*p);
	suffix[i] = '\0';


	// õ (ǸǤʼ򸫤ĤФޤ)
	for(i = 0; '\0' != *(mime[i]) ; i+=3){
		if( ! strcmp(mime[i], suffix) ){
			
			*type = (char)(mime[i+2]);
			return  mime[i+1];
		}
	}
	
	*type = (char)(mime[2]);
	return  mime[1];
}

#define HTTP_REQUEST_GET	1
#define HTTP_REQUEST_PUT	2
/*


fname_max : ե̾ѤѰդХåե ( = sizeof(file) )
*/
B parseHTTPRequest(char *file, char *auth, unsigned char *data, int recv, int fname_max, int auth_max){
	UH i=1, j, len;
	B state = -1;
	
	
	if(auth != NULL) auth[0]='\0';
	
	
	
	if(! strncmp("GET ", data, 4) ){
		for(i=3; data[i]==' '; i++) ;
	
		j = 0;
		for( ; data[i]!=' ' && data[i]!='\n' && data[i]!='\r'; i++){
			if( j < fname_max - 1 ){
				file[j++] = data[i];
			}
		}
		file[j] = '\0';

		state = HTTP_REQUEST_GET;
	}
	for(i=1 ; i<recv; i++){
		if( data[i-1] != '\n' ) continue;

		if( auth!=NULL && ! strncmp("Authorization:", data+i, (len = strlen("Authorization:"))) ){
			i += len;

			for( ; data[i]==' '; i++) ;
			
			for( ; data[i]!=' ' && data[i]!='\n' && data[i]!='\r'; i++) ;	// BasicǧڤǤ뤳ȤꤵƤʬ

			for( ; data[i]==' '; i++) ;

			j = 0;
			for( ; data[i]!=' ' && data[i]!='\n' && data[i]!='\r'; i++){
				if( j < auth_max - 1 ){
					auth[j++] = data[i];
				}
			}
			auth[j] = '\0';
		}
	}
	
	if( data[recv-4]!='\r' || data[recv-3]!='\n' || data[recv-2]!='\r' || data[recv-1]!='\n' ){
		return -1;
	}

	return state;
}


//Ѵơ֥
const char B64tbl[] ="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

#define  B64VAL(i)  ( i == '=' ? 0 : strchr(B64tbl, i) - B64tbl )


/*
Base64 ǥ
*/
void decodeBase64(UB *buf){

	UH j=0;
	UH l = strlen(buf);
	UH i;
	UB d1,d2,d3,d4;

	//4ХȤĽ
	for (i=0; i < l; i+=4){
		d1 = buf[i];
		d2 = buf[i+1];
		d3 = buf[i+2];
		d4 = buf[i+3];

		buf[j++] =(UB)( (B64VAL(d1) << 2) | ((B64VAL(d2) & 0x30) >> 4));
		buf[j++] =(UB)( ((B64VAL(d2) & 0x0f) << 4) | ((B64VAL(d3) & 0x3c) >> 2));
		buf[j++] =(UB)( ((B64VAL(d3) & 0x03) << 6) | ( B64VAL(d4) & 0x3f));
	}
	buf[j] = '\0';
}

/*
ԤȤ0
*/
B authenticate(char *fname, char *auth, UB *buf){
	UH i;
	H  lstsla;
	B fd, res;

	lstsla = -1;
	for(i=0; fname[i] != '\0'; i++){
		if(fname[i] == '/') lstsla=i;
		buf[i] = fname[i];
	}
	if( lstsla < 0 ) return 0;

	buf[++lstsla]='h';
	buf[++lstsla]='t';
	buf[++lstsla]='a';
	buf[++lstsla]='c';
	buf[++lstsla]='c';
	buf[++lstsla]='e';
	buf[++lstsla]='s';
	buf[++lstsla]='s';
	buf[++lstsla]='\0';


	if( (fd = open(buf, O_RDONLY)) < 0 ) return 1;
	
	decodeBase64(auth);
	
	res = checkHTTPAuthentication(fd, auth);
	
	close(fd);
	
	return (0==res);
}

/*

"/../" ޤ
"/" ǻϤޤʤGet׵ᤫɤĴ٤

*/
B checkGetAccess(char *fname){
	
	if( fname[0] != '/' ) return 0;
	
	if( strstr(fname, "..")!=NULL ) return 0;
	
	return 1;
}

void
tcp_www_task(VP_INT exinf)
{
	char fname[512];
	char auth[256];
	unsigned char buf[1536];
	UW coff_buf[1280];
	UB addr[sizeof("123.123.123.123")];

	T_IPV4EP dst;
	W	rlen;  // i
	ID	tskid;
	ER	error = E_OK;
	UW	size;
	B	fd, req;
	char	*mime, type, *cgidata, *p;
	UH	length;


	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP WWW:%d,%d] started.", tskid, (INT)exinf);



	while (TRUE) {
		if (tcp_acp_cep((INT)exinf, TCP_WWWD_REPID, &dst, TMO_FEVR) != E_OK) {
			syslog(LOG_NOTICE, "[TCP WWW ACP] error: %s", itron_strerror(error));
			continue;
		}

		ip2str(addr, &dst.ipaddr);
		syslog(LOG_NOTICE, "[TCP WWW ACP] connected from %s:%d", addr, dst.portno);


		length = 0;
		do{
			rlen = tcp_rcv_dat((INT)exinf, buf+length, sizeof(buf) - 1 - length, 5000);
			if( rlen <= 0 ){
				if (rlen != E_OK)
					syslog(LOG_NOTICE, "[TCP WWW RCV] error: %s", itron_strerror(rlen));
				goto err_fin;
			}
			buf[length+rlen]='\0'; p = strrchr( buf, '\n' );
			length += rlen;
		}while(p==NULL || (*(p-1)!='\n' && *(p-2)!='\n') );		// "\r\n\r\n" or "\n\n" ɤǧ


		// إåβ
		memcpy(fname, HTTP_DOC_ROOT, HTTP_DOC_ROOT_LEN+1);
		if( (req = parseHTTPRequest(
		                fname + HTTP_DOC_ROOT_LEN,		// GETǤоʸγǼ
		                auth,					// AuthenticationʸγǼ
		                buf,					// ǡ
		                length,					// ǡΥ
		                sizeof(fname) - HTTP_DOC_ROOT_LEN,	// GETǤоʸγǼХåե
		                sizeof(auth))				// AuthenticationʸγǼХåե
		    ) < 0 ) continue;

		if( req != HTTP_REQUEST_GET ) goto err_fin;

		sprintf(buf,"WWW Access from %s, file %s\n", addr, fname + HTTP_DOC_ROOT_LEN);
		systemlog(buf);

		// Get׵Ϥǥåȥ
		if( req == HTTP_REQUEST_GET ){
			if(NULL != (cgidata=strchr(fname, '?'))) *cgidata++ = '\0';	// ե̾ʬCGIΰʬ
			if(! checkGetAccess(fname+HTTP_DOC_ROOT_LEN) ) goto err_fin;
		}else{
			goto err_fin;
		}


		if(! authenticate(fname, auth, buf) ){
			syslog(LOG_NOTICE, "WWW Access from %s, auth failed: %s\n", addr, auth);
			sprintf(buf,"WWW Access from %s, auth failed\n", addr);
			systemlog(buf);

			sprintf(buf, res_hdr401, (int)strlen(res_bdy401));

			send_data((ID)exinf,              buf, strlen(buf));
			send_data((ID)exinf, (UB *)res_bdy401, strlen(res_bdy401) );

		}else if( ((mime = file2mime(fname, &type)) != NULL) && ((fd = open(fname, O_RDONLY)) >= 0) ){
			size = lseek(fd, 0, SEEK_END);	// ե륵μ
			lseek(fd, 0, SEEK_SET);

			sprintf(buf, res_hdr200, mime, size);	// HTTPإå

			send_data((ID)exinf, buf, strlen(buf));
			do{
				if( (size = read(fd, buf, 512)) < 0 ){ break; }
				if( 0 == send_data((ID)exinf,  buf, size )){ break; }
			}while(size != 0);
			close(fd);
		}else if( type==3 ){
			char* argv[3];
			struct program_io pio;
			W res;

			send_data((ID)exinf, res_hdr200_cgi, strlen(res_hdr200_cgi));	// HTTPΥإåƬʬ(HTTP 200 OK...)

			argv[0] = fname;				// 0 : fname
			argv[1] = (cgidata==NULL) ? "" : cgidata;	//     1 : (̤ǥ)
			argv[2] = NULL;

			// ɸ, ɸ: ³  / ɸ२顼: ꥢ
			pio.io_mux_in = pio.io_mux_out = EXEC_IO_NETWORK;
			pio.std_in    = pio.std_out    = (ID)exinf;
			pio.io_mux_err= EXEC_IO_SERIAL;
			pio.std_err   = 0;
			
			if( exec(fname, (UB *)coff_buf, sizeof(coff_buf), &pio, (argv[1]==NULL) ? 1 : 2, argv, &res) < 0 ){
				char *cgi_fail = "Content-Type: text/html\r\n\r\nCan't Execute";

				send_data((ID)exinf, cgi_fail, strlen(cgi_fail));
			}
		}else{
			sprintf(buf, res_hdr404, (int)strlen(res_bdy404));

			send_data((ID)exinf,              buf, strlen(buf));
			send_data((ID)exinf, (UB *)res_bdy404, strlen(res_bdy404) );
		}

	err_fin:
		if ((error = tcp_sht_cep((ID)exinf)) != E_OK)
			syslog(LOG_NOTICE, "[TCP WWW SHT] error: %s", itron_strerror(error));

		if ((error = tcp_cls_cep((ID)exinf, TMO_FEVR)) != E_OK)
			syslog(LOG_NOTICE, "[TCP WWW CLS] error: %s", itron_strerror(error));
	}
}


